package system
{
	import system.globalization.Calendar;
	import system.globalization.DateTimeStyles;
	import system._Array_;
	import as3runtime.RefOutStore;


		/**
		* Struct
		*  System.DateTime
		*/
	[struct]
	[link_system]
	public final class DateTime extends _Object_ implements IComparable,IFormattable,IConvertible
	{
		[creator];
		[native,system_DateTime_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,system_DateTime_constructor_];
		public static function constructor_(ticks:Int64,kind:DateTimeKind):DateTime;

		[native,system_DateTime_constructor__];
		public static function constructor__(year:int,month:int,day:int):DateTime;

		[native,system_DateTime_constructor___];
		public static function constructor___(year:int,month:int,day:int,calendar:system.globalization.Calendar):DateTime;

		[native,system_DateTime_constructor____];
		public static function constructor____(year:int,month:int,day:int,hour:int,minute:int,second:int):DateTime;

		[native,system_DateTime_constructor_____];
		public static function constructor_____(year:int,month:int,day:int,hour:int,minute:int,second:int,kind:DateTimeKind):DateTime;

		[native,system_DateTime_constructor______];
		public static function constructor______(year:int,month:int,day:int,hour:int,minute:int,second:int,calendar:system.globalization.Calendar):DateTime;

		[native,system_DateTime_constructor_______];
		public static function constructor_______(year:int,month:int,day:int,hour:int,minute:int,second:int,millisecond:int):DateTime;

		[native,system_DateTime_constructor________];
		public static function constructor________(year:int,month:int,day:int,hour:int,minute:int,second:int,millisecond:int,kind:DateTimeKind):DateTime;

		[native,system_DateTime_constructor_________];
		public static function constructor_________(year:int,month:int,day:int,hour:int,minute:int,second:int,millisecond:int,calendar:system.globalization.Calendar):DateTime;

		[native,system_DateTime_constructor__________];
		public static function constructor__________(year:int,month:int,day:int,hour:int,minute:int,second:int,millisecond:int,calendar:system.globalization.Calendar,kind:DateTimeKind):DateTime;

		[native,system_DateTime_ctor];
		public function DateTime(ticks:Int64);


		//*********字段*******
		/**
		* System.DateTime.MinValue
		*fieldtype:
		*   System.DateTime
		*/
		[native, system_DateTime_MinValue_getter];
		public static const MinValue:DateTime;
		/**
		* System.DateTime.MaxValue
		*fieldtype:
		*   System.DateTime
		*/
		[native, system_DateTime_MaxValue_getter];
		public static const MaxValue:DateTime;

		//*********公共方法*******
		/**
		* System.DateTime.Add
		*parameters:
		*  value : System.TimeSpan
		*return:
		*   System.DateTime
		*/
		[native,system_DateTime_add];
		public final function add(value:TimeSpan):DateTime;

		/**
		* System.DateTime.AddDays
		*parameters:
		*  value : System.Double
		*return:
		*   System.DateTime
		*/
		[native,system_DateTime_addDays];
		public final function addDays(value:Number):DateTime;

		/**
		* System.DateTime.AddHours
		*parameters:
		*  value : System.Double
		*return:
		*   System.DateTime
		*/
		[native,system_DateTime_addHours];
		public final function addHours(value:Number):DateTime;

		/**
		* System.DateTime.AddMilliseconds
		*parameters:
		*  value : System.Double
		*return:
		*   System.DateTime
		*/
		[native,system_DateTime_addMilliseconds];
		public final function addMilliseconds(value:Number):DateTime;

		/**
		* System.DateTime.AddMinutes
		*parameters:
		*  value : System.Double
		*return:
		*   System.DateTime
		*/
		[native,system_DateTime_addMinutes];
		public final function addMinutes(value:Number):DateTime;

		/**
		* System.DateTime.AddMonths
		*parameters:
		*  months : System.Int32
		*return:
		*   System.DateTime
		*/
		[native,system_DateTime_addMonths];
		public final function addMonths(months:int):DateTime;

		/**
		* System.DateTime.AddSeconds
		*parameters:
		*  value : System.Double
		*return:
		*   System.DateTime
		*/
		[native,system_DateTime_addSeconds];
		public final function addSeconds(value:Number):DateTime;

		/**
		* System.DateTime.AddTicks
		*parameters:
		*  value : System.Int64
		*return:
		*   System.DateTime
		*/
		[native,system_DateTime_addTicks];
		public final function addTicks(value:Int64):DateTime;

		/**
		* System.DateTime.AddYears
		*parameters:
		*  value : System.Int32
		*return:
		*   System.DateTime
		*/
		[native,system_DateTime_addYears];
		public final function addYears(value:int):DateTime;

		/**
		* System.DateTime.Compare
		*parameters:
		*  t1 : System.DateTime
		*  t2 : System.DateTime
		*return:
		*   System.Int32
		*/
		[native,static_system_DateTime_compare];
		public static function compare(t1:DateTime,t2:DateTime):int;

		[native,system_IComparable_compareTo];
		public final function compareTo(value:_Object_):int;

		/**
		* System.DateTime.CompareTo
		*parameters:
		*  value : System.DateTime
		*return:
		*   System.Int32
		*/
		[native,system_DateTime_compareTo_];
		public final function compareTo_(value:DateTime):int;

		/**
		* System.DateTime.DaysInMonth
		*parameters:
		*  year : System.Int32
		*  month : System.Int32
		*return:
		*   System.Int32
		*/
		[native,static_system_DateTime_daysInMonth];
		public static function daysInMonth(year:int,month:int):int;

		/**
		* System.DateTime.Equals
		*parameters:
		*  value : System.DateTime
		*return:
		*   System.Boolean
		*/
		[native,system_DateTime_equals___];
		public final function equals___(value:DateTime):Boolean;

		/**
		* System.DateTime.Equals
		*parameters:
		*  t1 : System.DateTime
		*  t2 : System.DateTime
		*return:
		*   System.Boolean
		*/
		[native,static_system_DateTime_equals];
		public static function equals(t1:DateTime,t2:DateTime):Boolean;

		/**
		* System.DateTime.FromBinary
		*parameters:
		*  dateData : System.Int64
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_fromBinary];
		public static function fromBinary(dateData:Int64):DateTime;

		/**
		* System.DateTime.FromFileTime
		*parameters:
		*  fileTime : System.Int64
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_fromFileTime];
		public static function fromFileTime(fileTime:Int64):DateTime;

		/**
		* System.DateTime.FromFileTimeUtc
		*parameters:
		*  fileTime : System.Int64
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_fromFileTimeUtc];
		public static function fromFileTimeUtc(fileTime:Int64):DateTime;

		/**
		* System.DateTime.FromOADate
		*parameters:
		*  d : System.Double
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_fromOADate];
		public static function fromOADate(d:Number):DateTime;

		/**
		* System.DateTime.IsDaylightSavingTime
		*return:
		*   System.Boolean
		*/
		[native,system_DateTime_isDaylightSavingTime];
		public final function isDaylightSavingTime():Boolean;

		/**
		* System.DateTime.SpecifyKind
		*parameters:
		*  value : System.DateTime
		*  kind : System.DateTimeKind
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_specifyKind];
		public static function specifyKind(value:DateTime,kind:DateTimeKind):DateTime;

		/**
		* System.DateTime.ToBinary
		*return:
		*   System.Int64
		*/
		[native,system_DateTime_toBinary];
		public final function toBinary():Int64;

		/**
		* System.DateTime.get_Date
		*return:
		*   System.DateTime
		*/
		[native,system_DateTime_get_Date]
		public final function get date():DateTime;

		/**
		* System.DateTime.get_Day
		*return:
		*   System.Int32
		*/
		[native,system_DateTime_get_Day]
		public final function get day():int;

		/**
		* System.DateTime.get_DayOfWeek
		*return:
		*   System.DayOfWeek
		*/
		[native,system_DateTime_get_DayOfWeek]
		public final function get dayOfWeek():DayOfWeek;

		/**
		* System.DateTime.get_DayOfYear
		*return:
		*   System.Int32
		*/
		[native,system_DateTime_get_DayOfYear]
		public final function get dayOfYear():int;

		/**
		* System.DateTime.get_Hour
		*return:
		*   System.Int32
		*/
		[native,system_DateTime_get_Hour]
		public final function get hour():int;

		/**
		* System.DateTime.get_Kind
		*return:
		*   System.DateTimeKind
		*/
		[native,system_DateTime_get_Kind]
		public final function get kind():DateTimeKind;

		/**
		* System.DateTime.get_Millisecond
		*return:
		*   System.Int32
		*/
		[native,system_DateTime_get_Millisecond]
		public final function get millisecond():int;

		/**
		* System.DateTime.get_Minute
		*return:
		*   System.Int32
		*/
		[native,system_DateTime_get_Minute]
		public final function get minute():int;

		/**
		* System.DateTime.get_Month
		*return:
		*   System.Int32
		*/
		[native,system_DateTime_get_Month]
		public final function get month():int;

		/**
		* System.DateTime.get_Now
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_get_Now]
		public static function get now():DateTime;

		/**
		* System.DateTime.get_UtcNow
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_get_UtcNow]
		public static function get utcNow():DateTime;

		/**
		* System.DateTime.get_Second
		*return:
		*   System.Int32
		*/
		[native,system_DateTime_get_Second]
		public final function get second():int;

		/**
		* System.DateTime.get_Ticks
		*return:
		*   System.Int64
		*/
		[native,system_DateTime_get_Ticks]
		public final function get ticks():Int64;

		/**
		* System.DateTime.get_TimeOfDay
		*return:
		*   System.TimeSpan
		*/
		[native,system_DateTime_get_TimeOfDay]
		public final function get timeOfDay():TimeSpan;

		/**
		* System.DateTime.get_Today
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_get_Today]
		public static function get today():DateTime;

		/**
		* System.DateTime.get_Year
		*return:
		*   System.Int32
		*/
		[native,system_DateTime_get_Year]
		public final function get year():int;

		/**
		* System.DateTime.IsLeapYear
		*parameters:
		*  year : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,static_system_DateTime_isLeapYear];
		public static function isLeapYear(year:int):Boolean;

		/**
		* System.DateTime.Parse
		*parameters:
		*  s : System.String
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_parse];
		public static function parse(s:String):DateTime;

		/**
		* System.DateTime.Parse
		*parameters:
		*  s : System.String
		*  provider : System.IFormatProvider
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_parse_];
		public static function parse_(s:String,provider:IFormatProvider):DateTime;

		/**
		* System.DateTime.Parse
		*parameters:
		*  s : System.String
		*  provider : System.IFormatProvider
		*  styles : System.Globalization.DateTimeStyles
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_parse__];
		public static function parse__(s:String,provider:IFormatProvider,styles:system.globalization.DateTimeStyles):DateTime;

		/**
		* System.DateTime.ParseExact
		*parameters:
		*  s : System.String
		*  format : System.String
		*  provider : System.IFormatProvider
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_parseExact];
		public static function parseExact(s:String,format:String,provider:IFormatProvider):DateTime;

		/**
		* System.DateTime.ParseExact
		*parameters:
		*  s : System.String
		*  format : System.String
		*  provider : System.IFormatProvider
		*  style : System.Globalization.DateTimeStyles
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_parseExact_];
		public static function parseExact_(s:String,format:String,provider:IFormatProvider,style:system.globalization.DateTimeStyles):DateTime;

		/**
		* System.DateTime.ParseExact
		*parameters:
		*  s : System.String
		*  formats : System.String[]
		*  provider : System.IFormatProvider
		*  style : System.Globalization.DateTimeStyles
		*return:
		*   System.DateTime
		*/
		[native,static_system_DateTime_parseExact__];
		public static function parseExact__(s:String,formats:_Array_,provider:IFormatProvider,style:system.globalization.DateTimeStyles):DateTime;

		/**
		* System.DateTime.Subtract
		*parameters:
		*  value : System.DateTime
		*return:
		*   System.TimeSpan
		*/
		[native,system_DateTime_subtract];
		public final function subtract(value:DateTime):TimeSpan;

		/**
		* System.DateTime.Subtract
		*parameters:
		*  value : System.TimeSpan
		*return:
		*   System.DateTime
		*/
		[native,system_DateTime_subtract_];
		public final function subtract_(value:TimeSpan):DateTime;

		/**
		* System.DateTime.ToOADate
		*return:
		*   System.Double
		*/
		[native,system_DateTime_toOADate];
		public final function toOADate():Number;

		/**
		* System.DateTime.ToFileTime
		*return:
		*   System.Int64
		*/
		[native,system_DateTime_toFileTime];
		public final function toFileTime():Int64;

		/**
		* System.DateTime.ToFileTimeUtc
		*return:
		*   System.Int64
		*/
		[native,system_DateTime_toFileTimeUtc];
		public final function toFileTimeUtc():Int64;

		/**
		* System.DateTime.ToLocalTime
		*return:
		*   System.DateTime
		*/
		[native,system_DateTime_toLocalTime];
		public final function toLocalTime():DateTime;

		/**
		* System.DateTime.ToLongDateString
		*return:
		*   System.String
		*/
		[native,system_DateTime_toLongDateString];
		public final function toLongDateString():String;

		/**
		* System.DateTime.ToLongTimeString
		*return:
		*   System.String
		*/
		[native,system_DateTime_toLongTimeString];
		public final function toLongTimeString():String;

		/**
		* System.DateTime.ToShortDateString
		*return:
		*   System.String
		*/
		[native,system_DateTime_toShortDateString];
		public final function toShortDateString():String;

		/**
		* System.DateTime.ToShortTimeString
		*return:
		*   System.String
		*/
		[native,system_DateTime_toShortTimeString];
		public final function toShortTimeString():String;

		/**
		* System.DateTime.ToString
		*parameters:
		*  format : System.String
		*return:
		*   System.String
		*/
		[native,system_DateTime_toString___];
		public final function toString___(format:String):String;

		[native,system_IConvertible_toString];
		public final function toString____(provider:IFormatProvider):String;

		[native,system_IFormattable_toString];
		public final function toString_____(format:String,provider:IFormatProvider):String;

		/**
		* System.DateTime.ToUniversalTime
		*return:
		*   System.DateTime
		*/
		[native,system_DateTime_toUniversalTime];
		public final function toUniversalTime():DateTime;

		/**
		* System.DateTime.TryParse
		*parameters:
		*  s : System.String
		*  result : (Out)System.DateTime
		*return:
		*   System.Boolean
		*/
		[native,static_system_DateTime_tryParse];
		public static function tryParse(s:String,result:DateTime,refout:as3runtime.RefOutStore):Boolean;

		/**
		* System.DateTime.TryParse
		*parameters:
		*  s : System.String
		*  provider : System.IFormatProvider
		*  styles : System.Globalization.DateTimeStyles
		*  result : (Out)System.DateTime
		*return:
		*   System.Boolean
		*/
		[native,static_system_DateTime_tryParse_];
		public static function tryParse_(s:String,provider:IFormatProvider,styles:system.globalization.DateTimeStyles,result:DateTime,refout:as3runtime.RefOutStore):Boolean;

		/**
		* System.DateTime.TryParseExact
		*parameters:
		*  s : System.String
		*  format : System.String
		*  provider : System.IFormatProvider
		*  style : System.Globalization.DateTimeStyles
		*  result : (Out)System.DateTime
		*return:
		*   System.Boolean
		*/
		[native,static_system_DateTime_tryParseExact];
		public static function tryParseExact(s:String,format:String,provider:IFormatProvider,style:system.globalization.DateTimeStyles,result:DateTime,refout:as3runtime.RefOutStore):Boolean;

		/**
		* System.DateTime.TryParseExact
		*parameters:
		*  s : System.String
		*  formats : System.String[]
		*  provider : System.IFormatProvider
		*  style : System.Globalization.DateTimeStyles
		*  result : (Out)System.DateTime
		*return:
		*   System.Boolean
		*/
		[native,static_system_DateTime_tryParseExact_];
		public static function tryParseExact_(s:String,formats:_Array_,provider:IFormatProvider,style:system.globalization.DateTimeStyles,result:DateTime,refout:as3runtime.RefOutStore):Boolean;

		/**
		* System.DateTime.GetDateTimeFormats
		*return:
		*   System.String[]
		*/
		[native,system_DateTime_getDateTimeFormats];
		public final function getDateTimeFormats():_Array_;

		/**
		* System.DateTime.GetDateTimeFormats
		*parameters:
		*  provider : System.IFormatProvider
		*return:
		*   System.String[]
		*/
		[native,system_DateTime_getDateTimeFormats_];
		public final function getDateTimeFormats_(provider:IFormatProvider):_Array_;

		/**
		* System.DateTime.GetDateTimeFormats
		*parameters:
		*  format : System.Char
		*return:
		*   System.String[]
		*/
		[native,system_DateTime_getDateTimeFormats__];
		public final function getDateTimeFormats__(format:Char):_Array_;

		/**
		* System.DateTime.GetDateTimeFormats
		*parameters:
		*  format : System.Char
		*  provider : System.IFormatProvider
		*return:
		*   System.String[]
		*/
		[native,system_DateTime_getDateTimeFormats___];
		public final function getDateTimeFormats___(format:Char,provider:IFormatProvider):_Array_;

		[native,system_IConvertible_getTypeCode];
		public final function getTypeCode():TypeCode;


		//*****操作重载*****
		/**
		 * 计算 d + t
		 */
		[native,static_system_DateTime_op_Addition];
		public static function op_Addition(d:DateTime,t:TimeSpan):DateTime;

		[operator,"+"];
		[native,static_system_DateTime_op_Addition];
		private static function _operator_op_Addition(d:DateTime,t:TimeSpan):DateTime;

		/**
		 * 计算 d - t
		 */
		[native,static_system_DateTime_op_Subtraction];
		public static function op_Subtraction(d:DateTime,t:TimeSpan):DateTime;

		[operator,"-"];
		[native,static_system_DateTime_op_Subtraction];
		private static function _operator_op_Subtraction(d:DateTime,t:TimeSpan):DateTime;

		/**
		 * 计算 d1 - d2
		 */
		[native,static_system_DateTime_op_Subtraction_];
		public static function op_Subtraction_(d1:DateTime,d2:DateTime):TimeSpan;

		[operator,"-"];
		[native,static_system_DateTime_op_Subtraction_];
		private static function _operator_op_Subtraction_(d1:DateTime,d2:DateTime):TimeSpan;

		/**
		 * 计算 d1 == d2
		 */
		[native,static_system_DateTime_op_Equality];
		public static function op_Equality(d1:DateTime,d2:DateTime):Boolean;

		[operator,"=="];
		[native,static_system_DateTime_op_Equality];
		private static function _operator_op_Equality(d1:DateTime,d2:DateTime):Boolean;

		/**
		 * 计算 d1 != d2
		 */
		[native,static_system_DateTime_op_Inequality];
		public static function op_Inequality(d1:DateTime,d2:DateTime):Boolean;

		[operator,"!="];
		[native,static_system_DateTime_op_Inequality];
		private static function _operator_op_Inequality(d1:DateTime,d2:DateTime):Boolean;

		/**
		 * 计算 t1 &lt; t2
		 */
		[native,static_system_DateTime_op_LessThan];
		public static function op_LessThan(t1:DateTime,t2:DateTime):Boolean;

		[operator,"<"];
		[native,static_system_DateTime_op_LessThan];
		private static function _operator_op_LessThan(t1:DateTime,t2:DateTime):Boolean;

		/**
		 * 计算 t1 &lt;= t2
		 */
		[native,static_system_DateTime_op_LessThanOrEqual];
		public static function op_LessThanOrEqual(t1:DateTime,t2:DateTime):Boolean;

		[operator,"<="];
		[native,static_system_DateTime_op_LessThanOrEqual];
		private static function _operator_op_LessThanOrEqual(t1:DateTime,t2:DateTime):Boolean;

		/**
		 * 计算 t1 &gt; t2
		 */
		[native,static_system_DateTime_op_GreaterThan];
		public static function op_GreaterThan(t1:DateTime,t2:DateTime):Boolean;

		[operator,">"];
		[native,static_system_DateTime_op_GreaterThan];
		private static function _operator_op_GreaterThan(t1:DateTime,t2:DateTime):Boolean;

		/**
		 * 计算 t1 &gt;= t2
		 */
		[native,static_system_DateTime_op_GreaterThanOrEqual];
		public static function op_GreaterThanOrEqual(t1:DateTime,t2:DateTime):Boolean;

		[operator,">="];
		[native,static_system_DateTime_op_GreaterThanOrEqual];
		private static function _operator_op_GreaterThanOrEqual(t1:DateTime,t2:DateTime):Boolean;


		//*****显式接口实现*****
		[native,system_IConvertible_toBoolean];
		private function system_IConvertible_ToBoolean(provider:IFormatProvider):Boolean;

		[native,system_IConvertible_toChar];
		private function system_IConvertible_ToChar(provider:IFormatProvider):Char;

		[native,system_IConvertible_toSByte];
		private function system_IConvertible_ToSByte(provider:IFormatProvider):SByte;

		[native,system_IConvertible_toByte];
		private function system_IConvertible_ToByte(provider:IFormatProvider):Byte;

		[native,system_IConvertible_toInt16];
		private function system_IConvertible_ToInt16(provider:IFormatProvider):int;

		[native,system_IConvertible_toUInt16];
		private function system_IConvertible_ToUInt16(provider:IFormatProvider):uint;

		[native,system_IConvertible_toInt32];
		private function system_IConvertible_ToInt32(provider:IFormatProvider):int;

		[native,system_IConvertible_toUInt32];
		private function system_IConvertible_ToUInt32(provider:IFormatProvider):uint;

		[native,system_IConvertible_toInt64];
		private function system_IConvertible_ToInt64(provider:IFormatProvider):Int64;

		[native,system_IConvertible_toUInt64];
		private function system_IConvertible_ToUInt64(provider:IFormatProvider):UInt64;

		[native,system_IConvertible_toSingle];
		private function system_IConvertible_ToSingle(provider:IFormatProvider):Number;

		[native,system_IConvertible_toDouble];
		private function system_IConvertible_ToDouble(provider:IFormatProvider):Number;

		[native,system_IConvertible_toDecimal];
		private function system_IConvertible_ToDecimal(provider:IFormatProvider):Decimal;

		[native,system_IConvertible_toDateTime];
		private function system_IConvertible_ToDateTime(provider:IFormatProvider):DateTime;

		[native,system_IConvertible_toType];
		private function system_IConvertible_ToType(conversionType:Class,provider:IFormatProvider):_Object_;


	}
}
