package system.globalization
{
	import system._Object_;
	import system.ICloneable;
	import system.DateTime;
	import system.DayOfWeek;
	import system._Array_;


		/**
		* Abstract
		*  System.Globalization.Calendar
		*/
	[no_constructor]
	[link_system]
	public class Calendar extends system._Object_ implements system.ICloneable
	{
		[creator];
		[native,system_globalization_Calendar_creator];
		private static function _creator(type:Class):*;
		[native,$$_noctorclass];
		public function Calendar();
		//*********字段*******
		/**
		* System.Globalization.Calendar.CurrentEra
		*fieldtype:
		*   System.Int32
		*/
		[native, system_globalization_Calendar_CurrentEra_getter];
		public static const CurrentEra:int;

		//*********公共方法*******
		/**
		* System.Globalization.Calendar.get_MinSupportedDateTime
		*return:
		*   System.DateTime
		*/
		[native,system_globalization_Calendar_get_MinSupportedDateTime]
		public function get minSupportedDateTime():system.DateTime;

		/**
		* System.Globalization.Calendar.get_MaxSupportedDateTime
		*return:
		*   System.DateTime
		*/
		[native,system_globalization_Calendar_get_MaxSupportedDateTime]
		public function get maxSupportedDateTime():system.DateTime;

		/**
		* System.Globalization.Calendar.get_AlgorithmType
		*return:
		*   System.Globalization.CalendarAlgorithmType
		*/
		[native,system_globalization_Calendar_get_AlgorithmType]
		public function get algorithmType():CalendarAlgorithmType;

		/**
		* System.Globalization.Calendar.get_IsReadOnly
		*return:
		*   System.Boolean
		*/
		[native,system_globalization_Calendar_get_IsReadOnly]
		public final function get isReadOnly():Boolean;

		[native,system_ICloneable_clone];
		public function clone():system._Object_;

		/**
		* System.Globalization.Calendar.ReadOnly
		*parameters:
		*  calendar : System.Globalization.Calendar
		*return:
		*   System.Globalization.Calendar
		*/
		[native,static_system_globalization_Calendar_readOnly];
		public static function readOnly(calendar:Calendar):Calendar;

		/**
		* System.Globalization.Calendar.AddMilliseconds
		*parameters:
		*  time : System.DateTime
		*  milliseconds : System.Double
		*return:
		*   System.DateTime
		*/
		[native,system_globalization_Calendar_addMilliseconds];
		public function addMilliseconds(time:system.DateTime,milliseconds:Number):system.DateTime;

		/**
		* System.Globalization.Calendar.AddDays
		*parameters:
		*  time : System.DateTime
		*  days : System.Int32
		*return:
		*   System.DateTime
		*/
		[native,system_globalization_Calendar_addDays];
		public function addDays(time:system.DateTime,days:int):system.DateTime;

		/**
		* System.Globalization.Calendar.AddHours
		*parameters:
		*  time : System.DateTime
		*  hours : System.Int32
		*return:
		*   System.DateTime
		*/
		[native,system_globalization_Calendar_addHours];
		public function addHours(time:system.DateTime,hours:int):system.DateTime;

		/**
		* System.Globalization.Calendar.AddMinutes
		*parameters:
		*  time : System.DateTime
		*  minutes : System.Int32
		*return:
		*   System.DateTime
		*/
		[native,system_globalization_Calendar_addMinutes];
		public function addMinutes(time:system.DateTime,minutes:int):system.DateTime;

		/**
		* System.Globalization.Calendar.AddMonths
		*parameters:
		*  time : System.DateTime
		*  months : System.Int32
		*return:
		*   System.DateTime
		*/
		[native,system_globalization_Calendar_addMonths];
		public function addMonths(time:system.DateTime,months:int):system.DateTime;

		/**
		* System.Globalization.Calendar.AddSeconds
		*parameters:
		*  time : System.DateTime
		*  seconds : System.Int32
		*return:
		*   System.DateTime
		*/
		[native,system_globalization_Calendar_addSeconds];
		public function addSeconds(time:system.DateTime,seconds:int):system.DateTime;

		/**
		* System.Globalization.Calendar.AddWeeks
		*parameters:
		*  time : System.DateTime
		*  weeks : System.Int32
		*return:
		*   System.DateTime
		*/
		[native,system_globalization_Calendar_addWeeks];
		public function addWeeks(time:system.DateTime,weeks:int):system.DateTime;

		/**
		* System.Globalization.Calendar.AddYears
		*parameters:
		*  time : System.DateTime
		*  years : System.Int32
		*return:
		*   System.DateTime
		*/
		[native,system_globalization_Calendar_addYears];
		public function addYears(time:system.DateTime,years:int):system.DateTime;

		/**
		* System.Globalization.Calendar.GetDayOfMonth
		*parameters:
		*  time : System.DateTime
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getDayOfMonth];
		public function getDayOfMonth(time:system.DateTime):int;

		/**
		* System.Globalization.Calendar.GetDayOfWeek
		*parameters:
		*  time : System.DateTime
		*return:
		*   System.DayOfWeek
		*/
		[native,system_globalization_Calendar_getDayOfWeek];
		public function getDayOfWeek(time:system.DateTime):system.DayOfWeek;

		/**
		* System.Globalization.Calendar.GetDayOfYear
		*parameters:
		*  time : System.DateTime
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getDayOfYear];
		public function getDayOfYear(time:system.DateTime):int;

		/**
		* System.Globalization.Calendar.GetDaysInMonth
		*parameters:
		*  year : System.Int32
		*  month : System.Int32
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getDaysInMonth];
		public function getDaysInMonth(year:int,month:int):int;

		/**
		* System.Globalization.Calendar.GetDaysInMonth
		*parameters:
		*  year : System.Int32
		*  month : System.Int32
		*  era : System.Int32
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getDaysInMonth_];
		public function getDaysInMonth_(year:int,month:int,era:int):int;

		/**
		* System.Globalization.Calendar.GetDaysInYear
		*parameters:
		*  year : System.Int32
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getDaysInYear];
		public function getDaysInYear(year:int):int;

		/**
		* System.Globalization.Calendar.GetDaysInYear
		*parameters:
		*  year : System.Int32
		*  era : System.Int32
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getDaysInYear_];
		public function getDaysInYear_(year:int,era:int):int;

		/**
		* System.Globalization.Calendar.GetEra
		*parameters:
		*  time : System.DateTime
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getEra];
		public function getEra(time:system.DateTime):int;

		/**
		* System.Globalization.Calendar.get_Eras
		*return:
		*   System.Int32[]
		*/
		[native,system_globalization_Calendar_get_Eras]
		public function get eras():_Array_;

		/**
		* System.Globalization.Calendar.GetHour
		*parameters:
		*  time : System.DateTime
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getHour];
		public function getHour(time:system.DateTime):int;

		/**
		* System.Globalization.Calendar.GetMilliseconds
		*parameters:
		*  time : System.DateTime
		*return:
		*   System.Double
		*/
		[native,system_globalization_Calendar_getMilliseconds];
		public function getMilliseconds(time:system.DateTime):Number;

		/**
		* System.Globalization.Calendar.GetMinute
		*parameters:
		*  time : System.DateTime
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getMinute];
		public function getMinute(time:system.DateTime):int;

		/**
		* System.Globalization.Calendar.GetMonth
		*parameters:
		*  time : System.DateTime
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getMonth];
		public function getMonth(time:system.DateTime):int;

		/**
		* System.Globalization.Calendar.GetMonthsInYear
		*parameters:
		*  year : System.Int32
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getMonthsInYear];
		public function getMonthsInYear(year:int):int;

		/**
		* System.Globalization.Calendar.GetMonthsInYear
		*parameters:
		*  year : System.Int32
		*  era : System.Int32
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getMonthsInYear_];
		public function getMonthsInYear_(year:int,era:int):int;

		/**
		* System.Globalization.Calendar.GetSecond
		*parameters:
		*  time : System.DateTime
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getSecond];
		public function getSecond(time:system.DateTime):int;

		/**
		* System.Globalization.Calendar.GetWeekOfYear
		*parameters:
		*  time : System.DateTime
		*  rule : System.Globalization.CalendarWeekRule
		*  firstDayOfWeek : System.DayOfWeek
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getWeekOfYear];
		public function getWeekOfYear(time:system.DateTime,rule:CalendarWeekRule,firstDayOfWeek:system.DayOfWeek):int;

		/**
		* System.Globalization.Calendar.GetYear
		*parameters:
		*  time : System.DateTime
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getYear];
		public function getYear(time:system.DateTime):int;

		/**
		* System.Globalization.Calendar.IsLeapDay
		*parameters:
		*  year : System.Int32
		*  month : System.Int32
		*  day : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,system_globalization_Calendar_isLeapDay];
		public function isLeapDay(year:int,month:int,day:int):Boolean;

		/**
		* System.Globalization.Calendar.IsLeapDay
		*parameters:
		*  year : System.Int32
		*  month : System.Int32
		*  day : System.Int32
		*  era : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,system_globalization_Calendar_isLeapDay_];
		public function isLeapDay_(year:int,month:int,day:int,era:int):Boolean;

		/**
		* System.Globalization.Calendar.IsLeapMonth
		*parameters:
		*  year : System.Int32
		*  month : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,system_globalization_Calendar_isLeapMonth];
		public function isLeapMonth(year:int,month:int):Boolean;

		/**
		* System.Globalization.Calendar.IsLeapMonth
		*parameters:
		*  year : System.Int32
		*  month : System.Int32
		*  era : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,system_globalization_Calendar_isLeapMonth_];
		public function isLeapMonth_(year:int,month:int,era:int):Boolean;

		/**
		* System.Globalization.Calendar.GetLeapMonth
		*parameters:
		*  year : System.Int32
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getLeapMonth];
		public function getLeapMonth(year:int):int;

		/**
		* System.Globalization.Calendar.GetLeapMonth
		*parameters:
		*  year : System.Int32
		*  era : System.Int32
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_getLeapMonth_];
		public function getLeapMonth_(year:int,era:int):int;

		/**
		* System.Globalization.Calendar.IsLeapYear
		*parameters:
		*  year : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,system_globalization_Calendar_isLeapYear];
		public function isLeapYear(year:int):Boolean;

		/**
		* System.Globalization.Calendar.IsLeapYear
		*parameters:
		*  year : System.Int32
		*  era : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,system_globalization_Calendar_isLeapYear_];
		public function isLeapYear_(year:int,era:int):Boolean;

		/**
		* System.Globalization.Calendar.ToDateTime
		*parameters:
		*  year : System.Int32
		*  month : System.Int32
		*  day : System.Int32
		*  hour : System.Int32
		*  minute : System.Int32
		*  second : System.Int32
		*  millisecond : System.Int32
		*return:
		*   System.DateTime
		*/
		[native,system_globalization_Calendar_toDateTime];
		public function toDateTime(year:int,month:int,day:int,hour:int,minute:int,second:int,millisecond:int):system.DateTime;

		/**
		* System.Globalization.Calendar.ToDateTime
		*parameters:
		*  year : System.Int32
		*  month : System.Int32
		*  day : System.Int32
		*  hour : System.Int32
		*  minute : System.Int32
		*  second : System.Int32
		*  millisecond : System.Int32
		*  era : System.Int32
		*return:
		*   System.DateTime
		*/
		[native,system_globalization_Calendar_toDateTime_];
		public function toDateTime_(year:int,month:int,day:int,hour:int,minute:int,second:int,millisecond:int,era:int):system.DateTime;

		/**
		* System.Globalization.Calendar.get_TwoDigitYearMax
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_get_TwoDigitYearMax]
		public function get twoDigitYearMax():int;

		/**
		* System.Globalization.Calendar.set_TwoDigitYearMax
		*parameters:
		*  value : System.Int32
		*/
		[native,system_globalization_Calendar_set_TwoDigitYearMax]
		public function set twoDigitYearMax(value:int):void;

		/**
		* System.Globalization.Calendar.ToFourDigitYear
		*parameters:
		*  year : System.Int32
		*return:
		*   System.Int32
		*/
		[native,system_globalization_Calendar_toFourDigitYear];
		public function toFourDigitYear(year:int):int;


	}
}
