package system.io
{
	import system.MarshalByRefObject;
	import system.IDisposable;
	import system.Int64;
	import system.IAsyncResult;
	import system._Array_;
	import system.AsyncCallback;
	import system._Object_;
	import system.Byte;


		/**
		* Abstract
		*  System.IO.Stream
		*/
	[no_constructor]
	[link_system]
	public class Stream extends system.MarshalByRefObject implements system.IDisposable
	{
		[creator];
		[native,system_io_Stream_creator];
		private static function _creator(type:Class):*;
		[native,$$_noctorclass];
		public function Stream();
		//*********字段*******
		/**
		* System.IO.Stream.Null
		*fieldtype:
		*   System.IO.Stream
		*/
		[native, system_io_Stream_Null_getter];
		public static const Null:Stream;

		//*********公共方法*******
		/**
		* System.IO.Stream.get_CanRead
		*return:
		*   System.Boolean
		*/
		[native,system_io_Stream_get_CanRead]
		public function get canRead():Boolean;

		/**
		* System.IO.Stream.get_CanSeek
		*return:
		*   System.Boolean
		*/
		[native,system_io_Stream_get_CanSeek]
		public function get canSeek():Boolean;

		/**
		* System.IO.Stream.get_CanTimeout
		*return:
		*   System.Boolean
		*/
		[native,system_io_Stream_get_CanTimeout]
		public function get canTimeout():Boolean;

		/**
		* System.IO.Stream.get_CanWrite
		*return:
		*   System.Boolean
		*/
		[native,system_io_Stream_get_CanWrite]
		public function get canWrite():Boolean;

		/**
		* System.IO.Stream.get_Length
		*return:
		*   System.Int64
		*/
		[native,system_io_Stream_get_Length]
		public function get length():system.Int64;

		/**
		* System.IO.Stream.get_Position
		*return:
		*   System.Int64
		*/
		[native,system_io_Stream_get_Position]
		public function get position():system.Int64;

		/**
		* System.IO.Stream.set_Position
		*parameters:
		*  value : System.Int64
		*/
		[native,system_io_Stream_set_Position]
		public function set position(value:system.Int64):void;

		/**
		* System.IO.Stream.get_ReadTimeout
		*return:
		*   System.Int32
		*/
		[native,system_io_Stream_get_ReadTimeout]
		public function get readTimeout():int;

		/**
		* System.IO.Stream.set_ReadTimeout
		*parameters:
		*  value : System.Int32
		*/
		[native,system_io_Stream_set_ReadTimeout]
		public function set readTimeout(value:int):void;

		/**
		* System.IO.Stream.get_WriteTimeout
		*return:
		*   System.Int32
		*/
		[native,system_io_Stream_get_WriteTimeout]
		public function get writeTimeout():int;

		/**
		* System.IO.Stream.set_WriteTimeout
		*parameters:
		*  value : System.Int32
		*/
		[native,system_io_Stream_set_WriteTimeout]
		public function set writeTimeout(value:int):void;

		/**
		* System.IO.Stream.Close
		*/
		[native,system_io_Stream_close];
		public function close():void;

		[native,system_IDisposable_dispose];
		public final function dispose():void;

		/**
		* System.IO.Stream.Flush
		*/
		[native,system_io_Stream_flush];
		public function flush():void;

		/**
		* System.IO.Stream.BeginRead
		*parameters:
		*  buffer : System.Byte[]
		*  offset : System.Int32
		*  count : System.Int32
		*  callback : System.AsyncCallback [System.Void(System.IAsyncResult)]
		*  state : System.Object
		*return:
		*   System.IAsyncResult
		*/
		[native,system_io_Stream_beginRead];
		public function beginRead(buffer:_Array_,offset:int,count:int,callback:system.AsyncCallback,state:system._Object_):system.IAsyncResult;

		/**
		* System.IO.Stream.EndRead
		*parameters:
		*  asyncResult : System.IAsyncResult
		*return:
		*   System.Int32
		*/
		[native,system_io_Stream_endRead];
		public function endRead(asyncResult:system.IAsyncResult):int;

		/**
		* System.IO.Stream.BeginWrite
		*parameters:
		*  buffer : System.Byte[]
		*  offset : System.Int32
		*  count : System.Int32
		*  callback : System.AsyncCallback [System.Void(System.IAsyncResult)]
		*  state : System.Object
		*return:
		*   System.IAsyncResult
		*/
		[native,system_io_Stream_beginWrite];
		public function beginWrite(buffer:_Array_,offset:int,count:int,callback:system.AsyncCallback,state:system._Object_):system.IAsyncResult;

		/**
		* System.IO.Stream.EndWrite
		*parameters:
		*  asyncResult : System.IAsyncResult
		*/
		[native,system_io_Stream_endWrite];
		public function endWrite(asyncResult:system.IAsyncResult):void;

		/**
		* System.IO.Stream.Seek
		*parameters:
		*  offset : System.Int64
		*  origin : System.IO.SeekOrigin
		*return:
		*   System.Int64
		*/
		[native,system_io_Stream_seek];
		public function seek(offset:system.Int64,origin:SeekOrigin):system.Int64;

		/**
		* System.IO.Stream.SetLength
		*parameters:
		*  value : System.Int64
		*/
		[native,system_io_Stream_setLength];
		public function setLength(value:system.Int64):void;

		/**
		* System.IO.Stream.Read
		*parameters:
		*  buffer : System.Byte[]
		*  offset : System.Int32
		*  count : System.Int32
		*return:
		*   System.Int32
		*/
		[native,system_io_Stream_read];
		public function read(buffer:_Array_,offset:int,count:int):int;

		/**
		* System.IO.Stream.ReadByte
		*return:
		*   System.Int32
		*/
		[native,system_io_Stream_readByte];
		public function readByte():int;

		/**
		* System.IO.Stream.Write
		*parameters:
		*  buffer : System.Byte[]
		*  offset : System.Int32
		*  count : System.Int32
		*/
		[native,system_io_Stream_write];
		public function write(buffer:_Array_,offset:int,count:int):void;

		/**
		* System.IO.Stream.WriteByte
		*parameters:
		*  value : System.Byte
		*/
		[native,system_io_Stream_writeByte];
		public function writeByte(value:system.Byte):void;

		/**
		* System.IO.Stream.Synchronized
		*parameters:
		*  stream : System.IO.Stream
		*return:
		*   System.IO.Stream
		*/
		[native,static_system_io_Stream_synchronized];
		public static function synchronized(stream:Stream):Stream;


	}
}
