package unityengine
{
	import system._Object_;
	import system._Array_;
	import unityengine.events.UnityAction;


		/**
		* Sealed
		*  UnityEngine.Application
		*/
	[link_system]
	public final class Application extends system._Object_
	{
		[creator];
		[native,unityengine_Application_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Application_ctor];
		public function Application();


		//*********公共方法*******
		/**
		* UnityEngine.Application.add_lowMemory
		*parameters:
		*  value : UnityEngine.Application.LowMemoryCallback [System.Void()]
		*/
		[native,static_unityengine_Application_lowMemory_addEventListener];
		public static function lowMemory_addEventListener(value:Application_LowMemoryCallback):void;

		/**
		* UnityEngine.Application.remove_lowMemory
		*parameters:
		*  value : UnityEngine.Application.LowMemoryCallback [System.Void()]
		*/
		[native,static_unityengine_Application_lowMemory_removeEventListener];
		public static function lowMemory_removeEventListener(value:Application_LowMemoryCallback):void;

		/**
		* UnityEngine.Application.Quit
		*/
		[native,static_unityengine_Application_quit];
		public static function quit():void;

		/**
		* UnityEngine.Application.CancelQuit
		*/
		[native,static_unityengine_Application_cancelQuit];
		public static function cancelQuit():void;

		/**
		* UnityEngine.Application.Unload
		*/
		[native,static_unityengine_Application_unload];
		public static function unload():void;

		/**
		* UnityEngine.Application.GetStreamProgressForLevel
		*parameters:
		*  levelIndex : System.Int32
		*return:
		*   System.Single
		*/
		[native,static_unityengine_Application_getStreamProgressForLevel];
		public static function getStreamProgressForLevel(levelIndex:int):Number;

		/**
		* UnityEngine.Application.GetStreamProgressForLevel
		*parameters:
		*  levelName : System.String
		*return:
		*   System.Single
		*/
		[native,static_unityengine_Application_getStreamProgressForLevel_];
		public static function getStreamProgressForLevel_(levelName:String):Number;

		/**
		* UnityEngine.Application.get_streamedBytes
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Application_get_streamedBytes]
		public static function get streamedBytes():int;

		/**
		* UnityEngine.Application.CanStreamedLevelBeLoaded
		*parameters:
		*  levelIndex : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Application_canStreamedLevelBeLoaded];
		public static function canStreamedLevelBeLoaded(levelIndex:int):Boolean;

		/**
		* UnityEngine.Application.CanStreamedLevelBeLoaded
		*parameters:
		*  levelName : System.String
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Application_canStreamedLevelBeLoaded_];
		public static function canStreamedLevelBeLoaded_(levelName:String):Boolean;

		/**
		* UnityEngine.Application.get_isPlaying
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Application_get_isPlaying]
		public static function get isPlaying():Boolean;

		/**
		* UnityEngine.Application.get_isFocused
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Application_get_isFocused]
		public static function get isFocused():Boolean;

		/**
		* UnityEngine.Application.get_isEditor
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Application_get_isEditor]
		public static function get isEditor():Boolean;

		/**
		* UnityEngine.Application.get_platform
		*return:
		*   UnityEngine.RuntimePlatform
		*/
		[native,static_unityengine_Application_get_platform]
		public static function get platform():RuntimePlatform;

		/**
		* UnityEngine.Application.GetBuildTags
		*return:
		*   System.String[]
		*/
		[native,static_unityengine_Application_getBuildTags];
		public static function getBuildTags():_Array_;

		/**
		* UnityEngine.Application.SetBuildTags
		*parameters:
		*  buildTags : System.String[]
		*/
		[native,static_unityengine_Application_setBuildTags];
		public static function setBuildTags(buildTags:_Array_):void;

		/**
		* UnityEngine.Application.get_buildGUID
		*return:
		*   System.String
		*/
		[native,static_unityengine_Application_get_buildGUID]
		public static function get buildGUID():String;

		/**
		* UnityEngine.Application.get_isMobilePlatform
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Application_get_isMobilePlatform]
		public static function get isMobilePlatform():Boolean;

		/**
		* UnityEngine.Application.get_isConsolePlatform
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Application_get_isConsolePlatform]
		public static function get isConsolePlatform():Boolean;

		/**
		* UnityEngine.Application.get_runInBackground
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Application_get_runInBackground]
		public static function get runInBackground():Boolean;

		/**
		* UnityEngine.Application.set_runInBackground
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_Application_set_runInBackground]
		public static function set runInBackground(value:Boolean):void;

		/**
		* UnityEngine.Application.HasProLicense
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Application_hasProLicense];
		public static function hasProLicense():Boolean;

		/**
		* UnityEngine.Application.get_dataPath
		*return:
		*   System.String
		*/
		[native,static_unityengine_Application_get_dataPath]
		public static function get dataPath():String;

		/**
		* UnityEngine.Application.get_streamingAssetsPath
		*return:
		*   System.String
		*/
		[native,static_unityengine_Application_get_streamingAssetsPath]
		public static function get streamingAssetsPath():String;

		/**
		* UnityEngine.Application.get_persistentDataPath
		*return:
		*   System.String
		*/
		[native,static_unityengine_Application_get_persistentDataPath]
		public static function get persistentDataPath():String;

		/**
		* UnityEngine.Application.get_temporaryCachePath
		*return:
		*   System.String
		*/
		[native,static_unityengine_Application_get_temporaryCachePath]
		public static function get temporaryCachePath():String;

		/**
		* UnityEngine.Application.get_absoluteURL
		*return:
		*   System.String
		*/
		[native,static_unityengine_Application_get_absoluteURL]
		public static function get absoluteURL():String;

		/**
		* UnityEngine.Application.get_unityVersion
		*return:
		*   System.String
		*/
		[native,static_unityengine_Application_get_unityVersion]
		public static function get unityVersion():String;

		/**
		* UnityEngine.Application.get_version
		*return:
		*   System.String
		*/
		[native,static_unityengine_Application_get_version]
		public static function get version():String;

		/**
		* UnityEngine.Application.get_installerName
		*return:
		*   System.String
		*/
		[native,static_unityengine_Application_get_installerName]
		public static function get installerName():String;

		/**
		* UnityEngine.Application.get_identifier
		*return:
		*   System.String
		*/
		[native,static_unityengine_Application_get_identifier]
		public static function get identifier():String;

		/**
		* UnityEngine.Application.get_installMode
		*return:
		*   UnityEngine.ApplicationInstallMode
		*/
		[native,static_unityengine_Application_get_installMode]
		public static function get installMode():ApplicationInstallMode;

		/**
		* UnityEngine.Application.get_sandboxType
		*return:
		*   UnityEngine.ApplicationSandboxType
		*/
		[native,static_unityengine_Application_get_sandboxType]
		public static function get sandboxType():ApplicationSandboxType;

		/**
		* UnityEngine.Application.get_productName
		*return:
		*   System.String
		*/
		[native,static_unityengine_Application_get_productName]
		public static function get productName():String;

		/**
		* UnityEngine.Application.get_companyName
		*return:
		*   System.String
		*/
		[native,static_unityengine_Application_get_companyName]
		public static function get companyName():String;

		/**
		* UnityEngine.Application.get_cloudProjectId
		*return:
		*   System.String
		*/
		[native,static_unityengine_Application_get_cloudProjectId]
		public static function get cloudProjectId():String;

		/**
		* UnityEngine.Application.RequestAdvertisingIdentifierAsync
		*parameters:
		*  delegateMethod : UnityEngine.Application.AdvertisingIdentifierCallback [System.Void(System.String,System.Boolean,System.String)]
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Application_requestAdvertisingIdentifierAsync];
		public static function requestAdvertisingIdentifierAsync(delegateMethod:Application_AdvertisingIdentifierCallback):Boolean;

		/**
		* UnityEngine.Application.OpenURL
		*parameters:
		*  url : System.String
		*/
		[native,static_unityengine_Application_openURL];
		public static function openURL(url:String):void;

		/**
		* UnityEngine.Application.get_targetFrameRate
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Application_get_targetFrameRate]
		public static function get targetFrameRate():int;

		/**
		* UnityEngine.Application.set_targetFrameRate
		*parameters:
		*  value : System.Int32
		*/
		[native,static_unityengine_Application_set_targetFrameRate]
		public static function set targetFrameRate(value:int):void;

		/**
		* UnityEngine.Application.get_systemLanguage
		*return:
		*   UnityEngine.SystemLanguage
		*/
		[native,static_unityengine_Application_get_systemLanguage]
		public static function get systemLanguage():SystemLanguage;

		/**
		* UnityEngine.Application.add_logMessageReceived
		*parameters:
		*  value : UnityEngine.Application.LogCallback [System.Void(System.String,System.String,UnityEngine.LogType)]
		*/
		[native,static_unityengine_Application_logMessageReceived_addEventListener];
		public static function logMessageReceived_addEventListener(value:Application_LogCallback):void;

		/**
		* UnityEngine.Application.remove_logMessageReceived
		*parameters:
		*  value : UnityEngine.Application.LogCallback [System.Void(System.String,System.String,UnityEngine.LogType)]
		*/
		[native,static_unityengine_Application_logMessageReceived_removeEventListener];
		public static function logMessageReceived_removeEventListener(value:Application_LogCallback):void;

		/**
		* UnityEngine.Application.add_logMessageReceivedThreaded
		*parameters:
		*  value : UnityEngine.Application.LogCallback [System.Void(System.String,System.String,UnityEngine.LogType)]
		*/
		[native,static_unityengine_Application_logMessageReceivedThreaded_addEventListener];
		public static function logMessageReceivedThreaded_addEventListener(value:Application_LogCallback):void;

		/**
		* UnityEngine.Application.remove_logMessageReceivedThreaded
		*parameters:
		*  value : UnityEngine.Application.LogCallback [System.Void(System.String,System.String,UnityEngine.LogType)]
		*/
		[native,static_unityengine_Application_logMessageReceivedThreaded_removeEventListener];
		public static function logMessageReceivedThreaded_removeEventListener(value:Application_LogCallback):void;

		/**
		* UnityEngine.Application.GetStackTraceLogType
		*parameters:
		*  logType : UnityEngine.LogType
		*return:
		*   UnityEngine.StackTraceLogType
		*/
		[native,static_unityengine_Application_getStackTraceLogType];
		public static function getStackTraceLogType(logType:LogType):StackTraceLogType;

		/**
		* UnityEngine.Application.SetStackTraceLogType
		*parameters:
		*  logType : UnityEngine.LogType
		*  stackTraceType : UnityEngine.StackTraceLogType
		*/
		[native,static_unityengine_Application_setStackTraceLogType];
		public static function setStackTraceLogType(logType:LogType,stackTraceType:StackTraceLogType):void;

		/**
		* UnityEngine.Application.get_backgroundLoadingPriority
		*return:
		*   UnityEngine.ThreadPriority
		*/
		[native,static_unityengine_Application_get_backgroundLoadingPriority]
		public static function get backgroundLoadingPriority():ThreadPriority;

		/**
		* UnityEngine.Application.set_backgroundLoadingPriority
		*parameters:
		*  value : UnityEngine.ThreadPriority
		*/
		[native,static_unityengine_Application_set_backgroundLoadingPriority]
		public static function set backgroundLoadingPriority(value:ThreadPriority):void;

		/**
		* UnityEngine.Application.get_internetReachability
		*return:
		*   UnityEngine.NetworkReachability
		*/
		[native,static_unityengine_Application_get_internetReachability]
		public static function get internetReachability():NetworkReachability;

		/**
		* UnityEngine.Application.get_genuine
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Application_get_genuine]
		public static function get genuine():Boolean;

		/**
		* UnityEngine.Application.get_genuineCheckAvailable
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Application_get_genuineCheckAvailable]
		public static function get genuineCheckAvailable():Boolean;

		/**
		* UnityEngine.Application.RequestUserAuthorization
		*parameters:
		*  mode : UnityEngine.UserAuthorization
		*return:
		*   UnityEngine.AsyncOperation
		*/
		[native,static_unityengine_Application_requestUserAuthorization];
		public static function requestUserAuthorization(mode:UserAuthorization):AsyncOperation;

		/**
		* UnityEngine.Application.HasUserAuthorization
		*parameters:
		*  mode : UnityEngine.UserAuthorization
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Application_hasUserAuthorization];
		public static function hasUserAuthorization(mode:UserAuthorization):Boolean;

		/**
		* UnityEngine.Application.add_onBeforeRender
		*parameters:
		*  value : UnityEngine.Events.UnityAction [System.Void()]
		*/
		[native,static_unityengine_Application_onBeforeRender_addEventListener];
		public static function onBeforeRender_addEventListener(value:unityengine.events.UnityAction):void;

		/**
		* UnityEngine.Application.remove_onBeforeRender
		*parameters:
		*  value : UnityEngine.Events.UnityAction [System.Void()]
		*/
		[native,static_unityengine_Application_onBeforeRender_removeEventListener];
		public static function onBeforeRender_removeEventListener(value:unityengine.events.UnityAction):void;


	}
}
