package unityengine
{
	import system.UInt64;
	import system._Array_;
	import system.io.Stream;


		/**
		* Sealed
		*  UnityEngine.AssetBundle
		*/
	[link_system]
	public final class AssetBundle extends UObject
	{
		[creator];
		[native,unityengine_AssetBundle_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_AssetBundle_ctor];
		public function AssetBundle();


		//*********公共方法*******
		/**
		* UnityEngine.AssetBundle.UnloadAllAssetBundles
		*parameters:
		*  unloadAllObjects : System.Boolean
		*/
		[native,static_unityengine_AssetBundle_unloadAllAssetBundles];
		public static function unloadAllAssetBundles(unloadAllObjects:Boolean):void;

		/**
		* UnityEngine.AssetBundle.LoadFromFileAsync
		*parameters:
		*  path : System.String
		*  crc : System.UInt32
		*  offset : System.UInt64
		*return:
		*   UnityEngine.AssetBundleCreateRequest
		*/
		[native,static_unityengine_AssetBundle_loadFromFileAsync];
		public static function loadFromFileAsync(path:String,crc:uint,offset:system.UInt64):AssetBundleCreateRequest;

		/**
		* UnityEngine.AssetBundle.LoadFromFileAsync
		*parameters:
		*  path : System.String
		*  crc : System.UInt32
		*return:
		*   UnityEngine.AssetBundleCreateRequest
		*/
		[native,static_unityengine_AssetBundle_loadFromFileAsync_];
		public static function loadFromFileAsync_(path:String,crc:uint):AssetBundleCreateRequest;

		/**
		* UnityEngine.AssetBundle.LoadFromFileAsync
		*parameters:
		*  path : System.String
		*return:
		*   UnityEngine.AssetBundleCreateRequest
		*/
		[native,static_unityengine_AssetBundle_loadFromFileAsync__];
		public static function loadFromFileAsync__(path:String):AssetBundleCreateRequest;

		/**
		* UnityEngine.AssetBundle.LoadFromFile
		*parameters:
		*  path : System.String
		*  crc : System.UInt32
		*  offset : System.UInt64
		*return:
		*   UnityEngine.AssetBundle
		*/
		[native,static_unityengine_AssetBundle_loadFromFile];
		public static function loadFromFile(path:String,crc:uint,offset:system.UInt64):AssetBundle;

		/**
		* UnityEngine.AssetBundle.LoadFromFile
		*parameters:
		*  path : System.String
		*  crc : System.UInt32
		*return:
		*   UnityEngine.AssetBundle
		*/
		[native,static_unityengine_AssetBundle_loadFromFile_];
		public static function loadFromFile_(path:String,crc:uint):AssetBundle;

		/**
		* UnityEngine.AssetBundle.LoadFromFile
		*parameters:
		*  path : System.String
		*return:
		*   UnityEngine.AssetBundle
		*/
		[native,static_unityengine_AssetBundle_loadFromFile__];
		public static function loadFromFile__(path:String):AssetBundle;

		/**
		* UnityEngine.AssetBundle.LoadFromMemoryAsync
		*parameters:
		*  binary : System.Byte[]
		*  crc : System.UInt32
		*return:
		*   UnityEngine.AssetBundleCreateRequest
		*/
		[native,static_unityengine_AssetBundle_loadFromMemoryAsync];
		public static function loadFromMemoryAsync(binary:_Array_,crc:uint):AssetBundleCreateRequest;

		/**
		* UnityEngine.AssetBundle.LoadFromMemoryAsync
		*parameters:
		*  binary : System.Byte[]
		*return:
		*   UnityEngine.AssetBundleCreateRequest
		*/
		[native,static_unityengine_AssetBundle_loadFromMemoryAsync_];
		public static function loadFromMemoryAsync_(binary:_Array_):AssetBundleCreateRequest;

		/**
		* UnityEngine.AssetBundle.LoadFromMemory
		*parameters:
		*  binary : System.Byte[]
		*  crc : System.UInt32
		*return:
		*   UnityEngine.AssetBundle
		*/
		[native,static_unityengine_AssetBundle_loadFromMemory];
		public static function loadFromMemory(binary:_Array_,crc:uint):AssetBundle;

		/**
		* UnityEngine.AssetBundle.LoadFromMemory
		*parameters:
		*  binary : System.Byte[]
		*return:
		*   UnityEngine.AssetBundle
		*/
		[native,static_unityengine_AssetBundle_loadFromMemory_];
		public static function loadFromMemory_(binary:_Array_):AssetBundle;

		/**
		* UnityEngine.AssetBundle.LoadFromStreamAsync
		*parameters:
		*  stream : System.IO.Stream
		*  crc : System.UInt32
		*return:
		*   UnityEngine.AssetBundleCreateRequest
		*/
		[native,static_unityengine_AssetBundle_loadFromStreamAsync];
		public static function loadFromStreamAsync(stream:system.io.Stream,crc:uint):AssetBundleCreateRequest;

		/**
		* UnityEngine.AssetBundle.LoadFromStreamAsync
		*parameters:
		*  stream : System.IO.Stream
		*return:
		*   UnityEngine.AssetBundleCreateRequest
		*/
		[native,static_unityengine_AssetBundle_loadFromStreamAsync_];
		public static function loadFromStreamAsync_(stream:system.io.Stream):AssetBundleCreateRequest;

		/**
		* UnityEngine.AssetBundle.LoadFromStreamAsync
		*parameters:
		*  stream : System.IO.Stream
		*  crc : System.UInt32
		*  managedReadBufferSize : System.UInt32
		*return:
		*   UnityEngine.AssetBundleCreateRequest
		*/
		[native,static_unityengine_AssetBundle_loadFromStreamAsync__];
		public static function loadFromStreamAsync__(stream:system.io.Stream,crc:uint,managedReadBufferSize:uint):AssetBundleCreateRequest;

		/**
		* UnityEngine.AssetBundle.LoadFromStream
		*parameters:
		*  stream : System.IO.Stream
		*  crc : System.UInt32
		*return:
		*   UnityEngine.AssetBundle
		*/
		[native,static_unityengine_AssetBundle_loadFromStream];
		public static function loadFromStream(stream:system.io.Stream,crc:uint):AssetBundle;

		/**
		* UnityEngine.AssetBundle.LoadFromStream
		*parameters:
		*  stream : System.IO.Stream
		*return:
		*   UnityEngine.AssetBundle
		*/
		[native,static_unityengine_AssetBundle_loadFromStream_];
		public static function loadFromStream_(stream:system.io.Stream):AssetBundle;

		/**
		* UnityEngine.AssetBundle.LoadFromStream
		*parameters:
		*  stream : System.IO.Stream
		*  crc : System.UInt32
		*  managedReadBufferSize : System.UInt32
		*return:
		*   UnityEngine.AssetBundle
		*/
		[native,static_unityengine_AssetBundle_loadFromStream__];
		public static function loadFromStream__(stream:system.io.Stream,crc:uint,managedReadBufferSize:uint):AssetBundle;

		/**
		* UnityEngine.AssetBundle.get_mainAsset
		*return:
		*   UnityEngine.Object
		*/
		[native,unityengine_AssetBundle_get_mainAsset]
		public final function get mainAsset():UObject;

		/**
		* UnityEngine.AssetBundle.get_isStreamedSceneAssetBundle
		*return:
		*   System.Boolean
		*/
		[native,unityengine_AssetBundle_get_isStreamedSceneAssetBundle]
		public final function get isStreamedSceneAssetBundle():Boolean;

		/**
		* UnityEngine.AssetBundle.Contains
		*parameters:
		*  name : System.String
		*return:
		*   System.Boolean
		*/
		[native,unityengine_AssetBundle_contains];
		public final function contains(name:String):Boolean;

		/**
		* UnityEngine.AssetBundle.LoadAsset
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Object
		*/
		[native,unityengine_AssetBundle_loadAsset];
		public final function loadAsset(name:String):UObject;

		/**
		* UnityEngine.AssetBundle.LoadAsset
		*parameters:
		*  name : System.String
		*  type : System.Type
		*return:
		*   UnityEngine.Object
		*/
		[native,unityengine_AssetBundle_loadAsset__];
		public final function loadAsset__(name:String,type:Class):UObject;

		/**
		* UnityEngine.AssetBundle.LoadAssetAsync
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.AssetBundleRequest
		*/
		[native,unityengine_AssetBundle_loadAssetAsync];
		public final function loadAssetAsync(name:String):AssetBundleRequest;

		/**
		* UnityEngine.AssetBundle.LoadAssetAsync
		*parameters:
		*  name : System.String
		*  type : System.Type
		*return:
		*   UnityEngine.AssetBundleRequest
		*/
		[native,unityengine_AssetBundle_loadAssetAsync__];
		public final function loadAssetAsync__(name:String,type:Class):AssetBundleRequest;

		/**
		* UnityEngine.AssetBundle.LoadAssetWithSubAssets
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Object[]
		*/
		[native,unityengine_AssetBundle_loadAssetWithSubAssets];
		public final function loadAssetWithSubAssets(name:String):_Array_;

		/**
		* UnityEngine.AssetBundle.LoadAssetWithSubAssets
		*parameters:
		*  name : System.String
		*  type : System.Type
		*return:
		*   UnityEngine.Object[]
		*/
		[native,unityengine_AssetBundle_loadAssetWithSubAssets__];
		public final function loadAssetWithSubAssets__(name:String,type:Class):_Array_;

		/**
		* UnityEngine.AssetBundle.LoadAssetWithSubAssetsAsync
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.AssetBundleRequest
		*/
		[native,unityengine_AssetBundle_loadAssetWithSubAssetsAsync];
		public final function loadAssetWithSubAssetsAsync(name:String):AssetBundleRequest;

		/**
		* UnityEngine.AssetBundle.LoadAssetWithSubAssetsAsync
		*parameters:
		*  name : System.String
		*  type : System.Type
		*return:
		*   UnityEngine.AssetBundleRequest
		*/
		[native,unityengine_AssetBundle_loadAssetWithSubAssetsAsync__];
		public final function loadAssetWithSubAssetsAsync__(name:String,type:Class):AssetBundleRequest;

		/**
		* UnityEngine.AssetBundle.LoadAllAssets
		*return:
		*   UnityEngine.Object[]
		*/
		[native,unityengine_AssetBundle_loadAllAssets];
		public final function loadAllAssets():_Array_;

		/**
		* UnityEngine.AssetBundle.LoadAllAssets
		*parameters:
		*  type : System.Type
		*return:
		*   UnityEngine.Object[]
		*/
		[native,unityengine_AssetBundle_loadAllAssets__];
		public final function loadAllAssets__(type:Class):_Array_;

		/**
		* UnityEngine.AssetBundle.LoadAllAssetsAsync
		*return:
		*   UnityEngine.AssetBundleRequest
		*/
		[native,unityengine_AssetBundle_loadAllAssetsAsync];
		public final function loadAllAssetsAsync():AssetBundleRequest;

		/**
		* UnityEngine.AssetBundle.LoadAllAssetsAsync
		*parameters:
		*  type : System.Type
		*return:
		*   UnityEngine.AssetBundleRequest
		*/
		[native,unityengine_AssetBundle_loadAllAssetsAsync__];
		public final function loadAllAssetsAsync__(type:Class):AssetBundleRequest;

		/**
		* UnityEngine.AssetBundle.Unload
		*parameters:
		*  unloadAllLoadedObjects : System.Boolean
		*/
		[native,unityengine_AssetBundle_unload];
		public final function unload(unloadAllLoadedObjects:Boolean):void;

		/**
		* UnityEngine.AssetBundle.GetAllAssetNames
		*return:
		*   System.String[]
		*/
		[native,unityengine_AssetBundle_getAllAssetNames];
		public final function getAllAssetNames():_Array_;

		/**
		* UnityEngine.AssetBundle.GetAllScenePaths
		*return:
		*   System.String[]
		*/
		[native,unityengine_AssetBundle_getAllScenePaths];
		public final function getAllScenePaths():_Array_;


	}
}
