package unityengine
{
	import system._Object_;
	import as3runtime.RefOutStore;


		/**
		* Struct
		*  UnityEngine.Bounds
		*/
	[struct]
	[link_system]
	public final class Bounds extends system._Object_
	{
		[creator];
		[native,unityengine_Bounds_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Bounds_ctor];
		public function Bounds(center:Vector3,size:Vector3);


		//*********公共方法*******
		/**
		* UnityEngine.Bounds.Contains
		*parameters:
		*  point : UnityEngine.Vector3
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Bounds_contains];
		public final function contains(point:Vector3):Boolean;

		/**
		* UnityEngine.Bounds.SqrDistance
		*parameters:
		*  point : UnityEngine.Vector3
		*return:
		*   System.Single
		*/
		[native,unityengine_Bounds_sqrDistance];
		public final function sqrDistance(point:Vector3):Number;

		/**
		* UnityEngine.Bounds.IntersectRay
		*parameters:
		*  ray : UnityEngine.Ray
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Bounds_intersectRay];
		public final function intersectRay(ray:Ray):Boolean;

		/**
		* UnityEngine.Bounds.IntersectRay
		*parameters:
		*  ray : UnityEngine.Ray
		*  distance : (Out)System.Single
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Bounds_intersectRay_];
		public final function intersectRay_(ray:Ray,distance:Number,refout:as3runtime.RefOutStore):Boolean;

		/**
		* UnityEngine.Bounds.ClosestPoint
		*parameters:
		*  point : UnityEngine.Vector3
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_closestPoint];
		public final function closestPoint(point:Vector3):Vector3;

		/**
		* UnityEngine.Bounds.get_center
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_get_center]
		public final function get center():Vector3;

		/**
		* UnityEngine.Bounds.set_center
		*parameters:
		*  value : UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_set_center]
		public final function set center(value:Vector3):void;

		/**
		* UnityEngine.Bounds.get_size
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_get_size]
		public final function get size():Vector3;

		/**
		* UnityEngine.Bounds.set_size
		*parameters:
		*  value : UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_set_size]
		public final function set size(value:Vector3):void;

		/**
		* UnityEngine.Bounds.get_extents
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_get_extents]
		public final function get extents():Vector3;

		/**
		* UnityEngine.Bounds.set_extents
		*parameters:
		*  value : UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_set_extents]
		public final function set extents(value:Vector3):void;

		/**
		* UnityEngine.Bounds.get_min
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_get_min]
		public final function get min():Vector3;

		/**
		* UnityEngine.Bounds.set_min
		*parameters:
		*  value : UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_set_min]
		public final function set min(value:Vector3):void;

		/**
		* UnityEngine.Bounds.get_max
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_get_max]
		public final function get max():Vector3;

		/**
		* UnityEngine.Bounds.set_max
		*parameters:
		*  value : UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_set_max]
		public final function set max(value:Vector3):void;

		/**
		* UnityEngine.Bounds.SetMinMax
		*parameters:
		*  min : UnityEngine.Vector3
		*  max : UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_setMinMax];
		public final function setMinMax(min:Vector3,max:Vector3):void;

		/**
		* UnityEngine.Bounds.Encapsulate
		*parameters:
		*  point : UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_encapsulate];
		public final function encapsulate(point:Vector3):void;

		/**
		* UnityEngine.Bounds.Encapsulate
		*parameters:
		*  bounds : UnityEngine.Bounds
		*/
		[native,unityengine_Bounds_encapsulate_];
		public final function encapsulate_(bounds:Bounds):void;

		/**
		* UnityEngine.Bounds.Expand
		*parameters:
		*  amount : System.Single
		*/
		[native,unityengine_Bounds_expand];
		public final function expand(amount:Number):void;

		/**
		* UnityEngine.Bounds.Expand
		*parameters:
		*  amount : UnityEngine.Vector3
		*/
		[native,unityengine_Bounds_expand_];
		public final function expand_(amount:Vector3):void;

		/**
		* UnityEngine.Bounds.Intersects
		*parameters:
		*  bounds : UnityEngine.Bounds
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Bounds_intersects];
		public final function intersects(bounds:Bounds):Boolean;

		/**
		* UnityEngine.Bounds.ToString
		*parameters:
		*  format : System.String
		*return:
		*   System.String
		*/
		[native,unityengine_Bounds_toString___];
		public final function toString___(format:String):String;


		//*****操作重载*****
		/**
		 * 计算 lhs == rhs
		 */
		[native,static_unityengine_Bounds_op_Equality];
		public static function op_Equality(lhs:Bounds,rhs:Bounds):Boolean;

		[operator,"=="];
		[native,static_unityengine_Bounds_op_Equality];
		private static function _operator_op_Equality(lhs:Bounds,rhs:Bounds):Boolean;

		/**
		 * 计算 lhs != rhs
		 */
		[native,static_unityengine_Bounds_op_Inequality];
		public static function op_Inequality(lhs:Bounds,rhs:Bounds):Boolean;

		[operator,"!="];
		[native,static_unityengine_Bounds_op_Inequality];
		private static function _operator_op_Inequality(lhs:Bounds,rhs:Bounds):Boolean;


	}
}
