package unityengine
{
	import unityengine.rendering.CameraEvent;
	import unityengine.rendering.CommandBuffer;
	import system._Array_;
	import unityengine.rendering.OpaqueSortMode;
	import unityengine.scenemanagement.Scene;


		/**
		* Sealed
		*  UnityEngine.Camera
		*/
	[link_system]
	public final class Camera extends Behaviour
	{
		[creator];
		[native,unityengine_Camera_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Camera_ctor];
		public function Camera();


		//*********字段*******
		/**
		* UnityEngine.Camera.onPreCull
		*fieldtype:
		*   UnityEngine.Camera.CameraCallback [System.Void(UnityEngine.Camera)]
		*/
		[native, unityengine_Camera_onPreCull_getter,unityengine_Camera_onPreCull_setter];
		public static var onPreCull:Camera_CameraCallback;
		/**
		* UnityEngine.Camera.onPreRender
		*fieldtype:
		*   UnityEngine.Camera.CameraCallback [System.Void(UnityEngine.Camera)]
		*/
		[native, unityengine_Camera_onPreRender_getter,unityengine_Camera_onPreRender_setter];
		public static var onPreRender:Camera_CameraCallback;
		/**
		* UnityEngine.Camera.onPostRender
		*fieldtype:
		*   UnityEngine.Camera.CameraCallback [System.Void(UnityEngine.Camera)]
		*/
		[native, unityengine_Camera_onPostRender_getter,unityengine_Camera_onPostRender_setter];
		public static var onPostRender:Camera_CameraCallback;

		//*********公共方法*******
		/**
		* UnityEngine.Camera.AddCommandBuffer
		*parameters:
		*  evt : UnityEngine.Rendering.CameraEvent
		*  buffer : UnityEngine.Rendering.CommandBuffer
		*/
		[native,unityengine_Camera_addCommandBuffer];
		public final function addCommandBuffer(evt:unityengine.rendering.CameraEvent,buffer:unityengine.rendering.CommandBuffer):void;

		/**
		* UnityEngine.Camera.RemoveCommandBuffer
		*parameters:
		*  evt : UnityEngine.Rendering.CameraEvent
		*  buffer : UnityEngine.Rendering.CommandBuffer
		*/
		[native,unityengine_Camera_removeCommandBuffer];
		public final function removeCommandBuffer(evt:unityengine.rendering.CameraEvent,buffer:unityengine.rendering.CommandBuffer):void;

		/**
		* UnityEngine.Camera.RemoveCommandBuffers
		*parameters:
		*  evt : UnityEngine.Rendering.CameraEvent
		*/
		[native,unityengine_Camera_removeCommandBuffers];
		public final function removeCommandBuffers(evt:unityengine.rendering.CameraEvent):void;

		/**
		* UnityEngine.Camera.RemoveAllCommandBuffers
		*/
		[native,unityengine_Camera_removeAllCommandBuffers];
		public final function removeAllCommandBuffers():void;

		/**
		* UnityEngine.Camera.GetCommandBuffers
		*parameters:
		*  evt : UnityEngine.Rendering.CameraEvent
		*return:
		*   UnityEngine.Rendering.CommandBuffer[]
		*/
		[native,unityengine_Camera_getCommandBuffers];
		public final function getCommandBuffers(evt:unityengine.rendering.CameraEvent):_Array_;

		/**
		* UnityEngine.Camera.get_commandBufferCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_Camera_get_commandBufferCount]
		public final function get commandBufferCount():int;

		/**
		* UnityEngine.Camera.CalculateObliqueMatrix
		*parameters:
		*  clipPlane : UnityEngine.Vector4
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_calculateObliqueMatrix];
		public final function calculateObliqueMatrix(clipPlane:Vector4):Matrix4x4;

		/**
		* UnityEngine.Camera.get_velocity
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Camera_get_velocity]
		public final function get velocity():Vector3;

		/**
		* UnityEngine.Camera.get_clearFlags
		*return:
		*   UnityEngine.CameraClearFlags
		*/
		[native,unityengine_Camera_get_clearFlags]
		public final function get clearFlags():CameraClearFlags;

		/**
		* UnityEngine.Camera.set_clearFlags
		*parameters:
		*  value : UnityEngine.CameraClearFlags
		*/
		[native,unityengine_Camera_set_clearFlags]
		public final function set clearFlags(value:CameraClearFlags):void;

		/**
		* UnityEngine.Camera.get_stereoEnabled
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_get_stereoEnabled]
		public final function get stereoEnabled():Boolean;

		/**
		* UnityEngine.Camera.get_stereoSeparation
		*return:
		*   System.Single
		*/
		[native,unityengine_Camera_get_stereoSeparation]
		public final function get stereoSeparation():Number;

		/**
		* UnityEngine.Camera.set_stereoSeparation
		*parameters:
		*  value : System.Single
		*/
		[native,unityengine_Camera_set_stereoSeparation]
		public final function set stereoSeparation(value:Number):void;

		/**
		* UnityEngine.Camera.get_stereoConvergence
		*return:
		*   System.Single
		*/
		[native,unityengine_Camera_get_stereoConvergence]
		public final function get stereoConvergence():Number;

		/**
		* UnityEngine.Camera.set_stereoConvergence
		*parameters:
		*  value : System.Single
		*/
		[native,unityengine_Camera_set_stereoConvergence]
		public final function set stereoConvergence(value:Number):void;

		/**
		* UnityEngine.Camera.get_cameraType
		*return:
		*   UnityEngine.CameraType
		*/
		[native,unityengine_Camera_get_cameraType]
		public final function get cameraType():CameraType;

		/**
		* UnityEngine.Camera.set_cameraType
		*parameters:
		*  value : UnityEngine.CameraType
		*/
		[native,unityengine_Camera_set_cameraType]
		public final function set cameraType(value:CameraType):void;

		/**
		* UnityEngine.Camera.GetStereoViewMatrix
		*parameters:
		*  eye : UnityEngine.Camera.StereoscopicEye
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_getStereoViewMatrix];
		public final function getStereoViewMatrix(eye:Camera_StereoscopicEye):Matrix4x4;

		/**
		* UnityEngine.Camera.get_stereoTargetEye
		*return:
		*   UnityEngine.StereoTargetEyeMask
		*/
		[native,unityengine_Camera_get_stereoTargetEye]
		public final function get stereoTargetEye():StereoTargetEyeMask;

		/**
		* UnityEngine.Camera.set_stereoTargetEye
		*parameters:
		*  value : UnityEngine.StereoTargetEyeMask
		*/
		[native,unityengine_Camera_set_stereoTargetEye]
		public final function set stereoTargetEye(value:StereoTargetEyeMask):void;

		/**
		* UnityEngine.Camera.get_areVRStereoViewMatricesWithinSingleCullTolerance
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_get_areVRStereoViewMatricesWithinSingleCullTolerance]
		public final function get areVRStereoViewMatricesWithinSingleCullTolerance():Boolean;

		/**
		* UnityEngine.Camera.SetStereoViewMatrix
		*parameters:
		*  eye : UnityEngine.Camera.StereoscopicEye
		*  matrix : UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_setStereoViewMatrix];
		public final function setStereoViewMatrix(eye:Camera_StereoscopicEye,matrix:Matrix4x4):void;

		/**
		* UnityEngine.Camera.ResetStereoViewMatrices
		*/
		[native,unityengine_Camera_resetStereoViewMatrices];
		public final function resetStereoViewMatrices():void;

		/**
		* UnityEngine.Camera.GetStereoProjectionMatrix
		*parameters:
		*  eye : UnityEngine.Camera.StereoscopicEye
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_getStereoProjectionMatrix];
		public final function getStereoProjectionMatrix(eye:Camera_StereoscopicEye):Matrix4x4;

		/**
		* UnityEngine.Camera.SetStereoProjectionMatrix
		*parameters:
		*  eye : UnityEngine.Camera.StereoscopicEye
		*  matrix : UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_setStereoProjectionMatrix];
		public final function setStereoProjectionMatrix(eye:Camera_StereoscopicEye,matrix:Matrix4x4):void;

		/**
		* UnityEngine.Camera.get_stereoActiveEye
		*return:
		*   UnityEngine.Camera.MonoOrStereoscopicEye
		*/
		[native,unityengine_Camera_get_stereoActiveEye]
		public final function get stereoActiveEye():Camera_MonoOrStereoscopicEye;

		/**
		* UnityEngine.Camera.CalculateFrustumCorners
		*parameters:
		*  viewport : UnityEngine.Rect
		*  z : System.Single
		*  eye : UnityEngine.Camera.MonoOrStereoscopicEye
		*  outCorners : UnityEngine.Vector3[]
		*/
		[native,unityengine_Camera_calculateFrustumCorners];
		public final function calculateFrustumCorners(viewport:Rect,z:Number,eye:Camera_MonoOrStereoscopicEye,outCorners:_Array_):void;

		/**
		* UnityEngine.Camera.ResetStereoProjectionMatrices
		*/
		[native,unityengine_Camera_resetStereoProjectionMatrices];
		public final function resetStereoProjectionMatrices():void;

		/**
		* UnityEngine.Camera.ResetTransparencySortSettings
		*/
		[native,unityengine_Camera_resetTransparencySortSettings];
		public final function resetTransparencySortSettings():void;

		/**
		* UnityEngine.Camera.get_targetDisplay
		*return:
		*   System.Int32
		*/
		[native,unityengine_Camera_get_targetDisplay]
		public final function get targetDisplay():int;

		/**
		* UnityEngine.Camera.set_targetDisplay
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_Camera_set_targetDisplay]
		public final function set targetDisplay(value:int):void;

		/**
		* UnityEngine.Camera.WorldToScreenPoint
		*parameters:
		*  position : UnityEngine.Vector3
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Camera_worldToScreenPoint];
		public final function worldToScreenPoint(position:Vector3):Vector3;

		/**
		* UnityEngine.Camera.WorldToViewportPoint
		*parameters:
		*  position : UnityEngine.Vector3
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Camera_worldToViewportPoint];
		public final function worldToViewportPoint(position:Vector3):Vector3;

		/**
		* UnityEngine.Camera.ViewportToWorldPoint
		*parameters:
		*  position : UnityEngine.Vector3
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Camera_viewportToWorldPoint];
		public final function viewportToWorldPoint(position:Vector3):Vector3;

		/**
		* UnityEngine.Camera.ScreenToWorldPoint
		*parameters:
		*  position : UnityEngine.Vector3
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Camera_screenToWorldPoint];
		public final function screenToWorldPoint(position:Vector3):Vector3;

		/**
		* UnityEngine.Camera.ScreenToViewportPoint
		*parameters:
		*  position : UnityEngine.Vector3
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Camera_screenToViewportPoint];
		public final function screenToViewportPoint(position:Vector3):Vector3;

		/**
		* UnityEngine.Camera.ViewportToScreenPoint
		*parameters:
		*  position : UnityEngine.Vector3
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Camera_viewportToScreenPoint];
		public final function viewportToScreenPoint(position:Vector3):Vector3;

		/**
		* UnityEngine.Camera.ViewportPointToRay
		*parameters:
		*  position : UnityEngine.Vector3
		*return:
		*   UnityEngine.Ray
		*/
		[native,unityengine_Camera_viewportPointToRay];
		public final function viewportPointToRay(position:Vector3):Ray;

		/**
		* UnityEngine.Camera.ScreenPointToRay
		*parameters:
		*  position : UnityEngine.Vector3
		*return:
		*   UnityEngine.Ray
		*/
		[native,unityengine_Camera_screenPointToRay];
		public final function screenPointToRay(position:Vector3):Ray;

		/**
		* UnityEngine.Camera.get_main
		*return:
		*   UnityEngine.Camera
		*/
		[native,static_unityengine_Camera_get_main]
		public static function get main():Camera;

		/**
		* UnityEngine.Camera.get_current
		*return:
		*   UnityEngine.Camera
		*/
		[native,static_unityengine_Camera_get_current]
		public static function get current():Camera;

		/**
		* UnityEngine.Camera.get_allCameras
		*return:
		*   UnityEngine.Camera[]
		*/
		[native,static_unityengine_Camera_get_allCameras]
		public static function get allCameras():_Array_;

		/**
		* UnityEngine.Camera.get_allCamerasCount
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Camera_get_allCamerasCount]
		public static function get allCamerasCount():int;

		/**
		* UnityEngine.Camera.GetAllCameras
		*parameters:
		*  cameras : UnityEngine.Camera[]
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Camera_getAllCameras];
		public static function getAllCameras(cameras:_Array_):int;

		/**
		* UnityEngine.Camera.Render
		*/
		[native,unityengine_Camera_render];
		public final function render():void;

		/**
		* UnityEngine.Camera.RenderWithShader
		*parameters:
		*  shader : UnityEngine.Shader
		*  replacementTag : System.String
		*/
		[native,unityengine_Camera_renderWithShader];
		public final function renderWithShader(shader:Shader,replacementTag:String):void;

		/**
		* UnityEngine.Camera.SetReplacementShader
		*parameters:
		*  shader : UnityEngine.Shader
		*  replacementTag : System.String
		*/
		[native,unityengine_Camera_setReplacementShader];
		public final function setReplacementShader(shader:Shader,replacementTag:String):void;

		/**
		* UnityEngine.Camera.ResetReplacementShader
		*/
		[native,unityengine_Camera_resetReplacementShader];
		public final function resetReplacementShader():void;

		/**
		* UnityEngine.Camera.get_useOcclusionCulling
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_get_useOcclusionCulling]
		public final function get useOcclusionCulling():Boolean;

		/**
		* UnityEngine.Camera.set_useOcclusionCulling
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_Camera_set_useOcclusionCulling]
		public final function set useOcclusionCulling(value:Boolean):void;

		/**
		* UnityEngine.Camera.get_cullingMatrix
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_get_cullingMatrix]
		public final function get cullingMatrix():Matrix4x4;

		/**
		* UnityEngine.Camera.set_cullingMatrix
		*parameters:
		*  value : UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_set_cullingMatrix]
		public final function set cullingMatrix(value:Matrix4x4):void;

		/**
		* UnityEngine.Camera.ResetCullingMatrix
		*/
		[native,unityengine_Camera_resetCullingMatrix];
		public final function resetCullingMatrix():void;

		/**
		* UnityEngine.Camera.RenderDontRestore
		*/
		[native,unityengine_Camera_renderDontRestore];
		public final function renderDontRestore():void;

		/**
		* UnityEngine.Camera.SetupCurrent
		*parameters:
		*  cur : UnityEngine.Camera
		*/
		[native,static_unityengine_Camera_setupCurrent];
		public static function setupCurrent(cur:Camera):void;

		/**
		* UnityEngine.Camera.RenderToCubemap
		*parameters:
		*  cubemap : UnityEngine.Cubemap
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_renderToCubemap];
		public final function renderToCubemap(cubemap:Cubemap):Boolean;

		/**
		* UnityEngine.Camera.RenderToCubemap
		*parameters:
		*  cubemap : UnityEngine.Cubemap
		*  faceMask : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_renderToCubemap_];
		public final function renderToCubemap_(cubemap:Cubemap,faceMask:int):Boolean;

		/**
		* UnityEngine.Camera.RenderToCubemap
		*parameters:
		*  cubemap : UnityEngine.RenderTexture
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_renderToCubemap__];
		public final function renderToCubemap__(cubemap:RenderTexture):Boolean;

		/**
		* UnityEngine.Camera.RenderToCubemap
		*parameters:
		*  cubemap : UnityEngine.RenderTexture
		*  faceMask : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_renderToCubemap___];
		public final function renderToCubemap___(cubemap:RenderTexture,faceMask:int):Boolean;

		/**
		* UnityEngine.Camera.get_layerCullDistances
		*return:
		*   System.Single[]
		*/
		[native,unityengine_Camera_get_layerCullDistances]
		public final function get layerCullDistances():_Array_;

		/**
		* UnityEngine.Camera.set_layerCullDistances
		*parameters:
		*  value : System.Single[]
		*/
		[native,unityengine_Camera_set_layerCullDistances]
		public final function set layerCullDistances(value:_Array_):void;

		/**
		* UnityEngine.Camera.get_layerCullSpherical
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_get_layerCullSpherical]
		public final function get layerCullSpherical():Boolean;

		/**
		* UnityEngine.Camera.set_layerCullSpherical
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_Camera_set_layerCullSpherical]
		public final function set layerCullSpherical(value:Boolean):void;

		/**
		* UnityEngine.Camera.CopyFrom
		*parameters:
		*  other : UnityEngine.Camera
		*/
		[native,unityengine_Camera_copyFrom];
		public final function copyFrom(other:Camera):void;

		/**
		* UnityEngine.Camera.get_depthTextureMode
		*return:
		*   UnityEngine.DepthTextureMode
		*/
		[native,unityengine_Camera_get_depthTextureMode]
		public final function get depthTextureMode():DepthTextureMode;

		/**
		* UnityEngine.Camera.set_depthTextureMode
		*parameters:
		*  value : UnityEngine.DepthTextureMode
		*/
		[native,unityengine_Camera_set_depthTextureMode]
		public final function set depthTextureMode(value:DepthTextureMode):void;

		/**
		* UnityEngine.Camera.get_clearStencilAfterLightingPass
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_get_clearStencilAfterLightingPass]
		public final function get clearStencilAfterLightingPass():Boolean;

		/**
		* UnityEngine.Camera.set_clearStencilAfterLightingPass
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_Camera_set_clearStencilAfterLightingPass]
		public final function set clearStencilAfterLightingPass(value:Boolean):void;

		/**
		* UnityEngine.Camera.get_fieldOfView
		*return:
		*   System.Single
		*/
		[native,unityengine_Camera_get_fieldOfView]
		public final function get fieldOfView():Number;

		/**
		* UnityEngine.Camera.set_fieldOfView
		*parameters:
		*  value : System.Single
		*/
		[native,unityengine_Camera_set_fieldOfView]
		public final function set fieldOfView(value:Number):void;

		/**
		* UnityEngine.Camera.get_nearClipPlane
		*return:
		*   System.Single
		*/
		[native,unityengine_Camera_get_nearClipPlane]
		public final function get nearClipPlane():Number;

		/**
		* UnityEngine.Camera.set_nearClipPlane
		*parameters:
		*  value : System.Single
		*/
		[native,unityengine_Camera_set_nearClipPlane]
		public final function set nearClipPlane(value:Number):void;

		/**
		* UnityEngine.Camera.get_farClipPlane
		*return:
		*   System.Single
		*/
		[native,unityengine_Camera_get_farClipPlane]
		public final function get farClipPlane():Number;

		/**
		* UnityEngine.Camera.set_farClipPlane
		*parameters:
		*  value : System.Single
		*/
		[native,unityengine_Camera_set_farClipPlane]
		public final function set farClipPlane(value:Number):void;

		/**
		* UnityEngine.Camera.get_renderingPath
		*return:
		*   UnityEngine.RenderingPath
		*/
		[native,unityengine_Camera_get_renderingPath]
		public final function get renderingPath():RenderingPath;

		/**
		* UnityEngine.Camera.set_renderingPath
		*parameters:
		*  value : UnityEngine.RenderingPath
		*/
		[native,unityengine_Camera_set_renderingPath]
		public final function set renderingPath(value:RenderingPath):void;

		/**
		* UnityEngine.Camera.get_actualRenderingPath
		*return:
		*   UnityEngine.RenderingPath
		*/
		[native,unityengine_Camera_get_actualRenderingPath]
		public final function get actualRenderingPath():RenderingPath;

		/**
		* UnityEngine.Camera.get_allowHDR
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_get_allowHDR]
		public final function get allowHDR():Boolean;

		/**
		* UnityEngine.Camera.set_allowHDR
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_Camera_set_allowHDR]
		public final function set allowHDR(value:Boolean):void;

		/**
		* UnityEngine.Camera.get_forceIntoRenderTexture
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_get_forceIntoRenderTexture]
		public final function get forceIntoRenderTexture():Boolean;

		/**
		* UnityEngine.Camera.set_forceIntoRenderTexture
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_Camera_set_forceIntoRenderTexture]
		public final function set forceIntoRenderTexture(value:Boolean):void;

		/**
		* UnityEngine.Camera.get_allowMSAA
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_get_allowMSAA]
		public final function get allowMSAA():Boolean;

		/**
		* UnityEngine.Camera.set_allowMSAA
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_Camera_set_allowMSAA]
		public final function set allowMSAA(value:Boolean):void;

		/**
		* UnityEngine.Camera.get_orthographicSize
		*return:
		*   System.Single
		*/
		[native,unityengine_Camera_get_orthographicSize]
		public final function get orthographicSize():Number;

		/**
		* UnityEngine.Camera.set_orthographicSize
		*parameters:
		*  value : System.Single
		*/
		[native,unityengine_Camera_set_orthographicSize]
		public final function set orthographicSize(value:Number):void;

		/**
		* UnityEngine.Camera.get_orthographic
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_get_orthographic]
		public final function get orthographic():Boolean;

		/**
		* UnityEngine.Camera.set_orthographic
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_Camera_set_orthographic]
		public final function set orthographic(value:Boolean):void;

		/**
		* UnityEngine.Camera.get_opaqueSortMode
		*return:
		*   UnityEngine.Rendering.OpaqueSortMode
		*/
		[native,unityengine_Camera_get_opaqueSortMode]
		public final function get opaqueSortMode():unityengine.rendering.OpaqueSortMode;

		/**
		* UnityEngine.Camera.set_opaqueSortMode
		*parameters:
		*  value : UnityEngine.Rendering.OpaqueSortMode
		*/
		[native,unityengine_Camera_set_opaqueSortMode]
		public final function set opaqueSortMode(value:unityengine.rendering.OpaqueSortMode):void;

		/**
		* UnityEngine.Camera.get_transparencySortMode
		*return:
		*   UnityEngine.TransparencySortMode
		*/
		[native,unityengine_Camera_get_transparencySortMode]
		public final function get transparencySortMode():TransparencySortMode;

		/**
		* UnityEngine.Camera.set_transparencySortMode
		*parameters:
		*  value : UnityEngine.TransparencySortMode
		*/
		[native,unityengine_Camera_set_transparencySortMode]
		public final function set transparencySortMode(value:TransparencySortMode):void;

		/**
		* UnityEngine.Camera.get_transparencySortAxis
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_Camera_get_transparencySortAxis]
		public final function get transparencySortAxis():Vector3;

		/**
		* UnityEngine.Camera.set_transparencySortAxis
		*parameters:
		*  value : UnityEngine.Vector3
		*/
		[native,unityengine_Camera_set_transparencySortAxis]
		public final function set transparencySortAxis(value:Vector3):void;

		/**
		* UnityEngine.Camera.get_depth
		*return:
		*   System.Single
		*/
		[native,unityengine_Camera_get_depth]
		public final function get depth():Number;

		/**
		* UnityEngine.Camera.set_depth
		*parameters:
		*  value : System.Single
		*/
		[native,unityengine_Camera_set_depth]
		public final function set depth(value:Number):void;

		/**
		* UnityEngine.Camera.get_aspect
		*return:
		*   System.Single
		*/
		[native,unityengine_Camera_get_aspect]
		public final function get aspect():Number;

		/**
		* UnityEngine.Camera.set_aspect
		*parameters:
		*  value : System.Single
		*/
		[native,unityengine_Camera_set_aspect]
		public final function set aspect(value:Number):void;

		/**
		* UnityEngine.Camera.get_cullingMask
		*return:
		*   System.Int32
		*/
		[native,unityengine_Camera_get_cullingMask]
		public final function get cullingMask():int;

		/**
		* UnityEngine.Camera.set_cullingMask
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_Camera_set_cullingMask]
		public final function set cullingMask(value:int):void;

		/**
		* UnityEngine.Camera.get_scene
		*return:
		*   UnityEngine.SceneManagement.Scene
		*/
		[native,unityengine_Camera_get_scene]
		public final function get scene():unityengine.scenemanagement.Scene;

		/**
		* UnityEngine.Camera.set_scene
		*parameters:
		*  value : UnityEngine.SceneManagement.Scene
		*/
		[native,unityengine_Camera_set_scene]
		public final function set scene(value:unityengine.scenemanagement.Scene):void;

		/**
		* UnityEngine.Camera.get_eventMask
		*return:
		*   System.Int32
		*/
		[native,unityengine_Camera_get_eventMask]
		public final function get eventMask():int;

		/**
		* UnityEngine.Camera.set_eventMask
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_Camera_set_eventMask]
		public final function set eventMask(value:int):void;

		/**
		* UnityEngine.Camera.get_backgroundColor
		*return:
		*   UnityEngine.Color
		*/
		[native,unityengine_Camera_get_backgroundColor]
		public final function get backgroundColor():Color;

		/**
		* UnityEngine.Camera.set_backgroundColor
		*parameters:
		*  value : UnityEngine.Color
		*/
		[native,unityengine_Camera_set_backgroundColor]
		public final function set backgroundColor(value:Color):void;

		/**
		* UnityEngine.Camera.get_rect
		*return:
		*   UnityEngine.Rect
		*/
		[native,unityengine_Camera_get_rect]
		public final function get rect():Rect;

		/**
		* UnityEngine.Camera.set_rect
		*parameters:
		*  value : UnityEngine.Rect
		*/
		[native,unityengine_Camera_set_rect]
		public final function set rect(value:Rect):void;

		/**
		* UnityEngine.Camera.get_pixelRect
		*return:
		*   UnityEngine.Rect
		*/
		[native,unityengine_Camera_get_pixelRect]
		public final function get pixelRect():Rect;

		/**
		* UnityEngine.Camera.set_pixelRect
		*parameters:
		*  value : UnityEngine.Rect
		*/
		[native,unityengine_Camera_set_pixelRect]
		public final function set pixelRect(value:Rect):void;

		/**
		* UnityEngine.Camera.get_targetTexture
		*return:
		*   UnityEngine.RenderTexture
		*/
		[native,unityengine_Camera_get_targetTexture]
		public final function get targetTexture():RenderTexture;

		/**
		* UnityEngine.Camera.set_targetTexture
		*parameters:
		*  value : UnityEngine.RenderTexture
		*/
		[native,unityengine_Camera_set_targetTexture]
		public final function set targetTexture(value:RenderTexture):void;

		/**
		* UnityEngine.Camera.get_activeTexture
		*return:
		*   UnityEngine.RenderTexture
		*/
		[native,unityengine_Camera_get_activeTexture]
		public final function get activeTexture():RenderTexture;

		/**
		* UnityEngine.Camera.SetTargetBuffers
		*parameters:
		*  colorBuffer : UnityEngine.RenderBuffer
		*  depthBuffer : UnityEngine.RenderBuffer
		*/
		[native,unityengine_Camera_setTargetBuffers];
		public final function setTargetBuffers(colorBuffer:RenderBuffer,depthBuffer:RenderBuffer):void;

		/**
		* UnityEngine.Camera.SetTargetBuffers
		*parameters:
		*  colorBuffer : UnityEngine.RenderBuffer[]
		*  depthBuffer : UnityEngine.RenderBuffer
		*/
		[native,unityengine_Camera_setTargetBuffers_];
		public final function setTargetBuffers_(colorBuffer:_Array_,depthBuffer:RenderBuffer):void;

		/**
		* UnityEngine.Camera.get_pixelWidth
		*return:
		*   System.Int32
		*/
		[native,unityengine_Camera_get_pixelWidth]
		public final function get pixelWidth():int;

		/**
		* UnityEngine.Camera.get_pixelHeight
		*return:
		*   System.Int32
		*/
		[native,unityengine_Camera_get_pixelHeight]
		public final function get pixelHeight():int;

		/**
		* UnityEngine.Camera.get_cameraToWorldMatrix
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_get_cameraToWorldMatrix]
		public final function get cameraToWorldMatrix():Matrix4x4;

		/**
		* UnityEngine.Camera.get_worldToCameraMatrix
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_get_worldToCameraMatrix]
		public final function get worldToCameraMatrix():Matrix4x4;

		/**
		* UnityEngine.Camera.set_worldToCameraMatrix
		*parameters:
		*  value : UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_set_worldToCameraMatrix]
		public final function set worldToCameraMatrix(value:Matrix4x4):void;

		/**
		* UnityEngine.Camera.ResetWorldToCameraMatrix
		*/
		[native,unityengine_Camera_resetWorldToCameraMatrix];
		public final function resetWorldToCameraMatrix():void;

		/**
		* UnityEngine.Camera.get_projectionMatrix
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_get_projectionMatrix]
		public final function get projectionMatrix():Matrix4x4;

		/**
		* UnityEngine.Camera.set_projectionMatrix
		*parameters:
		*  value : UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_set_projectionMatrix]
		public final function set projectionMatrix(value:Matrix4x4):void;

		/**
		* UnityEngine.Camera.get_nonJitteredProjectionMatrix
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_get_nonJitteredProjectionMatrix]
		public final function get nonJitteredProjectionMatrix():Matrix4x4;

		/**
		* UnityEngine.Camera.set_nonJitteredProjectionMatrix
		*parameters:
		*  value : UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_set_nonJitteredProjectionMatrix]
		public final function set nonJitteredProjectionMatrix(value:Matrix4x4):void;

		/**
		* UnityEngine.Camera.get_useJitteredProjectionMatrixForTransparentRendering
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Camera_get_useJitteredProjectionMatrixForTransparentRendering]
		public final function get useJitteredProjectionMatrixForTransparentRendering():Boolean;

		/**
		* UnityEngine.Camera.set_useJitteredProjectionMatrixForTransparentRendering
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_Camera_set_useJitteredProjectionMatrixForTransparentRendering]
		public final function set useJitteredProjectionMatrixForTransparentRendering(value:Boolean):void;

		/**
		* UnityEngine.Camera.get_previousViewProjectionMatrix
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_Camera_get_previousViewProjectionMatrix]
		public final function get previousViewProjectionMatrix():Matrix4x4;

		/**
		* UnityEngine.Camera.ResetProjectionMatrix
		*/
		[native,unityengine_Camera_resetProjectionMatrix];
		public final function resetProjectionMatrix():void;

		/**
		* UnityEngine.Camera.ResetAspect
		*/
		[native,unityengine_Camera_resetAspect];
		public final function resetAspect():void;


	}
}
