package unityengine
{
	import system._Array_;
	import system.collections.generic.List_Of_Component;
	import system._Object_;


		/**
		*  UnityEngine.Component
		*/
	[link_system]
	public class Component extends UObject
	{
		[creator];
		[native,unityengine_Component_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Component_ctor];
		public function Component();

		//*********跨语言继承适配器*******
		[crossextendadapter];
		[native,_unityengine_ComponentAdapter_ctor];
		private function _ComponentAdapter();


		//*********公共方法*******
		/**
		* UnityEngine.Component.get_transform
		*return:
		*   UnityEngine.Transform
		*/
		[native,unityengine_Component_get_transform]
		public final function get transform():Transform;

		/**
		* UnityEngine.Component.get_gameObject
		*return:
		*   UnityEngine.GameObject
		*/
		[native,unityengine_Component_get_gameObject]
		public final function get gameObject():GameObject;

		/**
		* UnityEngine.Component.GetComponent
		*parameters:
		*  type : System.Type
		*return:
		*   UnityEngine.Component
		*/
		[native,unityengine_Component_getComponent];
		public final function getComponent(type:Class):Component;

		/**
		* UnityEngine.Component.GetComponent
		*parameters:
		*  type : System.String
		*return:
		*   UnityEngine.Component
		*/
		[native,unityengine_Component_getComponent__];
		public final function getComponent__(type:String):Component;

		/**
		* UnityEngine.Component.GetComponentInChildren
		*parameters:
		*  t : System.Type
		*  includeInactive : System.Boolean
		*return:
		*   UnityEngine.Component
		*/
		[native,unityengine_Component_getComponentInChildren];
		public final function getComponentInChildren(t:Class,includeInactive:Boolean):Component;

		/**
		* UnityEngine.Component.GetComponentInChildren
		*parameters:
		*  t : System.Type
		*return:
		*   UnityEngine.Component
		*/
		[native,unityengine_Component_getComponentInChildren_];
		public final function getComponentInChildren_(t:Class):Component;

		/**
		* UnityEngine.Component.GetComponentsInChildren
		*parameters:
		*  t : System.Type
		*return:
		*   UnityEngine.Component[]
		*/
		[native,unityengine_Component_getComponentsInChildren];
		public final function getComponentsInChildren(t:Class):_Array_;

		/**
		* UnityEngine.Component.GetComponentsInChildren
		*parameters:
		*  t : System.Type
		*  includeInactive : System.Boolean
		*return:
		*   UnityEngine.Component[]
		*/
		[native,unityengine_Component_getComponentsInChildren_];
		public final function getComponentsInChildren_(t:Class,includeInactive:Boolean):_Array_;

		/**
		* UnityEngine.Component.GetComponentInParent
		*parameters:
		*  t : System.Type
		*return:
		*   UnityEngine.Component
		*/
		[native,unityengine_Component_getComponentInParent];
		public final function getComponentInParent(t:Class):Component;

		/**
		* UnityEngine.Component.GetComponentsInParent
		*parameters:
		*  t : System.Type
		*return:
		*   UnityEngine.Component[]
		*/
		[native,unityengine_Component_getComponentsInParent];
		public final function getComponentsInParent(t:Class):_Array_;

		/**
		* UnityEngine.Component.GetComponentsInParent
		*parameters:
		*  t : System.Type
		*  includeInactive : System.Boolean
		*return:
		*   UnityEngine.Component[]
		*/
		[native,unityengine_Component_getComponentsInParent_];
		public final function getComponentsInParent_(t:Class,includeInactive:Boolean):_Array_;

		/**
		* UnityEngine.Component.GetComponents
		*parameters:
		*  type : System.Type
		*return:
		*   UnityEngine.Component[]
		*/
		[native,unityengine_Component_getComponents];
		public final function getComponents(type:Class):_Array_;

		/**
		* UnityEngine.Component.GetComponents
		*parameters:
		*  type : System.Type
		*  results : System.Collections.Generic.List &lt; UnityEngine.Component &gt; 
		*/
		[native,unityengine_Component_getComponents_];
		public final function getComponents_(type:Class,results:system.collections.generic.List_Of_Component):void;

		/**
		* UnityEngine.Component.get_tag
		*return:
		*   System.String
		*/
		[native,unityengine_Component_get_tag]
		public final function get tag():String;

		/**
		* UnityEngine.Component.set_tag
		*parameters:
		*  value : System.String
		*/
		[native,unityengine_Component_set_tag]
		public final function set tag(value:String):void;

		/**
		* UnityEngine.Component.CompareTag
		*parameters:
		*  tag : System.String
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Component_compareTag];
		public final function compareTag(tag:String):Boolean;

		/**
		* UnityEngine.Component.SendMessageUpwards
		*parameters:
		*  methodName : System.String
		*  value : System.Object
		*  options : UnityEngine.SendMessageOptions
		*/
		[native,unityengine_Component_sendMessageUpwards];
		public final function sendMessageUpwards(methodName:String,value:system._Object_,options:SendMessageOptions):void;

		/**
		* UnityEngine.Component.SendMessage
		*parameters:
		*  methodName : System.String
		*  value : System.Object
		*  options : UnityEngine.SendMessageOptions
		*/
		[native,unityengine_Component_sendMessage];
		public final function sendMessage(methodName:String,value:system._Object_,options:SendMessageOptions):void;

		/**
		* UnityEngine.Component.BroadcastMessage
		*parameters:
		*  methodName : System.String
		*  parameter : System.Object
		*  options : UnityEngine.SendMessageOptions
		*/
		[native,unityengine_Component_broadcastMessage];
		public final function broadcastMessage(methodName:String,parameter:system._Object_,options:SendMessageOptions):void;


	}
}
