package unityengine
{
	import system._Array_;
	import system.IntPtr;


		/**
		* Sealed
		*  UnityEngine.Cubemap
		*/
	[link_system]
	public final class Cubemap extends Texture
	{
		[creator];
		[native,unityengine_Cubemap_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Cubemap_ctor];
		public function Cubemap(size:int,format:TextureFormat,mipmap:Boolean);


		//*********公共方法*******
		/**
		* UnityEngine.Cubemap.SetPixel
		*parameters:
		*  face : UnityEngine.CubemapFace
		*  x : System.Int32
		*  y : System.Int32
		*  color : UnityEngine.Color
		*/
		[native,unityengine_Cubemap_setPixel];
		public final function setPixel(face:CubemapFace,x:int,y:int,color:Color):void;

		/**
		* UnityEngine.Cubemap.GetPixel
		*parameters:
		*  face : UnityEngine.CubemapFace
		*  x : System.Int32
		*  y : System.Int32
		*return:
		*   UnityEngine.Color
		*/
		[native,unityengine_Cubemap_getPixel];
		public final function getPixel(face:CubemapFace,x:int,y:int):Color;

		/**
		* UnityEngine.Cubemap.GetPixels
		*parameters:
		*  face : UnityEngine.CubemapFace
		*  miplevel : System.Int32
		*return:
		*   UnityEngine.Color[]
		*/
		[native,unityengine_Cubemap_getPixels];
		public final function getPixels(face:CubemapFace,miplevel:int):_Array_;

		/**
		* UnityEngine.Cubemap.GetPixels
		*parameters:
		*  face : UnityEngine.CubemapFace
		*return:
		*   UnityEngine.Color[]
		*/
		[native,unityengine_Cubemap_getPixels_];
		public final function getPixels_(face:CubemapFace):_Array_;

		/**
		* UnityEngine.Cubemap.SetPixels
		*parameters:
		*  colors : UnityEngine.Color[]
		*  face : UnityEngine.CubemapFace
		*  miplevel : System.Int32
		*/
		[native,unityengine_Cubemap_setPixels];
		public final function setPixels(colors:_Array_,face:CubemapFace,miplevel:int):void;

		/**
		* UnityEngine.Cubemap.SetPixels
		*parameters:
		*  colors : UnityEngine.Color[]
		*  face : UnityEngine.CubemapFace
		*/
		[native,unityengine_Cubemap_setPixels_];
		public final function setPixels_(colors:_Array_,face:CubemapFace):void;

		/**
		* UnityEngine.Cubemap.get_mipmapCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_Cubemap_get_mipmapCount]
		public final function get mipmapCount():int;

		/**
		* UnityEngine.Cubemap.Apply
		*parameters:
		*  updateMipmaps : System.Boolean
		*  makeNoLongerReadable : System.Boolean
		*/
		[native,unityengine_Cubemap_apply];
		public final function apply(updateMipmaps:Boolean,makeNoLongerReadable:Boolean):void;

		/**
		* UnityEngine.Cubemap.Apply
		*parameters:
		*  updateMipmaps : System.Boolean
		*/
		[native,unityengine_Cubemap_apply_];
		public final function apply_(updateMipmaps:Boolean):void;

		/**
		* UnityEngine.Cubemap.Apply
		*/
		[native,unityengine_Cubemap_apply__];
		public final function apply__():void;

		/**
		* UnityEngine.Cubemap.get_format
		*return:
		*   UnityEngine.TextureFormat
		*/
		[native,unityengine_Cubemap_get_format]
		public final function get format():TextureFormat;

		/**
		* UnityEngine.Cubemap.CreateExternalTexture
		*parameters:
		*  size : System.Int32
		*  format : UnityEngine.TextureFormat
		*  mipmap : System.Boolean
		*  nativeTex : System.IntPtr
		*return:
		*   UnityEngine.Cubemap
		*/
		[native,static_unityengine_Cubemap_createExternalTexture];
		public static function createExternalTexture(size:int,format:TextureFormat,mipmap:Boolean,nativeTex:system.IntPtr):Cubemap;

		/**
		* UnityEngine.Cubemap.SmoothEdges
		*parameters:
		*  smoothRegionWidthInPixels : System.Int32
		*/
		[native,unityengine_Cubemap_smoothEdges];
		public final function smoothEdges(smoothRegionWidthInPixels:int):void;

		/**
		* UnityEngine.Cubemap.SmoothEdges
		*/
		[native,unityengine_Cubemap_smoothEdges_];
		public final function smoothEdges_():void;


	}
}
