package unityengine
{
	import system._Object_;
	import system.IntPtr;


		/**
		* Sealed
		*  UnityEngine.GL
		*/
	[link_system]
	public final class GL extends system._Object_
	{
		[creator];
		[native,unityengine_GL_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_GL_ctor];
		public function GL();


		//*********字段*******
		/**
		* UnityEngine.GL.TRIANGLES
		*fieldtype:
		*   System.Int32
		*/
		[native, unityengine_GL_TRIANGLES_getter];
		public static const TRIANGLES:int;
		/**
		* UnityEngine.GL.TRIANGLE_STRIP
		*fieldtype:
		*   System.Int32
		*/
		[native, unityengine_GL_TRIANGLE_STRIP_getter];
		public static const TRIANGLE_STRIP:int;
		/**
		* UnityEngine.GL.QUADS
		*fieldtype:
		*   System.Int32
		*/
		[native, unityengine_GL_QUADS_getter];
		public static const QUADS:int;
		/**
		* UnityEngine.GL.LINES
		*fieldtype:
		*   System.Int32
		*/
		[native, unityengine_GL_LINES_getter];
		public static const LINES:int;
		/**
		* UnityEngine.GL.LINE_STRIP
		*fieldtype:
		*   System.Int32
		*/
		[native, unityengine_GL_LINE_STRIP_getter];
		public static const LINE_STRIP:int;

		//*********公共方法*******
		/**
		* UnityEngine.GL.Vertex3
		*parameters:
		*  x : System.Single
		*  y : System.Single
		*  z : System.Single
		*/
		[native,static_unityengine_GL_vertex3];
		public static function vertex3(x:Number,y:Number,z:Number):void;

		/**
		* UnityEngine.GL.Vertex
		*parameters:
		*  v : UnityEngine.Vector3
		*/
		[native,static_unityengine_GL_vertex];
		public static function vertex(v:Vector3):void;

		/**
		* UnityEngine.GL.Color
		*parameters:
		*  c : UnityEngine.Color
		*/
		[native,static_unityengine_GL_color];
		public static function color(c:Color):void;

		/**
		* UnityEngine.GL.TexCoord
		*parameters:
		*  v : UnityEngine.Vector3
		*/
		[native,static_unityengine_GL_texCoord];
		public static function texCoord(v:Vector3):void;

		/**
		* UnityEngine.GL.TexCoord2
		*parameters:
		*  x : System.Single
		*  y : System.Single
		*/
		[native,static_unityengine_GL_texCoord2];
		public static function texCoord2(x:Number,y:Number):void;

		/**
		* UnityEngine.GL.TexCoord3
		*parameters:
		*  x : System.Single
		*  y : System.Single
		*  z : System.Single
		*/
		[native,static_unityengine_GL_texCoord3];
		public static function texCoord3(x:Number,y:Number,z:Number):void;

		/**
		* UnityEngine.GL.MultiTexCoord2
		*parameters:
		*  unit : System.Int32
		*  x : System.Single
		*  y : System.Single
		*/
		[native,static_unityengine_GL_multiTexCoord2];
		public static function multiTexCoord2(unit:int,x:Number,y:Number):void;

		/**
		* UnityEngine.GL.MultiTexCoord3
		*parameters:
		*  unit : System.Int32
		*  x : System.Single
		*  y : System.Single
		*  z : System.Single
		*/
		[native,static_unityengine_GL_multiTexCoord3];
		public static function multiTexCoord3(unit:int,x:Number,y:Number,z:Number):void;

		/**
		* UnityEngine.GL.MultiTexCoord
		*parameters:
		*  unit : System.Int32
		*  v : UnityEngine.Vector3
		*/
		[native,static_unityengine_GL_multiTexCoord];
		public static function multiTexCoord(unit:int,v:Vector3):void;

		/**
		* UnityEngine.GL.Begin
		*parameters:
		*  mode : System.Int32
		*/
		[native,static_unityengine_GL_begin];
		public static function begin(mode:int):void;

		/**
		* UnityEngine.GL.End
		*/
		[native,static_unityengine_GL_end];
		public static function end():void;

		/**
		* UnityEngine.GL.PushMatrix
		*/
		[native,static_unityengine_GL_pushMatrix];
		public static function pushMatrix():void;

		/**
		* UnityEngine.GL.PopMatrix
		*/
		[native,static_unityengine_GL_popMatrix];
		public static function popMatrix():void;

		/**
		* UnityEngine.GL.LoadIdentity
		*/
		[native,static_unityengine_GL_loadIdentity];
		public static function loadIdentity():void;

		/**
		* UnityEngine.GL.LoadOrtho
		*/
		[native,static_unityengine_GL_loadOrtho];
		public static function loadOrtho():void;

		/**
		* UnityEngine.GL.LoadPixelMatrix
		*/
		[native,static_unityengine_GL_loadPixelMatrix];
		public static function loadPixelMatrix():void;

		/**
		* UnityEngine.GL.LoadPixelMatrix
		*parameters:
		*  left : System.Single
		*  right : System.Single
		*  bottom : System.Single
		*  top : System.Single
		*/
		[native,static_unityengine_GL_loadPixelMatrix_];
		public static function loadPixelMatrix_(left:Number,right:Number,bottom:Number,top:Number):void;

		/**
		* UnityEngine.GL.Viewport
		*parameters:
		*  pixelRect : UnityEngine.Rect
		*/
		[native,static_unityengine_GL_viewport];
		public static function viewport(pixelRect:Rect):void;

		/**
		* UnityEngine.GL.LoadProjectionMatrix
		*parameters:
		*  mat : UnityEngine.Matrix4x4
		*/
		[native,static_unityengine_GL_loadProjectionMatrix];
		public static function loadProjectionMatrix(mat:Matrix4x4):void;

		/**
		* UnityEngine.GL.get_modelview
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,static_unityengine_GL_get_modelview]
		public static function get modelview():Matrix4x4;

		/**
		* UnityEngine.GL.set_modelview
		*parameters:
		*  value : UnityEngine.Matrix4x4
		*/
		[native,static_unityengine_GL_set_modelview]
		public static function set modelview(value:Matrix4x4):void;

		/**
		* UnityEngine.GL.MultMatrix
		*parameters:
		*  mat : UnityEngine.Matrix4x4
		*/
		[native,static_unityengine_GL_multMatrix];
		public static function multMatrix(mat:Matrix4x4):void;

		/**
		* UnityEngine.GL.GetGPUProjectionMatrix
		*parameters:
		*  proj : UnityEngine.Matrix4x4
		*  renderIntoTexture : System.Boolean
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,static_unityengine_GL_getGPUProjectionMatrix];
		public static function getGPUProjectionMatrix(proj:Matrix4x4,renderIntoTexture:Boolean):Matrix4x4;

		/**
		* UnityEngine.GL.get_wireframe
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_GL_get_wireframe]
		public static function get wireframe():Boolean;

		/**
		* UnityEngine.GL.set_wireframe
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_GL_set_wireframe]
		public static function set wireframe(value:Boolean):void;

		/**
		* UnityEngine.GL.get_sRGBWrite
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_GL_get_sRGBWrite]
		public static function get sRGBWrite():Boolean;

		/**
		* UnityEngine.GL.set_sRGBWrite
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_GL_set_sRGBWrite]
		public static function set sRGBWrite(value:Boolean):void;

		/**
		* UnityEngine.GL.get_invertCulling
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_GL_get_invertCulling]
		public static function get invertCulling():Boolean;

		/**
		* UnityEngine.GL.set_invertCulling
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_GL_set_invertCulling]
		public static function set invertCulling(value:Boolean):void;

		/**
		* UnityEngine.GL.Clear
		*parameters:
		*  clearDepth : System.Boolean
		*  clearColor : System.Boolean
		*  backgroundColor : UnityEngine.Color
		*/
		[native,static_unityengine_GL_clear];
		public static function clear(clearDepth:Boolean,clearColor:Boolean,backgroundColor:Color):void;

		/**
		* UnityEngine.GL.Clear
		*parameters:
		*  clearDepth : System.Boolean
		*  clearColor : System.Boolean
		*  backgroundColor : UnityEngine.Color
		*  depth : System.Single
		*/
		[native,static_unityengine_GL_clear_];
		public static function clear_(clearDepth:Boolean,clearColor:Boolean,backgroundColor:Color,depth:Number):void;

		/**
		* UnityEngine.GL.ClearWithSkybox
		*parameters:
		*  clearDepth : System.Boolean
		*  camera : UnityEngine.Camera
		*/
		[native,static_unityengine_GL_clearWithSkybox];
		public static function clearWithSkybox(clearDepth:Boolean,camera:Camera):void;

		/**
		* UnityEngine.GL.Flush
		*/
		[native,static_unityengine_GL_flush];
		public static function flush():void;

		/**
		* UnityEngine.GL.InvalidateState
		*/
		[native,static_unityengine_GL_invalidateState];
		public static function invalidateState():void;

		/**
		* UnityEngine.GL.IssuePluginEvent
		*parameters:
		*  callback : System.IntPtr
		*  eventID : System.Int32
		*/
		[native,static_unityengine_GL_issuePluginEvent_];
		public static function issuePluginEvent_(callback:system.IntPtr,eventID:int):void;

		/**
		* UnityEngine.GL.RenderTargetBarrier
		*/
		[native,static_unityengine_GL_renderTargetBarrier];
		public static function renderTargetBarrier():void;


	}
}
