package unityengine
{
	import system._Array_;
	import system.collections.generic.List_Of_Component;
	import system._Object_;
	import unityengine.scenemanagement.Scene;


		/**
		* Sealed
		*  UnityEngine.GameObject
		*/
	[link_system]
	public final class GameObject extends UObject
	{
		[creator];
		[native,unityengine_GameObject_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_GameObject_constructor_];
		public static function constructor_():GameObject;

		[native,unityengine_GameObject_constructor__];
		public static function constructor__(name:String,components:_Array_):GameObject;

		[native,unityengine_GameObject_ctor];
		public function GameObject(name:String);


		//*********公共方法*******
		/**
		* UnityEngine.GameObject.CreatePrimitive
		*parameters:
		*  type : UnityEngine.PrimitiveType
		*return:
		*   UnityEngine.GameObject
		*/
		[native,static_unityengine_GameObject_createPrimitive];
		public static function createPrimitive(type:PrimitiveType):GameObject;

		/**
		* UnityEngine.GameObject.GetComponent
		*parameters:
		*  type : System.Type
		*return:
		*   UnityEngine.Component
		*/
		[native,unityengine_GameObject_getComponent];
		public final function getComponent(type:Class):Component;

		/**
		* UnityEngine.GameObject.GetComponent
		*parameters:
		*  type : System.String
		*return:
		*   UnityEngine.Component
		*/
		[native,unityengine_GameObject_getComponent__];
		public final function getComponent__(type:String):Component;

		/**
		* UnityEngine.GameObject.GetComponentInChildren
		*parameters:
		*  type : System.Type
		*  includeInactive : System.Boolean
		*return:
		*   UnityEngine.Component
		*/
		[native,unityengine_GameObject_getComponentInChildren];
		public final function getComponentInChildren(type:Class,includeInactive:Boolean):Component;

		/**
		* UnityEngine.GameObject.GetComponentInChildren
		*parameters:
		*  type : System.Type
		*return:
		*   UnityEngine.Component
		*/
		[native,unityengine_GameObject_getComponentInChildren_];
		public final function getComponentInChildren_(type:Class):Component;

		/**
		* UnityEngine.GameObject.GetComponentInParent
		*parameters:
		*  type : System.Type
		*return:
		*   UnityEngine.Component
		*/
		[native,unityengine_GameObject_getComponentInParent];
		public final function getComponentInParent(type:Class):Component;

		/**
		* UnityEngine.GameObject.GetComponents
		*parameters:
		*  type : System.Type
		*return:
		*   UnityEngine.Component[]
		*/
		[native,unityengine_GameObject_getComponents];
		public final function getComponents(type:Class):_Array_;

		/**
		* UnityEngine.GameObject.GetComponents
		*parameters:
		*  type : System.Type
		*  results : System.Collections.Generic.List &lt; UnityEngine.Component &gt; 
		*/
		[native,unityengine_GameObject_getComponents__];
		public final function getComponents__(type:Class,results:system.collections.generic.List_Of_Component):void;

		/**
		* UnityEngine.GameObject.GetComponentsInChildren
		*parameters:
		*  type : System.Type
		*return:
		*   UnityEngine.Component[]
		*/
		[native,unityengine_GameObject_getComponentsInChildren];
		public final function getComponentsInChildren(type:Class):_Array_;

		/**
		* UnityEngine.GameObject.GetComponentsInChildren
		*parameters:
		*  type : System.Type
		*  includeInactive : System.Boolean
		*return:
		*   UnityEngine.Component[]
		*/
		[native,unityengine_GameObject_getComponentsInChildren_];
		public final function getComponentsInChildren_(type:Class,includeInactive:Boolean):_Array_;

		/**
		* UnityEngine.GameObject.GetComponentsInParent
		*parameters:
		*  type : System.Type
		*return:
		*   UnityEngine.Component[]
		*/
		[native,unityengine_GameObject_getComponentsInParent];
		public final function getComponentsInParent(type:Class):_Array_;

		/**
		* UnityEngine.GameObject.GetComponentsInParent
		*parameters:
		*  type : System.Type
		*  includeInactive : System.Boolean
		*return:
		*   UnityEngine.Component[]
		*/
		[native,unityengine_GameObject_getComponentsInParent_];
		public final function getComponentsInParent_(type:Class,includeInactive:Boolean):_Array_;

		/**
		* UnityEngine.GameObject.get_transform
		*return:
		*   UnityEngine.Transform
		*/
		[native,unityengine_GameObject_get_transform]
		public final function get transform():Transform;

		/**
		* UnityEngine.GameObject.get_layer
		*return:
		*   System.Int32
		*/
		[native,unityengine_GameObject_get_layer]
		public final function get layer():int;

		/**
		* UnityEngine.GameObject.set_layer
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_GameObject_set_layer]
		public final function set layer(value:int):void;

		/**
		* UnityEngine.GameObject.SetActive
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_GameObject_setActive];
		public final function setActive(value:Boolean):void;

		/**
		* UnityEngine.GameObject.get_activeSelf
		*return:
		*   System.Boolean
		*/
		[native,unityengine_GameObject_get_activeSelf]
		public final function get activeSelf():Boolean;

		/**
		* UnityEngine.GameObject.get_activeInHierarchy
		*return:
		*   System.Boolean
		*/
		[native,unityengine_GameObject_get_activeInHierarchy]
		public final function get activeInHierarchy():Boolean;

		/**
		* UnityEngine.GameObject.get_isStatic
		*return:
		*   System.Boolean
		*/
		[native,unityengine_GameObject_get_isStatic]
		public final function get isStatic():Boolean;

		/**
		* UnityEngine.GameObject.set_isStatic
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_GameObject_set_isStatic]
		public final function set isStatic(value:Boolean):void;

		/**
		* UnityEngine.GameObject.get_tag
		*return:
		*   System.String
		*/
		[native,unityengine_GameObject_get_tag]
		public final function get tag():String;

		/**
		* UnityEngine.GameObject.set_tag
		*parameters:
		*  value : System.String
		*/
		[native,unityengine_GameObject_set_tag]
		public final function set tag(value:String):void;

		/**
		* UnityEngine.GameObject.CompareTag
		*parameters:
		*  tag : System.String
		*return:
		*   System.Boolean
		*/
		[native,unityengine_GameObject_compareTag];
		public final function compareTag(tag:String):Boolean;

		/**
		* UnityEngine.GameObject.FindGameObjectWithTag
		*parameters:
		*  tag : System.String
		*return:
		*   UnityEngine.GameObject
		*/
		[native,static_unityengine_GameObject_findGameObjectWithTag];
		public static function findGameObjectWithTag(tag:String):GameObject;

		/**
		* UnityEngine.GameObject.FindWithTag
		*parameters:
		*  tag : System.String
		*return:
		*   UnityEngine.GameObject
		*/
		[native,static_unityengine_GameObject_findWithTag];
		public static function findWithTag(tag:String):GameObject;

		/**
		* UnityEngine.GameObject.FindGameObjectsWithTag
		*parameters:
		*  tag : System.String
		*return:
		*   UnityEngine.GameObject[]
		*/
		[native,static_unityengine_GameObject_findGameObjectsWithTag];
		public static function findGameObjectsWithTag(tag:String):_Array_;

		/**
		* UnityEngine.GameObject.SendMessageUpwards
		*parameters:
		*  methodName : System.String
		*  value : System.Object
		*  options : UnityEngine.SendMessageOptions
		*/
		[native,unityengine_GameObject_sendMessageUpwards];
		public final function sendMessageUpwards(methodName:String,value:system._Object_,options:SendMessageOptions):void;

		/**
		* UnityEngine.GameObject.SendMessage
		*parameters:
		*  methodName : System.String
		*  value : System.Object
		*  options : UnityEngine.SendMessageOptions
		*/
		[native,unityengine_GameObject_sendMessage];
		public final function sendMessage(methodName:String,value:system._Object_,options:SendMessageOptions):void;

		/**
		* UnityEngine.GameObject.BroadcastMessage
		*parameters:
		*  methodName : System.String
		*  parameter : System.Object
		*  options : UnityEngine.SendMessageOptions
		*/
		[native,unityengine_GameObject_broadcastMessage];
		public final function broadcastMessage(methodName:String,parameter:system._Object_,options:SendMessageOptions):void;

		/**
		* UnityEngine.GameObject.AddComponent
		*parameters:
		*  componentType : System.Type
		*return:
		*   UnityEngine.Component
		*/
		[native,unityengine_GameObject_addComponent];
		public final function addComponent(componentType:Class):Component;

		/**
		* UnityEngine.GameObject.Find
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.GameObject
		*/
		[native,static_unityengine_GameObject_find];
		public static function find(name:String):GameObject;

		/**
		* UnityEngine.GameObject.get_scene
		*return:
		*   UnityEngine.SceneManagement.Scene
		*/
		[native,unityengine_GameObject_get_scene]
		public final function get scene():unityengine.scenemanagement.Scene;

		/**
		* UnityEngine.GameObject.get_gameObject
		*return:
		*   UnityEngine.GameObject
		*/
		[native,unityengine_GameObject_get_gameObject]
		public final function get gameObject():GameObject;


	}
}
