package unityengine
{
	import system._Object_;
	import system._Array_;


	[link_system_interface(unityengine_ILogger_creator)]
	public interface ILogger extends ILogHandler
	{
		[native,unityengine_ILogger_get_logHandler]
		function get logHandler():ILogHandler;

		[native,unityengine_ILogger_set_logHandler]
		function set logHandler(value:ILogHandler):void;

		[native,unityengine_ILogger_get_logEnabled]
		function get logEnabled():Boolean;

		[native,unityengine_ILogger_set_logEnabled]
		function set logEnabled(value:Boolean):void;

		[native,unityengine_ILogger_get_filterLogType]
		function get filterLogType():LogType;

		[native,unityengine_ILogger_set_filterLogType]
		function set filterLogType(value:LogType):void;

		[native,unityengine_ILogger_isLogTypeAllowed]
		function isLogTypeAllowed(logType:LogType):Boolean;

		[native,unityengine_ILogger_log]
		function log(logType:LogType,message:system._Object_):void;

		[native,unityengine_ILogger_log_]
		function log_(logType:LogType,message:system._Object_,context:UObject):void;

		[native,unityengine_ILogger_log__]
		function log__(logType:LogType,tag:String,message:system._Object_):void;

		[native,unityengine_ILogger_log___]
		function log___(logType:LogType,tag:String,message:system._Object_,context:UObject):void;

		[native,unityengine_ILogger_log____]
		function log____(message:system._Object_):void;

		[native,unityengine_ILogger_log_____]
		function log_____(tag:String,message:system._Object_):void;

		[native,unityengine_ILogger_log______]
		function log______(tag:String,message:system._Object_,context:UObject):void;

		[native,unityengine_ILogger_logWarning]
		function logWarning(tag:String,message:system._Object_):void;

		[native,unityengine_ILogger_logWarning_]
		function logWarning_(tag:String,message:system._Object_,context:UObject):void;

		[native,unityengine_ILogger_logError]
		function logError(tag:String,message:system._Object_):void;

		[native,unityengine_ILogger_logError_]
		function logError_(tag:String,message:system._Object_,context:UObject):void;

		[native,unityengine_ILogger_logFormat_]
		function logFormat_(logType:LogType,format:String,args:_Array_):void;

	}
}
