package unityengine
{
	import system._Object_;
	import system._Array_;


		/**
		* Sealed
		*  UnityEngine.Input
		*/
	[link_system]
	public final class Input extends system._Object_
	{
		[creator];
		[native,unityengine_Input_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Input_ctor];
		public function Input();


		//*********公共方法*******
		/**
		* UnityEngine.Input.GetAxis
		*parameters:
		*  axisName : System.String
		*return:
		*   System.Single
		*/
		[native,static_unityengine_Input_getAxis];
		public static function getAxis(axisName:String):Number;

		/**
		* UnityEngine.Input.GetAxisRaw
		*parameters:
		*  axisName : System.String
		*return:
		*   System.Single
		*/
		[native,static_unityengine_Input_getAxisRaw];
		public static function getAxisRaw(axisName:String):Number;

		/**
		* UnityEngine.Input.GetButton
		*parameters:
		*  buttonName : System.String
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_getButton];
		public static function getButton(buttonName:String):Boolean;

		/**
		* UnityEngine.Input.get_compensateSensors
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_get_compensateSensors]
		public static function get compensateSensors():Boolean;

		/**
		* UnityEngine.Input.set_compensateSensors
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_Input_set_compensateSensors]
		public static function set compensateSensors(value:Boolean):void;

		/**
		* UnityEngine.Input.get_gyro
		*return:
		*   UnityEngine.Gyroscope
		*/
		[native,static_unityengine_Input_get_gyro]
		public static function get gyro():Gyroscope;

		/**
		* UnityEngine.Input.GetButtonDown
		*parameters:
		*  buttonName : System.String
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_getButtonDown];
		public static function getButtonDown(buttonName:String):Boolean;

		/**
		* UnityEngine.Input.GetButtonUp
		*parameters:
		*  buttonName : System.String
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_getButtonUp];
		public static function getButtonUp(buttonName:String):Boolean;

		/**
		* UnityEngine.Input.GetKey
		*parameters:
		*  name : System.String
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_getKey];
		public static function getKey(name:String):Boolean;

		/**
		* UnityEngine.Input.GetKey
		*parameters:
		*  key : UnityEngine.KeyCode
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_getKey_];
		public static function getKey_(key:KeyCode):Boolean;

		/**
		* UnityEngine.Input.GetKeyDown
		*parameters:
		*  name : System.String
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_getKeyDown];
		public static function getKeyDown(name:String):Boolean;

		/**
		* UnityEngine.Input.GetKeyDown
		*parameters:
		*  key : UnityEngine.KeyCode
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_getKeyDown_];
		public static function getKeyDown_(key:KeyCode):Boolean;

		/**
		* UnityEngine.Input.GetKeyUp
		*parameters:
		*  name : System.String
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_getKeyUp];
		public static function getKeyUp(name:String):Boolean;

		/**
		* UnityEngine.Input.GetKeyUp
		*parameters:
		*  key : UnityEngine.KeyCode
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_getKeyUp_];
		public static function getKeyUp_(key:KeyCode):Boolean;

		/**
		* UnityEngine.Input.GetJoystickNames
		*return:
		*   System.String[]
		*/
		[native,static_unityengine_Input_getJoystickNames];
		public static function getJoystickNames():_Array_;

		/**
		* UnityEngine.Input.GetMouseButton
		*parameters:
		*  button : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_getMouseButton];
		public static function getMouseButton(button:int):Boolean;

		/**
		* UnityEngine.Input.GetMouseButtonDown
		*parameters:
		*  button : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_getMouseButtonDown];
		public static function getMouseButtonDown(button:int):Boolean;

		/**
		* UnityEngine.Input.GetMouseButtonUp
		*parameters:
		*  button : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_getMouseButtonUp];
		public static function getMouseButtonUp(button:int):Boolean;

		/**
		* UnityEngine.Input.ResetInputAxes
		*/
		[native,static_unityengine_Input_resetInputAxes];
		public static function resetInputAxes():void;

		/**
		* UnityEngine.Input.get_mousePosition
		*return:
		*   UnityEngine.Vector3
		*/
		[native,static_unityengine_Input_get_mousePosition]
		public static function get mousePosition():Vector3;

		/**
		* UnityEngine.Input.get_mouseScrollDelta
		*return:
		*   UnityEngine.Vector2
		*/
		[native,static_unityengine_Input_get_mouseScrollDelta]
		public static function get mouseScrollDelta():Vector2;

		/**
		* UnityEngine.Input.get_mousePresent
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_get_mousePresent]
		public static function get mousePresent():Boolean;

		/**
		* UnityEngine.Input.get_simulateMouseWithTouches
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_get_simulateMouseWithTouches]
		public static function get simulateMouseWithTouches():Boolean;

		/**
		* UnityEngine.Input.set_simulateMouseWithTouches
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_Input_set_simulateMouseWithTouches]
		public static function set simulateMouseWithTouches(value:Boolean):void;

		/**
		* UnityEngine.Input.get_anyKey
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_get_anyKey]
		public static function get anyKey():Boolean;

		/**
		* UnityEngine.Input.get_anyKeyDown
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_get_anyKeyDown]
		public static function get anyKeyDown():Boolean;

		/**
		* UnityEngine.Input.get_inputString
		*return:
		*   System.String
		*/
		[native,static_unityengine_Input_get_inputString]
		public static function get inputString():String;

		/**
		* UnityEngine.Input.get_acceleration
		*return:
		*   UnityEngine.Vector3
		*/
		[native,static_unityengine_Input_get_acceleration]
		public static function get acceleration():Vector3;

		/**
		* UnityEngine.Input.get_accelerationEvents
		*return:
		*   UnityEngine.AccelerationEvent[]
		*/
		[native,static_unityengine_Input_get_accelerationEvents]
		public static function get accelerationEvents():_Array_;

		/**
		* UnityEngine.Input.GetAccelerationEvent
		*parameters:
		*  index : System.Int32
		*return:
		*   UnityEngine.AccelerationEvent
		*/
		[native,static_unityengine_Input_getAccelerationEvent];
		public static function getAccelerationEvent(index:int):AccelerationEvent;

		/**
		* UnityEngine.Input.get_accelerationEventCount
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Input_get_accelerationEventCount]
		public static function get accelerationEventCount():int;

		/**
		* UnityEngine.Input.get_touches
		*return:
		*   UnityEngine.Touch[]
		*/
		[native,static_unityengine_Input_get_touches]
		public static function get touches():_Array_;

		/**
		* UnityEngine.Input.GetTouch
		*parameters:
		*  index : System.Int32
		*return:
		*   UnityEngine.Touch
		*/
		[native,static_unityengine_Input_getTouch];
		public static function getTouch(index:int):Touch;

		/**
		* UnityEngine.Input.get_touchCount
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Input_get_touchCount]
		public static function get touchCount():int;

		/**
		* UnityEngine.Input.get_touchPressureSupported
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_get_touchPressureSupported]
		public static function get touchPressureSupported():Boolean;

		/**
		* UnityEngine.Input.get_stylusTouchSupported
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_get_stylusTouchSupported]
		public static function get stylusTouchSupported():Boolean;

		/**
		* UnityEngine.Input.get_touchSupported
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_get_touchSupported]
		public static function get touchSupported():Boolean;

		/**
		* UnityEngine.Input.get_multiTouchEnabled
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_get_multiTouchEnabled]
		public static function get multiTouchEnabled():Boolean;

		/**
		* UnityEngine.Input.set_multiTouchEnabled
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_Input_set_multiTouchEnabled]
		public static function set multiTouchEnabled(value:Boolean):void;

		/**
		* UnityEngine.Input.get_location
		*return:
		*   UnityEngine.LocationService
		*/
		[native,static_unityengine_Input_get_location]
		public static function get location():LocationService;

		/**
		* UnityEngine.Input.get_compass
		*return:
		*   UnityEngine.Compass
		*/
		[native,static_unityengine_Input_get_compass]
		public static function get compass():Compass;

		/**
		* UnityEngine.Input.get_deviceOrientation
		*return:
		*   UnityEngine.DeviceOrientation
		*/
		[native,static_unityengine_Input_get_deviceOrientation]
		public static function get deviceOrientation():DeviceOrientation;

		/**
		* UnityEngine.Input.get_imeCompositionMode
		*return:
		*   UnityEngine.IMECompositionMode
		*/
		[native,static_unityengine_Input_get_imeCompositionMode]
		public static function get imeCompositionMode():IMECompositionMode;

		/**
		* UnityEngine.Input.set_imeCompositionMode
		*parameters:
		*  value : UnityEngine.IMECompositionMode
		*/
		[native,static_unityengine_Input_set_imeCompositionMode]
		public static function set imeCompositionMode(value:IMECompositionMode):void;

		/**
		* UnityEngine.Input.get_compositionString
		*return:
		*   System.String
		*/
		[native,static_unityengine_Input_get_compositionString]
		public static function get compositionString():String;

		/**
		* UnityEngine.Input.get_imeIsSelected
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_get_imeIsSelected]
		public static function get imeIsSelected():Boolean;

		/**
		* UnityEngine.Input.get_compositionCursorPos
		*return:
		*   UnityEngine.Vector2
		*/
		[native,static_unityengine_Input_get_compositionCursorPos]
		public static function get compositionCursorPos():Vector2;

		/**
		* UnityEngine.Input.set_compositionCursorPos
		*parameters:
		*  value : UnityEngine.Vector2
		*/
		[native,static_unityengine_Input_set_compositionCursorPos]
		public static function set compositionCursorPos(value:Vector2):void;

		/**
		* UnityEngine.Input.get_backButtonLeavesApp
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Input_get_backButtonLeavesApp]
		public static function get backButtonLeavesApp():Boolean;

		/**
		* UnityEngine.Input.set_backButtonLeavesApp
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_Input_set_backButtonLeavesApp]
		public static function set backButtonLeavesApp(value:Boolean):void;


	}
}
