package unityengine
{
	import system.collections.generic.List_Of_Single;
	import system._Array_;
	import system.collections.generic.List_Of_Color;
	import system.collections.generic.List_Of_Vector4;
	import system.collections.generic.List_Of_Matrix4x4;


		/**
		*  UnityEngine.Material
		*/
	[link_system]
	public class Material extends UObject
	{
		[creator];
		[native,unityengine_Material_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Material_constructor_];
		public static function constructor_(source:Material):Material;

		[native,unityengine_Material_ctor];
		public function Material(shader:Shader);

		//*********跨语言继承适配器*******
		[crossextendadapter];
		[native,_unityengine_MaterialAdapter_ctor];
		private function _MaterialAdapter(shader:Shader);


		//*********公共方法*******
		/**
		* UnityEngine.Material.SetFloatArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,unityengine_Material_setFloatArray];
		public final function setFloatArray(name:String,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.Material.SetFloatArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,unityengine_Material_setFloatArray_];
		public final function setFloatArray_(nameID:int,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.Material.SetFloatArray
		*parameters:
		*  name : System.String
		*  values : System.Single[]
		*/
		[native,unityengine_Material_setFloatArray__];
		public final function setFloatArray__(name:String,values:_Array_):void;

		/**
		* UnityEngine.Material.SetFloatArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Single[]
		*/
		[native,unityengine_Material_setFloatArray___];
		public final function setFloatArray___(nameID:int,values:_Array_):void;

		/**
		* UnityEngine.Material.SetColorArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Color &gt; 
		*/
		[native,unityengine_Material_setColorArray];
		public final function setColorArray(name:String,values:system.collections.generic.List_Of_Color):void;

		/**
		* UnityEngine.Material.SetColorArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Color &gt; 
		*/
		[native,unityengine_Material_setColorArray_];
		public final function setColorArray_(nameID:int,values:system.collections.generic.List_Of_Color):void;

		/**
		* UnityEngine.Material.SetColorArray
		*parameters:
		*  name : System.String
		*  values : UnityEngine.Color[]
		*/
		[native,unityengine_Material_setColorArray__];
		public final function setColorArray__(name:String,values:_Array_):void;

		/**
		* UnityEngine.Material.SetColorArray
		*parameters:
		*  nameID : System.Int32
		*  values : UnityEngine.Color[]
		*/
		[native,unityengine_Material_setColorArray___];
		public final function setColorArray___(nameID:int,values:_Array_):void;

		/**
		* UnityEngine.Material.SetVectorArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_Material_setVectorArray];
		public final function setVectorArray(name:String,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Material.SetVectorArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_Material_setVectorArray_];
		public final function setVectorArray_(nameID:int,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Material.SetVectorArray
		*parameters:
		*  name : System.String
		*  values : UnityEngine.Vector4[]
		*/
		[native,unityengine_Material_setVectorArray__];
		public final function setVectorArray__(name:String,values:_Array_):void;

		/**
		* UnityEngine.Material.SetVectorArray
		*parameters:
		*  nameID : System.Int32
		*  values : UnityEngine.Vector4[]
		*/
		[native,unityengine_Material_setVectorArray___];
		public final function setVectorArray___(nameID:int,values:_Array_):void;

		/**
		* UnityEngine.Material.SetMatrixArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,unityengine_Material_setMatrixArray];
		public final function setMatrixArray(name:String,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.Material.SetMatrixArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,unityengine_Material_setMatrixArray_];
		public final function setMatrixArray_(nameID:int,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.Material.SetMatrixArray
		*parameters:
		*  name : System.String
		*  values : UnityEngine.Matrix4x4[]
		*/
		[native,unityengine_Material_setMatrixArray__];
		public final function setMatrixArray__(name:String,values:_Array_):void;

		/**
		* UnityEngine.Material.SetMatrixArray
		*parameters:
		*  nameID : System.Int32
		*  values : UnityEngine.Matrix4x4[]
		*/
		[native,unityengine_Material_setMatrixArray___];
		public final function setMatrixArray___(nameID:int,values:_Array_):void;

		/**
		* UnityEngine.Material.GetFloat
		*parameters:
		*  name : System.String
		*return:
		*   System.Single
		*/
		[native,unityengine_Material_getFloat];
		public final function getFloat(name:String):Number;

		/**
		* UnityEngine.Material.GetFloat
		*parameters:
		*  nameID : System.Int32
		*return:
		*   System.Single
		*/
		[native,unityengine_Material_getFloat_];
		public final function getFloat_(nameID:int):Number;

		/**
		* UnityEngine.Material.GetInt
		*parameters:
		*  name : System.String
		*return:
		*   System.Int32
		*/
		[native,unityengine_Material_getInt];
		public final function getInt(name:String):int;

		/**
		* UnityEngine.Material.GetInt
		*parameters:
		*  nameID : System.Int32
		*return:
		*   System.Int32
		*/
		[native,unityengine_Material_getInt_];
		public final function getInt_(nameID:int):int;

		/**
		* UnityEngine.Material.GetColor
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Color
		*/
		[native,unityengine_Material_getColor];
		public final function getColor(name:String):Color;

		/**
		* UnityEngine.Material.GetColor
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Color
		*/
		[native,unityengine_Material_getColor_];
		public final function getColor_(nameID:int):Color;

		/**
		* UnityEngine.Material.GetVector
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Vector4
		*/
		[native,unityengine_Material_getVector];
		public final function getVector(name:String):Vector4;

		/**
		* UnityEngine.Material.GetVector
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Vector4
		*/
		[native,unityengine_Material_getVector_];
		public final function getVector_(nameID:int):Vector4;

		/**
		* UnityEngine.Material.GetMatrix
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_Material_getMatrix];
		public final function getMatrix(name:String):Matrix4x4;

		/**
		* UnityEngine.Material.GetMatrix
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_Material_getMatrix_];
		public final function getMatrix_(nameID:int):Matrix4x4;

		/**
		* UnityEngine.Material.GetFloatArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,unityengine_Material_getFloatArray];
		public final function getFloatArray(name:String,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.Material.GetFloatArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,unityengine_Material_getFloatArray_];
		public final function getFloatArray_(nameID:int,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.Material.GetFloatArray
		*parameters:
		*  name : System.String
		*return:
		*   System.Single[]
		*/
		[native,unityengine_Material_getFloatArray__];
		public final function getFloatArray__(name:String):_Array_;

		/**
		* UnityEngine.Material.GetFloatArray
		*parameters:
		*  nameID : System.Int32
		*return:
		*   System.Single[]
		*/
		[native,unityengine_Material_getFloatArray___];
		public final function getFloatArray___(nameID:int):_Array_;

		/**
		* UnityEngine.Material.GetVectorArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_Material_getVectorArray];
		public final function getVectorArray(name:String,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Material.GetVectorArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_Material_getVectorArray_];
		public final function getVectorArray_(nameID:int,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Material.GetColorArray
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Color[]
		*/
		[native,unityengine_Material_getColorArray];
		public final function getColorArray(name:String):_Array_;

		/**
		* UnityEngine.Material.GetColorArray
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Color[]
		*/
		[native,unityengine_Material_getColorArray_];
		public final function getColorArray_(nameID:int):_Array_;

		/**
		* UnityEngine.Material.GetColorArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Color &gt; 
		*/
		[native,unityengine_Material_getColorArray__];
		public final function getColorArray__(name:String,values:system.collections.generic.List_Of_Color):void;

		/**
		* UnityEngine.Material.GetColorArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Color &gt; 
		*/
		[native,unityengine_Material_getColorArray___];
		public final function getColorArray___(nameID:int,values:system.collections.generic.List_Of_Color):void;

		/**
		* UnityEngine.Material.GetVectorArray
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Vector4[]
		*/
		[native,unityengine_Material_getVectorArray__];
		public final function getVectorArray__(name:String):_Array_;

		/**
		* UnityEngine.Material.GetVectorArray
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Vector4[]
		*/
		[native,unityengine_Material_getVectorArray___];
		public final function getVectorArray___(nameID:int):_Array_;

		/**
		* UnityEngine.Material.GetMatrixArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,unityengine_Material_getMatrixArray];
		public final function getMatrixArray(name:String,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.Material.GetMatrixArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,unityengine_Material_getMatrixArray_];
		public final function getMatrixArray_(nameID:int,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.Material.GetMatrixArray
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Matrix4x4[]
		*/
		[native,unityengine_Material_getMatrixArray__];
		public final function getMatrixArray__(name:String):_Array_;

		/**
		* UnityEngine.Material.GetMatrixArray
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Matrix4x4[]
		*/
		[native,unityengine_Material_getMatrixArray___];
		public final function getMatrixArray___(nameID:int):_Array_;

		/**
		* UnityEngine.Material.GetTexture
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Texture
		*/
		[native,unityengine_Material_getTexture];
		public final function getTexture(name:String):Texture;

		/**
		* UnityEngine.Material.GetTexture
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Texture
		*/
		[native,unityengine_Material_getTexture_];
		public final function getTexture_(nameID:int):Texture;

		/**
		* UnityEngine.Material.GetTextureOffset
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_Material_getTextureOffset];
		public final function getTextureOffset(name:String):Vector2;

		/**
		* UnityEngine.Material.GetTextureOffset
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_Material_getTextureOffset_];
		public final function getTextureOffset_(nameID:int):Vector2;

		/**
		* UnityEngine.Material.GetTextureScale
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_Material_getTextureScale];
		public final function getTextureScale(name:String):Vector2;

		/**
		* UnityEngine.Material.GetTextureScale
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_Material_getTextureScale_];
		public final function getTextureScale_(nameID:int):Vector2;

		/**
		* UnityEngine.Material.get_shader
		*return:
		*   UnityEngine.Shader
		*/
		[native,unityengine_Material_get_shader]
		public final function get shader():Shader;

		/**
		* UnityEngine.Material.set_shader
		*parameters:
		*  value : UnityEngine.Shader
		*/
		[native,unityengine_Material_set_shader]
		public final function set shader(value:Shader):void;

		/**
		* UnityEngine.Material.get_color
		*return:
		*   UnityEngine.Color
		*/
		[native,unityengine_Material_get_color]
		public final function get color():Color;

		/**
		* UnityEngine.Material.set_color
		*parameters:
		*  value : UnityEngine.Color
		*/
		[native,unityengine_Material_set_color]
		public final function set color(value:Color):void;

		/**
		* UnityEngine.Material.get_mainTexture
		*return:
		*   UnityEngine.Texture
		*/
		[native,unityengine_Material_get_mainTexture]
		public final function get mainTexture():Texture;

		/**
		* UnityEngine.Material.set_mainTexture
		*parameters:
		*  value : UnityEngine.Texture
		*/
		[native,unityengine_Material_set_mainTexture]
		public final function set mainTexture(value:Texture):void;

		/**
		* UnityEngine.Material.get_mainTextureOffset
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_Material_get_mainTextureOffset]
		public final function get mainTextureOffset():Vector2;

		/**
		* UnityEngine.Material.set_mainTextureOffset
		*parameters:
		*  value : UnityEngine.Vector2
		*/
		[native,unityengine_Material_set_mainTextureOffset]
		public final function set mainTextureOffset(value:Vector2):void;

		/**
		* UnityEngine.Material.get_mainTextureScale
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_Material_get_mainTextureScale]
		public final function get mainTextureScale():Vector2;

		/**
		* UnityEngine.Material.set_mainTextureScale
		*parameters:
		*  value : UnityEngine.Vector2
		*/
		[native,unityengine_Material_set_mainTextureScale]
		public final function set mainTextureScale(value:Vector2):void;

		/**
		* UnityEngine.Material.HasProperty
		*parameters:
		*  propertyName : System.String
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Material_hasProperty];
		public final function hasProperty(propertyName:String):Boolean;

		/**
		* UnityEngine.Material.HasProperty
		*parameters:
		*  nameID : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Material_hasProperty_];
		public final function hasProperty_(nameID:int):Boolean;

		/**
		* UnityEngine.Material.GetTag
		*parameters:
		*  tag : System.String
		*  searchFallbacks : System.Boolean
		*  defaultValue : System.String
		*return:
		*   System.String
		*/
		[native,unityengine_Material_getTag];
		public final function getTag(tag:String,searchFallbacks:Boolean,defaultValue:String):String;

		/**
		* UnityEngine.Material.GetTag
		*parameters:
		*  tag : System.String
		*  searchFallbacks : System.Boolean
		*return:
		*   System.String
		*/
		[native,unityengine_Material_getTag_];
		public final function getTag_(tag:String,searchFallbacks:Boolean):String;

		/**
		* UnityEngine.Material.SetOverrideTag
		*parameters:
		*  tag : System.String
		*  val : System.String
		*/
		[native,unityengine_Material_setOverrideTag];
		public final function setOverrideTag(tag:String,val:String):void;

		/**
		* UnityEngine.Material.SetShaderPassEnabled
		*parameters:
		*  passName : System.String
		*  enabled : System.Boolean
		*/
		[native,unityengine_Material_setShaderPassEnabled];
		public final function setShaderPassEnabled(passName:String,enabled:Boolean):void;

		/**
		* UnityEngine.Material.GetShaderPassEnabled
		*parameters:
		*  passName : System.String
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Material_getShaderPassEnabled];
		public final function getShaderPassEnabled(passName:String):Boolean;

		/**
		* UnityEngine.Material.Lerp
		*parameters:
		*  start : UnityEngine.Material
		*  end : UnityEngine.Material
		*  t : System.Single
		*/
		[native,unityengine_Material_lerp];
		public final function lerp(start:Material,end:Material,t:Number):void;

		/**
		* UnityEngine.Material.get_passCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_Material_get_passCount]
		public final function get passCount():int;

		/**
		* UnityEngine.Material.SetPass
		*parameters:
		*  pass : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Material_setPass];
		public final function setPass(pass:int):Boolean;

		/**
		* UnityEngine.Material.GetPassName
		*parameters:
		*  pass : System.Int32
		*return:
		*   System.String
		*/
		[native,unityengine_Material_getPassName];
		public final function getPassName(pass:int):String;

		/**
		* UnityEngine.Material.FindPass
		*parameters:
		*  passName : System.String
		*return:
		*   System.Int32
		*/
		[native,unityengine_Material_findPass];
		public final function findPass(passName:String):int;

		/**
		* UnityEngine.Material.get_renderQueue
		*return:
		*   System.Int32
		*/
		[native,unityengine_Material_get_renderQueue]
		public final function get renderQueue():int;

		/**
		* UnityEngine.Material.set_renderQueue
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_Material_set_renderQueue]
		public final function set renderQueue(value:int):void;

		/**
		* UnityEngine.Material.CopyPropertiesFromMaterial
		*parameters:
		*  mat : UnityEngine.Material
		*/
		[native,unityengine_Material_copyPropertiesFromMaterial];
		public final function copyPropertiesFromMaterial(mat:Material):void;

		/**
		* UnityEngine.Material.EnableKeyword
		*parameters:
		*  keyword : System.String
		*/
		[native,unityengine_Material_enableKeyword];
		public final function enableKeyword(keyword:String):void;

		/**
		* UnityEngine.Material.DisableKeyword
		*parameters:
		*  keyword : System.String
		*/
		[native,unityengine_Material_disableKeyword];
		public final function disableKeyword(keyword:String):void;

		/**
		* UnityEngine.Material.IsKeywordEnabled
		*parameters:
		*  keyword : System.String
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Material_isKeywordEnabled];
		public final function isKeywordEnabled(keyword:String):Boolean;

		/**
		* UnityEngine.Material.get_shaderKeywords
		*return:
		*   System.String[]
		*/
		[native,unityengine_Material_get_shaderKeywords]
		public final function get shaderKeywords():_Array_;

		/**
		* UnityEngine.Material.set_shaderKeywords
		*parameters:
		*  value : System.String[]
		*/
		[native,unityengine_Material_set_shaderKeywords]
		public final function set shaderKeywords(value:_Array_):void;

		/**
		* UnityEngine.Material.get_globalIlluminationFlags
		*return:
		*   UnityEngine.MaterialGlobalIlluminationFlags
		*/
		[native,unityengine_Material_get_globalIlluminationFlags]
		public final function get globalIlluminationFlags():MaterialGlobalIlluminationFlags;

		/**
		* UnityEngine.Material.set_globalIlluminationFlags
		*parameters:
		*  value : UnityEngine.MaterialGlobalIlluminationFlags
		*/
		[native,unityengine_Material_set_globalIlluminationFlags]
		public final function set globalIlluminationFlags(value:MaterialGlobalIlluminationFlags):void;

		/**
		* UnityEngine.Material.get_enableInstancing
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Material_get_enableInstancing]
		public final function get enableInstancing():Boolean;

		/**
		* UnityEngine.Material.set_enableInstancing
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_Material_set_enableInstancing]
		public final function set enableInstancing(value:Boolean):void;

		/**
		* UnityEngine.Material.get_doubleSidedGI
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Material_get_doubleSidedGI]
		public final function get doubleSidedGI():Boolean;

		/**
		* UnityEngine.Material.set_doubleSidedGI
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_Material_set_doubleSidedGI]
		public final function set doubleSidedGI(value:Boolean):void;

		/**
		* UnityEngine.Material.SetFloat
		*parameters:
		*  name : System.String
		*  value : System.Single
		*/
		[native,unityengine_Material_setFloat];
		public final function setFloat(name:String,value:Number):void;

		/**
		* UnityEngine.Material.SetFloat
		*parameters:
		*  nameID : System.Int32
		*  value : System.Single
		*/
		[native,unityengine_Material_setFloat_];
		public final function setFloat_(nameID:int,value:Number):void;

		/**
		* UnityEngine.Material.SetInt
		*parameters:
		*  name : System.String
		*  value : System.Int32
		*/
		[native,unityengine_Material_setInt];
		public final function setInt(name:String,value:int):void;

		/**
		* UnityEngine.Material.SetInt
		*parameters:
		*  nameID : System.Int32
		*  value : System.Int32
		*/
		[native,unityengine_Material_setInt_];
		public final function setInt_(nameID:int,value:int):void;

		/**
		* UnityEngine.Material.SetColor
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Color
		*/
		[native,unityengine_Material_setColor];
		public final function setColor(name:String,value:Color):void;

		/**
		* UnityEngine.Material.SetColor
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Color
		*/
		[native,unityengine_Material_setColor_];
		public final function setColor_(nameID:int,value:Color):void;

		/**
		* UnityEngine.Material.SetVector
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Vector4
		*/
		[native,unityengine_Material_setVector];
		public final function setVector(name:String,value:Vector4):void;

		/**
		* UnityEngine.Material.SetVector
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Vector4
		*/
		[native,unityengine_Material_setVector_];
		public final function setVector_(nameID:int,value:Vector4):void;

		/**
		* UnityEngine.Material.SetMatrix
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Matrix4x4
		*/
		[native,unityengine_Material_setMatrix];
		public final function setMatrix(name:String,value:Matrix4x4):void;

		/**
		* UnityEngine.Material.SetMatrix
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Matrix4x4
		*/
		[native,unityengine_Material_setMatrix_];
		public final function setMatrix_(nameID:int,value:Matrix4x4):void;

		/**
		* UnityEngine.Material.SetTexture
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Texture
		*/
		[native,unityengine_Material_setTexture];
		public final function setTexture(name:String,value:Texture):void;

		/**
		* UnityEngine.Material.SetTexture
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Texture
		*/
		[native,unityengine_Material_setTexture_];
		public final function setTexture_(nameID:int,value:Texture):void;

		/**
		* UnityEngine.Material.SetBuffer
		*parameters:
		*  name : System.String
		*  value : UnityEngine.ComputeBuffer
		*/
		[native,unityengine_Material_setBuffer];
		public final function setBuffer(name:String,value:ComputeBuffer):void;

		/**
		* UnityEngine.Material.SetBuffer
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.ComputeBuffer
		*/
		[native,unityengine_Material_setBuffer_];
		public final function setBuffer_(nameID:int,value:ComputeBuffer):void;

		/**
		* UnityEngine.Material.SetTextureOffset
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Vector2
		*/
		[native,unityengine_Material_setTextureOffset];
		public final function setTextureOffset(name:String,value:Vector2):void;

		/**
		* UnityEngine.Material.SetTextureOffset
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Vector2
		*/
		[native,unityengine_Material_setTextureOffset_];
		public final function setTextureOffset_(nameID:int,value:Vector2):void;

		/**
		* UnityEngine.Material.SetTextureScale
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Vector2
		*/
		[native,unityengine_Material_setTextureScale];
		public final function setTextureScale(name:String,value:Vector2):void;

		/**
		* UnityEngine.Material.SetTextureScale
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Vector2
		*/
		[native,unityengine_Material_setTextureScale_];
		public final function setTextureScale_(nameID:int,value:Vector2):void;


	}
}
