package unityengine
{
	import system._Object_;
	import system.collections.generic.List_Of_Single;
	import system._Array_;
	import system.collections.generic.List_Of_Vector4;
	import system.collections.generic.List_Of_Matrix4x4;


		/**
		* Sealed
		*  UnityEngine.MaterialPropertyBlock
		*/
	[link_system]
	public final class MaterialPropertyBlock extends system._Object_
	{
		[creator];
		[native,unityengine_MaterialPropertyBlock_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_MaterialPropertyBlock_ctor];
		public function MaterialPropertyBlock();


		//*********公共方法*******
		/**
		* UnityEngine.MaterialPropertyBlock.get_isEmpty
		*return:
		*   System.Boolean
		*/
		[native,unityengine_MaterialPropertyBlock_get_isEmpty]
		public final function get isEmpty():Boolean;

		/**
		* UnityEngine.MaterialPropertyBlock.Clear
		*/
		[native,unityengine_MaterialPropertyBlock_clear];
		public final function clear():void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetFloat
		*parameters:
		*  name : System.String
		*  value : System.Single
		*/
		[native,unityengine_MaterialPropertyBlock_setFloat];
		public final function setFloat(name:String,value:Number):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetFloat
		*parameters:
		*  nameID : System.Int32
		*  value : System.Single
		*/
		[native,unityengine_MaterialPropertyBlock_setFloat_];
		public final function setFloat_(nameID:int,value:Number):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetVector
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Vector4
		*/
		[native,unityengine_MaterialPropertyBlock_setVector];
		public final function setVector(name:String,value:Vector4):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetVector
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Vector4
		*/
		[native,unityengine_MaterialPropertyBlock_setVector_];
		public final function setVector_(nameID:int,value:Vector4):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetColor
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Color
		*/
		[native,unityengine_MaterialPropertyBlock_setColor];
		public final function setColor(name:String,value:Color):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetColor
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Color
		*/
		[native,unityengine_MaterialPropertyBlock_setColor_];
		public final function setColor_(nameID:int,value:Color):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetMatrix
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Matrix4x4
		*/
		[native,unityengine_MaterialPropertyBlock_setMatrix];
		public final function setMatrix(name:String,value:Matrix4x4):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetMatrix
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Matrix4x4
		*/
		[native,unityengine_MaterialPropertyBlock_setMatrix_];
		public final function setMatrix_(nameID:int,value:Matrix4x4):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetBuffer
		*parameters:
		*  name : System.String
		*  value : UnityEngine.ComputeBuffer
		*/
		[native,unityengine_MaterialPropertyBlock_setBuffer];
		public final function setBuffer(name:String,value:ComputeBuffer):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetBuffer
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.ComputeBuffer
		*/
		[native,unityengine_MaterialPropertyBlock_setBuffer_];
		public final function setBuffer_(nameID:int,value:ComputeBuffer):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetTexture
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Texture
		*/
		[native,unityengine_MaterialPropertyBlock_setTexture];
		public final function setTexture(name:String,value:Texture):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetTexture
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Texture
		*/
		[native,unityengine_MaterialPropertyBlock_setTexture_];
		public final function setTexture_(nameID:int,value:Texture):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetFloatArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,unityengine_MaterialPropertyBlock_setFloatArray];
		public final function setFloatArray(name:String,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetFloatArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,unityengine_MaterialPropertyBlock_setFloatArray_];
		public final function setFloatArray_(nameID:int,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetFloatArray
		*parameters:
		*  name : System.String
		*  values : System.Single[]
		*/
		[native,unityengine_MaterialPropertyBlock_setFloatArray__];
		public final function setFloatArray__(name:String,values:_Array_):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetFloatArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Single[]
		*/
		[native,unityengine_MaterialPropertyBlock_setFloatArray___];
		public final function setFloatArray___(nameID:int,values:_Array_):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetVectorArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_MaterialPropertyBlock_setVectorArray];
		public final function setVectorArray(name:String,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetVectorArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_MaterialPropertyBlock_setVectorArray_];
		public final function setVectorArray_(nameID:int,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetVectorArray
		*parameters:
		*  name : System.String
		*  values : UnityEngine.Vector4[]
		*/
		[native,unityengine_MaterialPropertyBlock_setVectorArray__];
		public final function setVectorArray__(name:String,values:_Array_):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetVectorArray
		*parameters:
		*  nameID : System.Int32
		*  values : UnityEngine.Vector4[]
		*/
		[native,unityengine_MaterialPropertyBlock_setVectorArray___];
		public final function setVectorArray___(nameID:int,values:_Array_):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetMatrixArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,unityengine_MaterialPropertyBlock_setMatrixArray];
		public final function setMatrixArray(name:String,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetMatrixArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,unityengine_MaterialPropertyBlock_setMatrixArray_];
		public final function setMatrixArray_(nameID:int,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetMatrixArray
		*parameters:
		*  name : System.String
		*  values : UnityEngine.Matrix4x4[]
		*/
		[native,unityengine_MaterialPropertyBlock_setMatrixArray__];
		public final function setMatrixArray__(name:String,values:_Array_):void;

		/**
		* UnityEngine.MaterialPropertyBlock.SetMatrixArray
		*parameters:
		*  nameID : System.Int32
		*  values : UnityEngine.Matrix4x4[]
		*/
		[native,unityengine_MaterialPropertyBlock_setMatrixArray___];
		public final function setMatrixArray___(nameID:int,values:_Array_):void;

		/**
		* UnityEngine.MaterialPropertyBlock.GetFloat
		*parameters:
		*  name : System.String
		*return:
		*   System.Single
		*/
		[native,unityengine_MaterialPropertyBlock_getFloat];
		public final function getFloat(name:String):Number;

		/**
		* UnityEngine.MaterialPropertyBlock.GetFloat
		*parameters:
		*  nameID : System.Int32
		*return:
		*   System.Single
		*/
		[native,unityengine_MaterialPropertyBlock_getFloat_];
		public final function getFloat_(nameID:int):Number;

		/**
		* UnityEngine.MaterialPropertyBlock.GetVector
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Vector4
		*/
		[native,unityengine_MaterialPropertyBlock_getVector];
		public final function getVector(name:String):Vector4;

		/**
		* UnityEngine.MaterialPropertyBlock.GetVector
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Vector4
		*/
		[native,unityengine_MaterialPropertyBlock_getVector_];
		public final function getVector_(nameID:int):Vector4;

		/**
		* UnityEngine.MaterialPropertyBlock.GetMatrix
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_MaterialPropertyBlock_getMatrix];
		public final function getMatrix(name:String):Matrix4x4;

		/**
		* UnityEngine.MaterialPropertyBlock.GetMatrix
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_MaterialPropertyBlock_getMatrix_];
		public final function getMatrix_(nameID:int):Matrix4x4;

		/**
		* UnityEngine.MaterialPropertyBlock.GetFloatArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,unityengine_MaterialPropertyBlock_getFloatArray];
		public final function getFloatArray(name:String,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.MaterialPropertyBlock.GetFloatArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,unityengine_MaterialPropertyBlock_getFloatArray_];
		public final function getFloatArray_(nameID:int,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.MaterialPropertyBlock.GetFloatArray
		*parameters:
		*  name : System.String
		*return:
		*   System.Single[]
		*/
		[native,unityengine_MaterialPropertyBlock_getFloatArray__];
		public final function getFloatArray__(name:String):_Array_;

		/**
		* UnityEngine.MaterialPropertyBlock.GetFloatArray
		*parameters:
		*  nameID : System.Int32
		*return:
		*   System.Single[]
		*/
		[native,unityengine_MaterialPropertyBlock_getFloatArray___];
		public final function getFloatArray___(nameID:int):_Array_;

		/**
		* UnityEngine.MaterialPropertyBlock.GetVectorArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_MaterialPropertyBlock_getVectorArray];
		public final function getVectorArray(name:String,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.MaterialPropertyBlock.GetVectorArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_MaterialPropertyBlock_getVectorArray_];
		public final function getVectorArray_(nameID:int,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.MaterialPropertyBlock.GetVectorArray
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Vector4[]
		*/
		[native,unityengine_MaterialPropertyBlock_getVectorArray__];
		public final function getVectorArray__(name:String):_Array_;

		/**
		* UnityEngine.MaterialPropertyBlock.GetVectorArray
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Vector4[]
		*/
		[native,unityengine_MaterialPropertyBlock_getVectorArray___];
		public final function getVectorArray___(nameID:int):_Array_;

		/**
		* UnityEngine.MaterialPropertyBlock.GetMatrixArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,unityengine_MaterialPropertyBlock_getMatrixArray];
		public final function getMatrixArray(name:String,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.MaterialPropertyBlock.GetMatrixArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,unityengine_MaterialPropertyBlock_getMatrixArray_];
		public final function getMatrixArray_(nameID:int,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.MaterialPropertyBlock.GetMatrixArray
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Matrix4x4[]
		*/
		[native,unityengine_MaterialPropertyBlock_getMatrixArray__];
		public final function getMatrixArray__(name:String):_Array_;

		/**
		* UnityEngine.MaterialPropertyBlock.GetMatrixArray
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Matrix4x4[]
		*/
		[native,unityengine_MaterialPropertyBlock_getMatrixArray___];
		public final function getMatrixArray___(nameID:int):_Array_;

		/**
		* UnityEngine.MaterialPropertyBlock.GetTexture
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Texture
		*/
		[native,unityengine_MaterialPropertyBlock_getTexture];
		public final function getTexture(name:String):Texture;

		/**
		* UnityEngine.MaterialPropertyBlock.GetTexture
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Texture
		*/
		[native,unityengine_MaterialPropertyBlock_getTexture_];
		public final function getTexture_(nameID:int):Texture;


	}
}
