package unityengine
{
	import system._Array_;
	import system.collections.generic.List_Of_Vector3;
	import system.collections.generic.List_Of_Vector4;
	import system.collections.generic.List_Of_Color;
	import system.collections.generic.List_Of_Color32;
	import system.collections.generic.List_Of_Vector2;
	import system.collections.generic.List_Of_Int32;
	import system.collections.generic.List_Of_Matrix4x4;
	import system.collections.generic.List_Of_BoneWeight;
	import system.IntPtr;


		/**
		* Sealed
		*  UnityEngine.Mesh
		*/
	[link_system]
	public final class Mesh extends UObject
	{
		[creator];
		[native,unityengine_Mesh_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Mesh_ctor];
		public function Mesh();


		//*********公共方法*******
		/**
		* UnityEngine.Mesh.set_uv4
		*parameters:
		*  value : UnityEngine.Vector2[]
		*/
		[native,unityengine_Mesh_set_uv4]
		public final function set uv4(value:_Array_):void;

		/**
		* UnityEngine.Mesh.get_colors
		*return:
		*   UnityEngine.Color[]
		*/
		[native,unityengine_Mesh_get_colors]
		public final function get colors():_Array_;

		/**
		* UnityEngine.Mesh.set_colors
		*parameters:
		*  value : UnityEngine.Color[]
		*/
		[native,unityengine_Mesh_set_colors]
		public final function set colors(value:_Array_):void;

		/**
		* UnityEngine.Mesh.get_colors32
		*return:
		*   UnityEngine.Color32[]
		*/
		[native,unityengine_Mesh_get_colors32]
		public final function get colors32():_Array_;

		/**
		* UnityEngine.Mesh.set_colors32
		*parameters:
		*  value : UnityEngine.Color32[]
		*/
		[native,unityengine_Mesh_set_colors32]
		public final function set colors32(value:_Array_):void;

		/**
		* UnityEngine.Mesh.GetVertices
		*parameters:
		*  vertices : System.Collections.Generic.List &lt; UnityEngine.Vector3 &gt; 
		*/
		[native,unityengine_Mesh_getVertices];
		public final function getVertices(vertices:system.collections.generic.List_Of_Vector3):void;

		/**
		* UnityEngine.Mesh.SetVertices
		*parameters:
		*  inVertices : System.Collections.Generic.List &lt; UnityEngine.Vector3 &gt; 
		*/
		[native,unityengine_Mesh_setVertices];
		public final function setVertices(inVertices:system.collections.generic.List_Of_Vector3):void;

		/**
		* UnityEngine.Mesh.GetNormals
		*parameters:
		*  normals : System.Collections.Generic.List &lt; UnityEngine.Vector3 &gt; 
		*/
		[native,unityengine_Mesh_getNormals];
		public final function getNormals(normals:system.collections.generic.List_Of_Vector3):void;

		/**
		* UnityEngine.Mesh.SetNormals
		*parameters:
		*  inNormals : System.Collections.Generic.List &lt; UnityEngine.Vector3 &gt; 
		*/
		[native,unityengine_Mesh_setNormals];
		public final function setNormals(inNormals:system.collections.generic.List_Of_Vector3):void;

		/**
		* UnityEngine.Mesh.GetTangents
		*parameters:
		*  tangents : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_Mesh_getTangents];
		public final function getTangents(tangents:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Mesh.SetTangents
		*parameters:
		*  inTangents : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_Mesh_setTangents];
		public final function setTangents(inTangents:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Mesh.GetColors
		*parameters:
		*  colors : System.Collections.Generic.List &lt; UnityEngine.Color &gt; 
		*/
		[native,unityengine_Mesh_getColors];
		public final function getColors(colors:system.collections.generic.List_Of_Color):void;

		/**
		* UnityEngine.Mesh.SetColors
		*parameters:
		*  inColors : System.Collections.Generic.List &lt; UnityEngine.Color &gt; 
		*/
		[native,unityengine_Mesh_setColors];
		public final function setColors(inColors:system.collections.generic.List_Of_Color):void;

		/**
		* UnityEngine.Mesh.GetColors
		*parameters:
		*  colors : System.Collections.Generic.List &lt; UnityEngine.Color32 &gt; 
		*/
		[native,unityengine_Mesh_getColors_];
		public final function getColors_(colors:system.collections.generic.List_Of_Color32):void;

		/**
		* UnityEngine.Mesh.SetColors
		*parameters:
		*  inColors : System.Collections.Generic.List &lt; UnityEngine.Color32 &gt; 
		*/
		[native,unityengine_Mesh_setColors_];
		public final function setColors_(inColors:system.collections.generic.List_Of_Color32):void;

		/**
		* UnityEngine.Mesh.SetUVs
		*parameters:
		*  channel : System.Int32
		*  uvs : System.Collections.Generic.List &lt; UnityEngine.Vector2 &gt; 
		*/
		[native,unityengine_Mesh_setUVs];
		public final function setUVs(channel:int,uvs:system.collections.generic.List_Of_Vector2):void;

		/**
		* UnityEngine.Mesh.SetUVs
		*parameters:
		*  channel : System.Int32
		*  uvs : System.Collections.Generic.List &lt; UnityEngine.Vector3 &gt; 
		*/
		[native,unityengine_Mesh_setUVs_];
		public final function setUVs_(channel:int,uvs:system.collections.generic.List_Of_Vector3):void;

		/**
		* UnityEngine.Mesh.SetUVs
		*parameters:
		*  channel : System.Int32
		*  uvs : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_Mesh_setUVs__];
		public final function setUVs__(channel:int,uvs:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Mesh.GetUVs
		*parameters:
		*  channel : System.Int32
		*  uvs : System.Collections.Generic.List &lt; UnityEngine.Vector2 &gt; 
		*/
		[native,unityengine_Mesh_getUVs];
		public final function getUVs(channel:int,uvs:system.collections.generic.List_Of_Vector2):void;

		/**
		* UnityEngine.Mesh.GetUVs
		*parameters:
		*  channel : System.Int32
		*  uvs : System.Collections.Generic.List &lt; UnityEngine.Vector3 &gt; 
		*/
		[native,unityengine_Mesh_getUVs_];
		public final function getUVs_(channel:int,uvs:system.collections.generic.List_Of_Vector3):void;

		/**
		* UnityEngine.Mesh.GetUVs
		*parameters:
		*  channel : System.Int32
		*  uvs : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_Mesh_getUVs__];
		public final function getUVs__(channel:int,uvs:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Mesh.get_triangles
		*return:
		*   System.Int32[]
		*/
		[native,unityengine_Mesh_get_triangles]
		public final function get triangles():_Array_;

		/**
		* UnityEngine.Mesh.set_triangles
		*parameters:
		*  value : System.Int32[]
		*/
		[native,unityengine_Mesh_set_triangles]
		public final function set triangles(value:_Array_):void;

		/**
		* UnityEngine.Mesh.GetTriangles
		*parameters:
		*  submesh : System.Int32
		*return:
		*   System.Int32[]
		*/
		[native,unityengine_Mesh_getTriangles];
		public final function getTriangles(submesh:int):_Array_;

		/**
		* UnityEngine.Mesh.GetTriangles
		*parameters:
		*  triangles : System.Collections.Generic.List &lt; System.Int32 &gt; 
		*  submesh : System.Int32
		*/
		[native,unityengine_Mesh_getTriangles_];
		public final function getTriangles_(triangles:system.collections.generic.List_Of_Int32,submesh:int):void;

		/**
		* UnityEngine.Mesh.GetIndices
		*parameters:
		*  submesh : System.Int32
		*return:
		*   System.Int32[]
		*/
		[native,unityengine_Mesh_getIndices];
		public final function getIndices(submesh:int):_Array_;

		/**
		* UnityEngine.Mesh.GetIndices
		*parameters:
		*  indices : System.Collections.Generic.List &lt; System.Int32 &gt; 
		*  submesh : System.Int32
		*/
		[native,unityengine_Mesh_getIndices_];
		public final function getIndices_(indices:system.collections.generic.List_Of_Int32,submesh:int):void;

		/**
		* UnityEngine.Mesh.GetIndexStart
		*parameters:
		*  submesh : System.Int32
		*return:
		*   System.UInt32
		*/
		[native,unityengine_Mesh_getIndexStart];
		public final function getIndexStart(submesh:int):uint;

		/**
		* UnityEngine.Mesh.GetIndexCount
		*parameters:
		*  submesh : System.Int32
		*return:
		*   System.UInt32
		*/
		[native,unityengine_Mesh_getIndexCount];
		public final function getIndexCount(submesh:int):uint;

		/**
		* UnityEngine.Mesh.GetBindposes
		*parameters:
		*  bindposes : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,unityengine_Mesh_getBindposes];
		public final function getBindposes(bindposes:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.Mesh.GetBoneWeights
		*parameters:
		*  boneWeights : System.Collections.Generic.List &lt; UnityEngine.BoneWeight &gt; 
		*/
		[native,unityengine_Mesh_getBoneWeights];
		public final function getBoneWeights(boneWeights:system.collections.generic.List_Of_BoneWeight):void;

		/**
		* UnityEngine.Mesh.Clear
		*parameters:
		*  keepVertexLayout : System.Boolean
		*/
		[native,unityengine_Mesh_clear];
		public final function clear(keepVertexLayout:Boolean):void;

		/**
		* UnityEngine.Mesh.Clear
		*/
		[native,unityengine_Mesh_clear_];
		public final function clear_():void;

		/**
		* UnityEngine.Mesh.RecalculateBounds
		*/
		[native,unityengine_Mesh_recalculateBounds];
		public final function recalculateBounds():void;

		/**
		* UnityEngine.Mesh.RecalculateNormals
		*/
		[native,unityengine_Mesh_recalculateNormals];
		public final function recalculateNormals():void;

		/**
		* UnityEngine.Mesh.RecalculateTangents
		*/
		[native,unityengine_Mesh_recalculateTangents];
		public final function recalculateTangents():void;

		/**
		* UnityEngine.Mesh.MarkDynamic
		*/
		[native,unityengine_Mesh_markDynamic];
		public final function markDynamic():void;

		/**
		* UnityEngine.Mesh.UploadMeshData
		*parameters:
		*  markNoLogerReadable : System.Boolean
		*/
		[native,unityengine_Mesh_uploadMeshData];
		public final function uploadMeshData(markNoLogerReadable:Boolean):void;

		/**
		* UnityEngine.Mesh.SetTriangles
		*parameters:
		*  triangles : System.Int32[]
		*  submesh : System.Int32
		*/
		[native,unityengine_Mesh_setTriangles];
		public final function setTriangles(triangles:_Array_,submesh:int):void;

		/**
		* UnityEngine.Mesh.SetTriangles
		*parameters:
		*  triangles : System.Int32[]
		*  submesh : System.Int32
		*  calculateBounds : System.Boolean
		*/
		[native,unityengine_Mesh_setTriangles_];
		public final function setTriangles_(triangles:_Array_,submesh:int,calculateBounds:Boolean):void;

		/**
		* UnityEngine.Mesh.SetTriangles
		*parameters:
		*  triangles : System.Collections.Generic.List &lt; System.Int32 &gt; 
		*  submesh : System.Int32
		*/
		[native,unityengine_Mesh_setTriangles__];
		public final function setTriangles__(triangles:system.collections.generic.List_Of_Int32,submesh:int):void;

		/**
		* UnityEngine.Mesh.SetTriangles
		*parameters:
		*  triangles : System.Collections.Generic.List &lt; System.Int32 &gt; 
		*  submesh : System.Int32
		*  calculateBounds : System.Boolean
		*/
		[native,unityengine_Mesh_setTriangles___];
		public final function setTriangles___(triangles:system.collections.generic.List_Of_Int32,submesh:int,calculateBounds:Boolean):void;

		/**
		* UnityEngine.Mesh.SetIndices
		*parameters:
		*  indices : System.Int32[]
		*  topology : UnityEngine.MeshTopology
		*  submesh : System.Int32
		*/
		[native,unityengine_Mesh_setIndices];
		public final function setIndices(indices:_Array_,topology:MeshTopology,submesh:int):void;

		/**
		* UnityEngine.Mesh.SetIndices
		*parameters:
		*  indices : System.Int32[]
		*  topology : UnityEngine.MeshTopology
		*  submesh : System.Int32
		*  calculateBounds : System.Boolean
		*/
		[native,unityengine_Mesh_setIndices_];
		public final function setIndices_(indices:_Array_,topology:MeshTopology,submesh:int,calculateBounds:Boolean):void;

		/**
		* UnityEngine.Mesh.GetBlendShapeFrameVertices
		*parameters:
		*  shapeIndex : System.Int32
		*  frameIndex : System.Int32
		*  deltaVertices : UnityEngine.Vector3[]
		*  deltaNormals : UnityEngine.Vector3[]
		*  deltaTangents : UnityEngine.Vector3[]
		*/
		[native,unityengine_Mesh_getBlendShapeFrameVertices];
		public final function getBlendShapeFrameVertices(shapeIndex:int,frameIndex:int,deltaVertices:_Array_,deltaNormals:_Array_,deltaTangents:_Array_):void;

		/**
		* UnityEngine.Mesh.AddBlendShapeFrame
		*parameters:
		*  shapeName : System.String
		*  frameWeight : System.Single
		*  deltaVertices : UnityEngine.Vector3[]
		*  deltaNormals : UnityEngine.Vector3[]
		*  deltaTangents : UnityEngine.Vector3[]
		*/
		[native,unityengine_Mesh_addBlendShapeFrame];
		public final function addBlendShapeFrame(shapeName:String,frameWeight:Number,deltaVertices:_Array_,deltaNormals:_Array_,deltaTangents:_Array_):void;

		/**
		* UnityEngine.Mesh.get_bounds
		*return:
		*   UnityEngine.Bounds
		*/
		[native,unityengine_Mesh_get_bounds]
		public final function get bounds():Bounds;

		/**
		* UnityEngine.Mesh.set_bounds
		*parameters:
		*  value : UnityEngine.Bounds
		*/
		[native,unityengine_Mesh_set_bounds]
		public final function set bounds(value:Bounds):void;

		/**
		* UnityEngine.Mesh.GetTopology
		*parameters:
		*  submesh : System.Int32
		*return:
		*   UnityEngine.MeshTopology
		*/
		[native,unityengine_Mesh_getTopology];
		public final function getTopology(submesh:int):MeshTopology;

		/**
		* UnityEngine.Mesh.CombineMeshes
		*parameters:
		*  combine : UnityEngine.CombineInstance[]
		*  mergeSubMeshes : System.Boolean
		*  useMatrices : System.Boolean
		*  hasLightmapData : System.Boolean
		*/
		[native,unityengine_Mesh_combineMeshes];
		public final function combineMeshes(combine:_Array_,mergeSubMeshes:Boolean,useMatrices:Boolean,hasLightmapData:Boolean):void;

		/**
		* UnityEngine.Mesh.CombineMeshes
		*parameters:
		*  combine : UnityEngine.CombineInstance[]
		*  mergeSubMeshes : System.Boolean
		*  useMatrices : System.Boolean
		*/
		[native,unityengine_Mesh_combineMeshes_];
		public final function combineMeshes_(combine:_Array_,mergeSubMeshes:Boolean,useMatrices:Boolean):void;

		/**
		* UnityEngine.Mesh.CombineMeshes
		*parameters:
		*  combine : UnityEngine.CombineInstance[]
		*  mergeSubMeshes : System.Boolean
		*/
		[native,unityengine_Mesh_combineMeshes__];
		public final function combineMeshes__(combine:_Array_,mergeSubMeshes:Boolean):void;

		/**
		* UnityEngine.Mesh.CombineMeshes
		*parameters:
		*  combine : UnityEngine.CombineInstance[]
		*/
		[native,unityengine_Mesh_combineMeshes___];
		public final function combineMeshes___(combine:_Array_):void;

		/**
		* UnityEngine.Mesh.get_boneWeights
		*return:
		*   UnityEngine.BoneWeight[]
		*/
		[native,unityengine_Mesh_get_boneWeights]
		public final function get boneWeights():_Array_;

		/**
		* UnityEngine.Mesh.set_boneWeights
		*parameters:
		*  value : UnityEngine.BoneWeight[]
		*/
		[native,unityengine_Mesh_set_boneWeights]
		public final function set boneWeights(value:_Array_):void;

		/**
		* UnityEngine.Mesh.get_bindposes
		*return:
		*   UnityEngine.Matrix4x4[]
		*/
		[native,unityengine_Mesh_get_bindposes]
		public final function get bindposes():_Array_;

		/**
		* UnityEngine.Mesh.set_bindposes
		*parameters:
		*  value : UnityEngine.Matrix4x4[]
		*/
		[native,unityengine_Mesh_set_bindposes]
		public final function set bindposes(value:_Array_):void;

		/**
		* UnityEngine.Mesh.get_isReadable
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Mesh_get_isReadable]
		public final function get isReadable():Boolean;

		/**
		* UnityEngine.Mesh.get_vertexCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_Mesh_get_vertexCount]
		public final function get vertexCount():int;

		/**
		* UnityEngine.Mesh.get_subMeshCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_Mesh_get_subMeshCount]
		public final function get subMeshCount():int;

		/**
		* UnityEngine.Mesh.set_subMeshCount
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_Mesh_set_subMeshCount]
		public final function set subMeshCount(value:int):void;

		/**
		* UnityEngine.Mesh.get_vertexBufferCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_Mesh_get_vertexBufferCount]
		public final function get vertexBufferCount():int;

		/**
		* UnityEngine.Mesh.GetNativeVertexBufferPtr
		*parameters:
		*  index : System.Int32
		*return:
		*   System.IntPtr
		*/
		[native,unityengine_Mesh_getNativeVertexBufferPtr];
		public final function getNativeVertexBufferPtr(index:int):system.IntPtr;

		/**
		* UnityEngine.Mesh.GetNativeIndexBufferPtr
		*return:
		*   System.IntPtr
		*/
		[native,unityengine_Mesh_getNativeIndexBufferPtr];
		public final function getNativeIndexBufferPtr():system.IntPtr;

		/**
		* UnityEngine.Mesh.get_blendShapeCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_Mesh_get_blendShapeCount]
		public final function get blendShapeCount():int;

		/**
		* UnityEngine.Mesh.ClearBlendShapes
		*/
		[native,unityengine_Mesh_clearBlendShapes];
		public final function clearBlendShapes():void;

		/**
		* UnityEngine.Mesh.GetBlendShapeName
		*parameters:
		*  shapeIndex : System.Int32
		*return:
		*   System.String
		*/
		[native,unityengine_Mesh_getBlendShapeName];
		public final function getBlendShapeName(shapeIndex:int):String;

		/**
		* UnityEngine.Mesh.GetBlendShapeIndex
		*parameters:
		*  blendShapeName : System.String
		*return:
		*   System.Int32
		*/
		[native,unityengine_Mesh_getBlendShapeIndex];
		public final function getBlendShapeIndex(blendShapeName:String):int;

		/**
		* UnityEngine.Mesh.GetBlendShapeFrameCount
		*parameters:
		*  shapeIndex : System.Int32
		*return:
		*   System.Int32
		*/
		[native,unityengine_Mesh_getBlendShapeFrameCount];
		public final function getBlendShapeFrameCount(shapeIndex:int):int;

		/**
		* UnityEngine.Mesh.GetBlendShapeFrameWeight
		*parameters:
		*  shapeIndex : System.Int32
		*  frameIndex : System.Int32
		*return:
		*   System.Single
		*/
		[native,unityengine_Mesh_getBlendShapeFrameWeight];
		public final function getBlendShapeFrameWeight(shapeIndex:int,frameIndex:int):Number;

		/**
		* UnityEngine.Mesh.get_vertices
		*return:
		*   UnityEngine.Vector3[]
		*/
		[native,unityengine_Mesh_get_vertices]
		public final function get vertices():_Array_;

		/**
		* UnityEngine.Mesh.set_vertices
		*parameters:
		*  value : UnityEngine.Vector3[]
		*/
		[native,unityengine_Mesh_set_vertices]
		public final function set vertices(value:_Array_):void;

		/**
		* UnityEngine.Mesh.get_normals
		*return:
		*   UnityEngine.Vector3[]
		*/
		[native,unityengine_Mesh_get_normals]
		public final function get normals():_Array_;

		/**
		* UnityEngine.Mesh.set_normals
		*parameters:
		*  value : UnityEngine.Vector3[]
		*/
		[native,unityengine_Mesh_set_normals]
		public final function set normals(value:_Array_):void;

		/**
		* UnityEngine.Mesh.get_tangents
		*return:
		*   UnityEngine.Vector4[]
		*/
		[native,unityengine_Mesh_get_tangents]
		public final function get tangents():_Array_;

		/**
		* UnityEngine.Mesh.set_tangents
		*parameters:
		*  value : UnityEngine.Vector4[]
		*/
		[native,unityengine_Mesh_set_tangents]
		public final function set tangents(value:_Array_):void;

		/**
		* UnityEngine.Mesh.get_uv
		*return:
		*   UnityEngine.Vector2[]
		*/
		[native,unityengine_Mesh_get_uv]
		public final function get uv():_Array_;

		/**
		* UnityEngine.Mesh.set_uv
		*parameters:
		*  value : UnityEngine.Vector2[]
		*/
		[native,unityengine_Mesh_set_uv]
		public final function set uv(value:_Array_):void;

		/**
		* UnityEngine.Mesh.get_uv2
		*return:
		*   UnityEngine.Vector2[]
		*/
		[native,unityengine_Mesh_get_uv2]
		public final function get uv2():_Array_;

		/**
		* UnityEngine.Mesh.set_uv2
		*parameters:
		*  value : UnityEngine.Vector2[]
		*/
		[native,unityengine_Mesh_set_uv2]
		public final function set uv2(value:_Array_):void;

		/**
		* UnityEngine.Mesh.get_uv3
		*return:
		*   UnityEngine.Vector2[]
		*/
		[native,unityengine_Mesh_get_uv3]
		public final function get uv3():_Array_;

		/**
		* UnityEngine.Mesh.set_uv3
		*parameters:
		*  value : UnityEngine.Vector2[]
		*/
		[native,unityengine_Mesh_set_uv3]
		public final function set uv3(value:_Array_):void;

		/**
		* UnityEngine.Mesh.get_uv4
		*return:
		*   UnityEngine.Vector2[]
		*/
		[native,unityengine_Mesh_get_uv4]
		public final function get uv4():_Array_;


	}
}
