package unityengine
{
	import system._Object_;
	import system._Array_;


		/**
		* Sealed
		*  UnityEngine.Network
		*/
	[link_system]
	public final class Network extends system._Object_
	{
		[creator];
		[native,unityengine_Network_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Network_ctor];
		public function Network();


		//*********公共方法*******
		/**
		* UnityEngine.Network.InitializeServer
		*parameters:
		*  connections : System.Int32
		*  listenPort : System.Int32
		*  useNat : System.Boolean
		*return:
		*   UnityEngine.NetworkConnectionError
		*/
		[native,static_unityengine_Network_initializeServer];
		public static function initializeServer(connections:int,listenPort:int,useNat:Boolean):NetworkConnectionError;

		/**
		* UnityEngine.Network.get_incomingPassword
		*return:
		*   System.String
		*/
		[native,static_unityengine_Network_get_incomingPassword]
		public static function get incomingPassword():String;

		/**
		* UnityEngine.Network.set_incomingPassword
		*parameters:
		*  value : System.String
		*/
		[native,static_unityengine_Network_set_incomingPassword]
		public static function set incomingPassword(value:String):void;

		/**
		* UnityEngine.Network.get_logLevel
		*return:
		*   UnityEngine.NetworkLogLevel
		*/
		[native,static_unityengine_Network_get_logLevel]
		public static function get logLevel():NetworkLogLevel;

		/**
		* UnityEngine.Network.set_logLevel
		*parameters:
		*  value : UnityEngine.NetworkLogLevel
		*/
		[native,static_unityengine_Network_set_logLevel]
		public static function set logLevel(value:NetworkLogLevel):void;

		/**
		* UnityEngine.Network.InitializeSecurity
		*/
		[native,static_unityengine_Network_initializeSecurity];
		public static function initializeSecurity():void;

		/**
		* UnityEngine.Network.Connect
		*parameters:
		*  IP : System.String
		*  remotePort : System.Int32
		*return:
		*   UnityEngine.NetworkConnectionError
		*/
		[native,static_unityengine_Network_connect];
		public static function connect(IP:String,remotePort:int):NetworkConnectionError;

		/**
		* UnityEngine.Network.Connect
		*parameters:
		*  IP : System.String
		*  remotePort : System.Int32
		*  password : System.String
		*return:
		*   UnityEngine.NetworkConnectionError
		*/
		[native,static_unityengine_Network_connect_];
		public static function connect_(IP:String,remotePort:int,password:String):NetworkConnectionError;

		/**
		* UnityEngine.Network.Connect
		*parameters:
		*  IPs : System.String[]
		*  remotePort : System.Int32
		*return:
		*   UnityEngine.NetworkConnectionError
		*/
		[native,static_unityengine_Network_connect__];
		public static function connect__(IPs:_Array_,remotePort:int):NetworkConnectionError;

		/**
		* UnityEngine.Network.Connect
		*parameters:
		*  IPs : System.String[]
		*  remotePort : System.Int32
		*  password : System.String
		*return:
		*   UnityEngine.NetworkConnectionError
		*/
		[native,static_unityengine_Network_connect___];
		public static function connect___(IPs:_Array_,remotePort:int,password:String):NetworkConnectionError;

		/**
		* UnityEngine.Network.Connect
		*parameters:
		*  GUID : System.String
		*return:
		*   UnityEngine.NetworkConnectionError
		*/
		[native,static_unityengine_Network_connect____];
		public static function connect____(GUID:String):NetworkConnectionError;

		/**
		* UnityEngine.Network.Connect
		*parameters:
		*  GUID : System.String
		*  password : System.String
		*return:
		*   UnityEngine.NetworkConnectionError
		*/
		[native,static_unityengine_Network_connect_____];
		public static function connect_____(GUID:String,password:String):NetworkConnectionError;

		/**
		* UnityEngine.Network.Connect
		*parameters:
		*  hostData : UnityEngine.HostData
		*return:
		*   UnityEngine.NetworkConnectionError
		*/
		[native,static_unityengine_Network_connect______];
		public static function connect______(hostData:HostData):NetworkConnectionError;

		/**
		* UnityEngine.Network.Connect
		*parameters:
		*  hostData : UnityEngine.HostData
		*  password : System.String
		*return:
		*   UnityEngine.NetworkConnectionError
		*/
		[native,static_unityengine_Network_connect_______];
		public static function connect_______(hostData:HostData,password:String):NetworkConnectionError;

		/**
		* UnityEngine.Network.Disconnect
		*parameters:
		*  timeout : System.Int32
		*/
		[native,static_unityengine_Network_disconnect];
		public static function disconnect(timeout:int):void;

		/**
		* UnityEngine.Network.Disconnect
		*/
		[native,static_unityengine_Network_disconnect_];
		public static function disconnect_():void;

		/**
		* UnityEngine.Network.CloseConnection
		*parameters:
		*  target : UnityEngine.NetworkPlayer
		*  sendDisconnectionNotification : System.Boolean
		*/
		[native,static_unityengine_Network_closeConnection];
		public static function closeConnection(target:NetworkPlayer,sendDisconnectionNotification:Boolean):void;

		/**
		* UnityEngine.Network.get_connections
		*return:
		*   UnityEngine.NetworkPlayer[]
		*/
		[native,static_unityengine_Network_get_connections]
		public static function get connections():_Array_;

		/**
		* UnityEngine.Network.get_player
		*return:
		*   UnityEngine.NetworkPlayer
		*/
		[native,static_unityengine_Network_get_player]
		public static function get player():NetworkPlayer;

		/**
		* UnityEngine.Network.AllocateViewID
		*return:
		*   UnityEngine.NetworkViewID
		*/
		[native,static_unityengine_Network_allocateViewID];
		public static function allocateViewID():NetworkViewID;

		/**
		* UnityEngine.Network.Instantiate
		*parameters:
		*  prefab : UnityEngine.Object
		*  position : UnityEngine.Vector3
		*  rotation : UnityEngine.Quaternion
		*  group : System.Int32
		*return:
		*   UnityEngine.Object
		*/
		[native,static_unityengine_Network_instantiate];
		public static function instantiate(prefab:UObject,position:Vector3,rotation:Quaternion,group:int):UObject;

		/**
		* UnityEngine.Network.Destroy
		*parameters:
		*  viewID : UnityEngine.NetworkViewID
		*/
		[native,static_unityengine_Network_destroy];
		public static function destroy(viewID:NetworkViewID):void;

		/**
		* UnityEngine.Network.Destroy
		*parameters:
		*  gameObject : UnityEngine.GameObject
		*/
		[native,static_unityengine_Network_destroy_];
		public static function destroy_(gameObject:GameObject):void;

		/**
		* UnityEngine.Network.DestroyPlayerObjects
		*parameters:
		*  playerID : UnityEngine.NetworkPlayer
		*/
		[native,static_unityengine_Network_destroyPlayerObjects];
		public static function destroyPlayerObjects(playerID:NetworkPlayer):void;

		/**
		* UnityEngine.Network.RemoveRPCs
		*parameters:
		*  playerID : UnityEngine.NetworkPlayer
		*/
		[native,static_unityengine_Network_removeRPCs];
		public static function removeRPCs(playerID:NetworkPlayer):void;

		/**
		* UnityEngine.Network.RemoveRPCs
		*parameters:
		*  playerID : UnityEngine.NetworkPlayer
		*  group : System.Int32
		*/
		[native,static_unityengine_Network_removeRPCs_];
		public static function removeRPCs_(playerID:NetworkPlayer,group:int):void;

		/**
		* UnityEngine.Network.RemoveRPCs
		*parameters:
		*  viewID : UnityEngine.NetworkViewID
		*/
		[native,static_unityengine_Network_removeRPCs__];
		public static function removeRPCs__(viewID:NetworkViewID):void;

		/**
		* UnityEngine.Network.RemoveRPCsInGroup
		*parameters:
		*  group : System.Int32
		*/
		[native,static_unityengine_Network_removeRPCsInGroup];
		public static function removeRPCsInGroup(group:int):void;

		/**
		* UnityEngine.Network.get_isClient
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Network_get_isClient]
		public static function get isClient():Boolean;

		/**
		* UnityEngine.Network.get_isServer
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Network_get_isServer]
		public static function get isServer():Boolean;

		/**
		* UnityEngine.Network.get_peerType
		*return:
		*   UnityEngine.NetworkPeerType
		*/
		[native,static_unityengine_Network_get_peerType]
		public static function get peerType():NetworkPeerType;

		/**
		* UnityEngine.Network.SetLevelPrefix
		*parameters:
		*  prefix : System.Int32
		*/
		[native,static_unityengine_Network_setLevelPrefix];
		public static function setLevelPrefix(prefix:int):void;

		/**
		* UnityEngine.Network.GetLastPing
		*parameters:
		*  player : UnityEngine.NetworkPlayer
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Network_getLastPing];
		public static function getLastPing(player:NetworkPlayer):int;

		/**
		* UnityEngine.Network.GetAveragePing
		*parameters:
		*  player : UnityEngine.NetworkPlayer
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Network_getAveragePing];
		public static function getAveragePing(player:NetworkPlayer):int;

		/**
		* UnityEngine.Network.get_sendRate
		*return:
		*   System.Single
		*/
		[native,static_unityengine_Network_get_sendRate]
		public static function get sendRate():Number;

		/**
		* UnityEngine.Network.set_sendRate
		*parameters:
		*  value : System.Single
		*/
		[native,static_unityengine_Network_set_sendRate]
		public static function set sendRate(value:Number):void;

		/**
		* UnityEngine.Network.get_isMessageQueueRunning
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Network_get_isMessageQueueRunning]
		public static function get isMessageQueueRunning():Boolean;

		/**
		* UnityEngine.Network.set_isMessageQueueRunning
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_Network_set_isMessageQueueRunning]
		public static function set isMessageQueueRunning(value:Boolean):void;

		/**
		* UnityEngine.Network.SetReceivingEnabled
		*parameters:
		*  player : UnityEngine.NetworkPlayer
		*  group : System.Int32
		*  enabled : System.Boolean
		*/
		[native,static_unityengine_Network_setReceivingEnabled];
		public static function setReceivingEnabled(player:NetworkPlayer,group:int,enabled:Boolean):void;

		/**
		* UnityEngine.Network.SetSendingEnabled
		*parameters:
		*  group : System.Int32
		*  enabled : System.Boolean
		*/
		[native,static_unityengine_Network_setSendingEnabled];
		public static function setSendingEnabled(group:int,enabled:Boolean):void;

		/**
		* UnityEngine.Network.SetSendingEnabled
		*parameters:
		*  player : UnityEngine.NetworkPlayer
		*  group : System.Int32
		*  enabled : System.Boolean
		*/
		[native,static_unityengine_Network_setSendingEnabled_];
		public static function setSendingEnabled_(player:NetworkPlayer,group:int,enabled:Boolean):void;

		/**
		* UnityEngine.Network.get_time
		*return:
		*   System.Double
		*/
		[native,static_unityengine_Network_get_time]
		public static function get time():Number;

		/**
		* UnityEngine.Network.get_minimumAllocatableViewIDs
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Network_get_minimumAllocatableViewIDs]
		public static function get minimumAllocatableViewIDs():int;

		/**
		* UnityEngine.Network.set_minimumAllocatableViewIDs
		*parameters:
		*  value : System.Int32
		*/
		[native,static_unityengine_Network_set_minimumAllocatableViewIDs]
		public static function set minimumAllocatableViewIDs(value:int):void;

		/**
		* UnityEngine.Network.get_natFacilitatorIP
		*return:
		*   System.String
		*/
		[native,static_unityengine_Network_get_natFacilitatorIP]
		public static function get natFacilitatorIP():String;

		/**
		* UnityEngine.Network.set_natFacilitatorIP
		*parameters:
		*  value : System.String
		*/
		[native,static_unityengine_Network_set_natFacilitatorIP]
		public static function set natFacilitatorIP(value:String):void;

		/**
		* UnityEngine.Network.get_natFacilitatorPort
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Network_get_natFacilitatorPort]
		public static function get natFacilitatorPort():int;

		/**
		* UnityEngine.Network.set_natFacilitatorPort
		*parameters:
		*  value : System.Int32
		*/
		[native,static_unityengine_Network_set_natFacilitatorPort]
		public static function set natFacilitatorPort(value:int):void;

		/**
		* UnityEngine.Network.TestConnection
		*parameters:
		*  forceTest : System.Boolean
		*return:
		*   UnityEngine.ConnectionTesterStatus
		*/
		[native,static_unityengine_Network_testConnection];
		public static function testConnection(forceTest:Boolean):ConnectionTesterStatus;

		/**
		* UnityEngine.Network.TestConnection
		*return:
		*   UnityEngine.ConnectionTesterStatus
		*/
		[native,static_unityengine_Network_testConnection_];
		public static function testConnection_():ConnectionTesterStatus;

		/**
		* UnityEngine.Network.TestConnectionNAT
		*parameters:
		*  forceTest : System.Boolean
		*return:
		*   UnityEngine.ConnectionTesterStatus
		*/
		[native,static_unityengine_Network_testConnectionNAT];
		public static function testConnectionNAT(forceTest:Boolean):ConnectionTesterStatus;

		/**
		* UnityEngine.Network.TestConnectionNAT
		*return:
		*   UnityEngine.ConnectionTesterStatus
		*/
		[native,static_unityengine_Network_testConnectionNAT_];
		public static function testConnectionNAT_():ConnectionTesterStatus;

		/**
		* UnityEngine.Network.get_connectionTesterIP
		*return:
		*   System.String
		*/
		[native,static_unityengine_Network_get_connectionTesterIP]
		public static function get connectionTesterIP():String;

		/**
		* UnityEngine.Network.set_connectionTesterIP
		*parameters:
		*  value : System.String
		*/
		[native,static_unityengine_Network_set_connectionTesterIP]
		public static function set connectionTesterIP(value:String):void;

		/**
		* UnityEngine.Network.get_connectionTesterPort
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Network_get_connectionTesterPort]
		public static function get connectionTesterPort():int;

		/**
		* UnityEngine.Network.set_connectionTesterPort
		*parameters:
		*  value : System.Int32
		*/
		[native,static_unityengine_Network_set_connectionTesterPort]
		public static function set connectionTesterPort(value:int):void;

		/**
		* UnityEngine.Network.HavePublicAddress
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Network_havePublicAddress];
		public static function havePublicAddress():Boolean;

		/**
		* UnityEngine.Network.get_maxConnections
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Network_get_maxConnections]
		public static function get maxConnections():int;

		/**
		* UnityEngine.Network.set_maxConnections
		*parameters:
		*  value : System.Int32
		*/
		[native,static_unityengine_Network_set_maxConnections]
		public static function set maxConnections(value:int):void;

		/**
		* UnityEngine.Network.get_proxyIP
		*return:
		*   System.String
		*/
		[native,static_unityengine_Network_get_proxyIP]
		public static function get proxyIP():String;

		/**
		* UnityEngine.Network.set_proxyIP
		*parameters:
		*  value : System.String
		*/
		[native,static_unityengine_Network_set_proxyIP]
		public static function set proxyIP(value:String):void;

		/**
		* UnityEngine.Network.get_proxyPort
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Network_get_proxyPort]
		public static function get proxyPort():int;

		/**
		* UnityEngine.Network.set_proxyPort
		*parameters:
		*  value : System.Int32
		*/
		[native,static_unityengine_Network_set_proxyPort]
		public static function set proxyPort(value:int):void;

		/**
		* UnityEngine.Network.get_useProxy
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Network_get_useProxy]
		public static function get useProxy():Boolean;

		/**
		* UnityEngine.Network.set_useProxy
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_Network_set_useProxy]
		public static function set useProxy(value:Boolean):void;

		/**
		* UnityEngine.Network.get_proxyPassword
		*return:
		*   System.String
		*/
		[native,static_unityengine_Network_get_proxyPassword]
		public static function get proxyPassword():String;

		/**
		* UnityEngine.Network.set_proxyPassword
		*parameters:
		*  value : System.String
		*/
		[native,static_unityengine_Network_set_proxyPassword]
		public static function set proxyPassword(value:String):void;


	}
}
