package unityengine
{
	import system.collections._IEnumerable_;
	import system._Array_;


		/**
		* Sealed
		*  UnityEngine.RectTransform
		*/
	[link_system]
	public final class RectTransform extends Transform implements system.collections._IEnumerable_
	{
		[creator];
		[native,unityengine_RectTransform_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_RectTransform_ctor];
		public function RectTransform();


		//*********公共方法*******
		/**
		* UnityEngine.RectTransform.get_rect
		*return:
		*   UnityEngine.Rect
		*/
		[native,unityengine_RectTransform_get_rect]
		public final function get rect():Rect;

		/**
		* UnityEngine.RectTransform.get_anchorMin
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_get_anchorMin]
		public final function get anchorMin():Vector2;

		/**
		* UnityEngine.RectTransform.set_anchorMin
		*parameters:
		*  value : UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_set_anchorMin]
		public final function set anchorMin(value:Vector2):void;

		/**
		* UnityEngine.RectTransform.get_anchorMax
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_get_anchorMax]
		public final function get anchorMax():Vector2;

		/**
		* UnityEngine.RectTransform.set_anchorMax
		*parameters:
		*  value : UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_set_anchorMax]
		public final function set anchorMax(value:Vector2):void;

		/**
		* UnityEngine.RectTransform.get_anchoredPosition3D
		*return:
		*   UnityEngine.Vector3
		*/
		[native,unityengine_RectTransform_get_anchoredPosition3D]
		public final function get anchoredPosition3D():Vector3;

		/**
		* UnityEngine.RectTransform.set_anchoredPosition3D
		*parameters:
		*  value : UnityEngine.Vector3
		*/
		[native,unityengine_RectTransform_set_anchoredPosition3D]
		public final function set anchoredPosition3D(value:Vector3):void;

		/**
		* UnityEngine.RectTransform.get_anchoredPosition
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_get_anchoredPosition]
		public final function get anchoredPosition():Vector2;

		/**
		* UnityEngine.RectTransform.set_anchoredPosition
		*parameters:
		*  value : UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_set_anchoredPosition]
		public final function set anchoredPosition(value:Vector2):void;

		/**
		* UnityEngine.RectTransform.get_sizeDelta
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_get_sizeDelta]
		public final function get sizeDelta():Vector2;

		/**
		* UnityEngine.RectTransform.set_sizeDelta
		*parameters:
		*  value : UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_set_sizeDelta]
		public final function set sizeDelta(value:Vector2):void;

		/**
		* UnityEngine.RectTransform.get_pivot
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_get_pivot]
		public final function get pivot():Vector2;

		/**
		* UnityEngine.RectTransform.set_pivot
		*parameters:
		*  value : UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_set_pivot]
		public final function set pivot(value:Vector2):void;

		/**
		* UnityEngine.RectTransform.add_reapplyDrivenProperties
		*parameters:
		*  value : UnityEngine.RectTransform.ReapplyDrivenProperties [System.Void(UnityEngine.RectTransform)]
		*/
		[native,static_unityengine_RectTransform_reapplyDrivenProperties_addEventListener];
		public static function reapplyDrivenProperties_addEventListener(value:RectTransform_ReapplyDrivenProperties):void;

		/**
		* UnityEngine.RectTransform.remove_reapplyDrivenProperties
		*parameters:
		*  value : UnityEngine.RectTransform.ReapplyDrivenProperties [System.Void(UnityEngine.RectTransform)]
		*/
		[native,static_unityengine_RectTransform_reapplyDrivenProperties_removeEventListener];
		public static function reapplyDrivenProperties_removeEventListener(value:RectTransform_ReapplyDrivenProperties):void;

		/**
		* UnityEngine.RectTransform.GetLocalCorners
		*parameters:
		*  fourCornersArray : UnityEngine.Vector3[]
		*/
		[native,unityengine_RectTransform_getLocalCorners];
		public final function getLocalCorners(fourCornersArray:_Array_):void;

		/**
		* UnityEngine.RectTransform.GetWorldCorners
		*parameters:
		*  fourCornersArray : UnityEngine.Vector3[]
		*/
		[native,unityengine_RectTransform_getWorldCorners];
		public final function getWorldCorners(fourCornersArray:_Array_):void;

		/**
		* UnityEngine.RectTransform.get_offsetMin
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_get_offsetMin]
		public final function get offsetMin():Vector2;

		/**
		* UnityEngine.RectTransform.set_offsetMin
		*parameters:
		*  value : UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_set_offsetMin]
		public final function set offsetMin(value:Vector2):void;

		/**
		* UnityEngine.RectTransform.get_offsetMax
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_get_offsetMax]
		public final function get offsetMax():Vector2;

		/**
		* UnityEngine.RectTransform.set_offsetMax
		*parameters:
		*  value : UnityEngine.Vector2
		*/
		[native,unityengine_RectTransform_set_offsetMax]
		public final function set offsetMax(value:Vector2):void;

		/**
		* UnityEngine.RectTransform.SetInsetAndSizeFromParentEdge
		*parameters:
		*  edge : UnityEngine.RectTransform.Edge
		*  inset : System.Single
		*  size : System.Single
		*/
		[native,unityengine_RectTransform_setInsetAndSizeFromParentEdge];
		public final function setInsetAndSizeFromParentEdge(edge:RectTransform_Edge,inset:Number,size:Number):void;

		/**
		* UnityEngine.RectTransform.SetSizeWithCurrentAnchors
		*parameters:
		*  axis : UnityEngine.RectTransform.Axis
		*  size : System.Single
		*/
		[native,unityengine_RectTransform_setSizeWithCurrentAnchors];
		public final function setSizeWithCurrentAnchors(axis:RectTransform_Axis,size:Number):void;


	}
}
