package unityengine
{
	import unityengine.rendering.AmbientMode;
	import unityengine.rendering.SphericalHarmonicsL2;
	import unityengine.rendering.DefaultReflectionMode;


		/**
		* Sealed
		*  UnityEngine.RenderSettings
		*/
	[link_system]
	public final class RenderSettings extends UObject
	{
		[creator];
		[native,unityengine_RenderSettings_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_RenderSettings_ctor];
		public function RenderSettings();


		//*********公共方法*******
		/**
		* UnityEngine.RenderSettings.get_fog
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_RenderSettings_get_fog]
		public static function get fog():Boolean;

		/**
		* UnityEngine.RenderSettings.set_fog
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_RenderSettings_set_fog]
		public static function set fog(value:Boolean):void;

		/**
		* UnityEngine.RenderSettings.get_fogMode
		*return:
		*   UnityEngine.FogMode
		*/
		[native,static_unityengine_RenderSettings_get_fogMode]
		public static function get fogMode():FogMode;

		/**
		* UnityEngine.RenderSettings.set_fogMode
		*parameters:
		*  value : UnityEngine.FogMode
		*/
		[native,static_unityengine_RenderSettings_set_fogMode]
		public static function set fogMode(value:FogMode):void;

		/**
		* UnityEngine.RenderSettings.get_fogColor
		*return:
		*   UnityEngine.Color
		*/
		[native,static_unityengine_RenderSettings_get_fogColor]
		public static function get fogColor():Color;

		/**
		* UnityEngine.RenderSettings.set_fogColor
		*parameters:
		*  value : UnityEngine.Color
		*/
		[native,static_unityengine_RenderSettings_set_fogColor]
		public static function set fogColor(value:Color):void;

		/**
		* UnityEngine.RenderSettings.get_fogDensity
		*return:
		*   System.Single
		*/
		[native,static_unityengine_RenderSettings_get_fogDensity]
		public static function get fogDensity():Number;

		/**
		* UnityEngine.RenderSettings.set_fogDensity
		*parameters:
		*  value : System.Single
		*/
		[native,static_unityengine_RenderSettings_set_fogDensity]
		public static function set fogDensity(value:Number):void;

		/**
		* UnityEngine.RenderSettings.get_fogStartDistance
		*return:
		*   System.Single
		*/
		[native,static_unityengine_RenderSettings_get_fogStartDistance]
		public static function get fogStartDistance():Number;

		/**
		* UnityEngine.RenderSettings.set_fogStartDistance
		*parameters:
		*  value : System.Single
		*/
		[native,static_unityengine_RenderSettings_set_fogStartDistance]
		public static function set fogStartDistance(value:Number):void;

		/**
		* UnityEngine.RenderSettings.get_fogEndDistance
		*return:
		*   System.Single
		*/
		[native,static_unityengine_RenderSettings_get_fogEndDistance]
		public static function get fogEndDistance():Number;

		/**
		* UnityEngine.RenderSettings.set_fogEndDistance
		*parameters:
		*  value : System.Single
		*/
		[native,static_unityengine_RenderSettings_set_fogEndDistance]
		public static function set fogEndDistance(value:Number):void;

		/**
		* UnityEngine.RenderSettings.get_ambientMode
		*return:
		*   UnityEngine.Rendering.AmbientMode
		*/
		[native,static_unityengine_RenderSettings_get_ambientMode]
		public static function get ambientMode():unityengine.rendering.AmbientMode;

		/**
		* UnityEngine.RenderSettings.set_ambientMode
		*parameters:
		*  value : UnityEngine.Rendering.AmbientMode
		*/
		[native,static_unityengine_RenderSettings_set_ambientMode]
		public static function set ambientMode(value:unityengine.rendering.AmbientMode):void;

		/**
		* UnityEngine.RenderSettings.get_ambientSkyColor
		*return:
		*   UnityEngine.Color
		*/
		[native,static_unityengine_RenderSettings_get_ambientSkyColor]
		public static function get ambientSkyColor():Color;

		/**
		* UnityEngine.RenderSettings.set_ambientSkyColor
		*parameters:
		*  value : UnityEngine.Color
		*/
		[native,static_unityengine_RenderSettings_set_ambientSkyColor]
		public static function set ambientSkyColor(value:Color):void;

		/**
		* UnityEngine.RenderSettings.get_ambientEquatorColor
		*return:
		*   UnityEngine.Color
		*/
		[native,static_unityengine_RenderSettings_get_ambientEquatorColor]
		public static function get ambientEquatorColor():Color;

		/**
		* UnityEngine.RenderSettings.set_ambientEquatorColor
		*parameters:
		*  value : UnityEngine.Color
		*/
		[native,static_unityengine_RenderSettings_set_ambientEquatorColor]
		public static function set ambientEquatorColor(value:Color):void;

		/**
		* UnityEngine.RenderSettings.get_ambientGroundColor
		*return:
		*   UnityEngine.Color
		*/
		[native,static_unityengine_RenderSettings_get_ambientGroundColor]
		public static function get ambientGroundColor():Color;

		/**
		* UnityEngine.RenderSettings.set_ambientGroundColor
		*parameters:
		*  value : UnityEngine.Color
		*/
		[native,static_unityengine_RenderSettings_set_ambientGroundColor]
		public static function set ambientGroundColor(value:Color):void;

		/**
		* UnityEngine.RenderSettings.get_ambientLight
		*return:
		*   UnityEngine.Color
		*/
		[native,static_unityengine_RenderSettings_get_ambientLight]
		public static function get ambientLight():Color;

		/**
		* UnityEngine.RenderSettings.set_ambientLight
		*parameters:
		*  value : UnityEngine.Color
		*/
		[native,static_unityengine_RenderSettings_set_ambientLight]
		public static function set ambientLight(value:Color):void;

		/**
		* UnityEngine.RenderSettings.get_ambientIntensity
		*return:
		*   System.Single
		*/
		[native,static_unityengine_RenderSettings_get_ambientIntensity]
		public static function get ambientIntensity():Number;

		/**
		* UnityEngine.RenderSettings.set_ambientIntensity
		*parameters:
		*  value : System.Single
		*/
		[native,static_unityengine_RenderSettings_set_ambientIntensity]
		public static function set ambientIntensity(value:Number):void;

		/**
		* UnityEngine.RenderSettings.get_ambientProbe
		*return:
		*   UnityEngine.Rendering.SphericalHarmonicsL2
		*/
		[native,static_unityengine_RenderSettings_get_ambientProbe]
		public static function get ambientProbe():unityengine.rendering.SphericalHarmonicsL2;

		/**
		* UnityEngine.RenderSettings.set_ambientProbe
		*parameters:
		*  value : UnityEngine.Rendering.SphericalHarmonicsL2
		*/
		[native,static_unityengine_RenderSettings_set_ambientProbe]
		public static function set ambientProbe(value:unityengine.rendering.SphericalHarmonicsL2):void;

		/**
		* UnityEngine.RenderSettings.get_subtractiveShadowColor
		*return:
		*   UnityEngine.Color
		*/
		[native,static_unityengine_RenderSettings_get_subtractiveShadowColor]
		public static function get subtractiveShadowColor():Color;

		/**
		* UnityEngine.RenderSettings.set_subtractiveShadowColor
		*parameters:
		*  value : UnityEngine.Color
		*/
		[native,static_unityengine_RenderSettings_set_subtractiveShadowColor]
		public static function set subtractiveShadowColor(value:Color):void;

		/**
		* UnityEngine.RenderSettings.get_reflectionIntensity
		*return:
		*   System.Single
		*/
		[native,static_unityengine_RenderSettings_get_reflectionIntensity]
		public static function get reflectionIntensity():Number;

		/**
		* UnityEngine.RenderSettings.set_reflectionIntensity
		*parameters:
		*  value : System.Single
		*/
		[native,static_unityengine_RenderSettings_set_reflectionIntensity]
		public static function set reflectionIntensity(value:Number):void;

		/**
		* UnityEngine.RenderSettings.get_reflectionBounces
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_RenderSettings_get_reflectionBounces]
		public static function get reflectionBounces():int;

		/**
		* UnityEngine.RenderSettings.set_reflectionBounces
		*parameters:
		*  value : System.Int32
		*/
		[native,static_unityengine_RenderSettings_set_reflectionBounces]
		public static function set reflectionBounces(value:int):void;

		/**
		* UnityEngine.RenderSettings.get_haloStrength
		*return:
		*   System.Single
		*/
		[native,static_unityengine_RenderSettings_get_haloStrength]
		public static function get haloStrength():Number;

		/**
		* UnityEngine.RenderSettings.set_haloStrength
		*parameters:
		*  value : System.Single
		*/
		[native,static_unityengine_RenderSettings_set_haloStrength]
		public static function set haloStrength(value:Number):void;

		/**
		* UnityEngine.RenderSettings.get_flareStrength
		*return:
		*   System.Single
		*/
		[native,static_unityengine_RenderSettings_get_flareStrength]
		public static function get flareStrength():Number;

		/**
		* UnityEngine.RenderSettings.set_flareStrength
		*parameters:
		*  value : System.Single
		*/
		[native,static_unityengine_RenderSettings_set_flareStrength]
		public static function set flareStrength(value:Number):void;

		/**
		* UnityEngine.RenderSettings.get_flareFadeSpeed
		*return:
		*   System.Single
		*/
		[native,static_unityengine_RenderSettings_get_flareFadeSpeed]
		public static function get flareFadeSpeed():Number;

		/**
		* UnityEngine.RenderSettings.set_flareFadeSpeed
		*parameters:
		*  value : System.Single
		*/
		[native,static_unityengine_RenderSettings_set_flareFadeSpeed]
		public static function set flareFadeSpeed(value:Number):void;

		/**
		* UnityEngine.RenderSettings.get_skybox
		*return:
		*   UnityEngine.Material
		*/
		[native,static_unityengine_RenderSettings_get_skybox]
		public static function get skybox():Material;

		/**
		* UnityEngine.RenderSettings.set_skybox
		*parameters:
		*  value : UnityEngine.Material
		*/
		[native,static_unityengine_RenderSettings_set_skybox]
		public static function set skybox(value:Material):void;

		/**
		* UnityEngine.RenderSettings.get_sun
		*return:
		*   UnityEngine.Light
		*/
		[native,static_unityengine_RenderSettings_get_sun]
		public static function get sun():Light;

		/**
		* UnityEngine.RenderSettings.set_sun
		*parameters:
		*  value : UnityEngine.Light
		*/
		[native,static_unityengine_RenderSettings_set_sun]
		public static function set sun(value:Light):void;

		/**
		* UnityEngine.RenderSettings.get_defaultReflectionMode
		*return:
		*   UnityEngine.Rendering.DefaultReflectionMode
		*/
		[native,static_unityengine_RenderSettings_get_defaultReflectionMode]
		public static function get defaultReflectionMode():unityengine.rendering.DefaultReflectionMode;

		/**
		* UnityEngine.RenderSettings.set_defaultReflectionMode
		*parameters:
		*  value : UnityEngine.Rendering.DefaultReflectionMode
		*/
		[native,static_unityengine_RenderSettings_set_defaultReflectionMode]
		public static function set defaultReflectionMode(value:unityengine.rendering.DefaultReflectionMode):void;

		/**
		* UnityEngine.RenderSettings.get_defaultReflectionResolution
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_RenderSettings_get_defaultReflectionResolution]
		public static function get defaultReflectionResolution():int;

		/**
		* UnityEngine.RenderSettings.set_defaultReflectionResolution
		*parameters:
		*  value : System.Int32
		*/
		[native,static_unityengine_RenderSettings_set_defaultReflectionResolution]
		public static function set defaultReflectionResolution(value:int):void;

		/**
		* UnityEngine.RenderSettings.get_customReflection
		*return:
		*   UnityEngine.Cubemap
		*/
		[native,static_unityengine_RenderSettings_get_customReflection]
		public static function get customReflection():Cubemap;

		/**
		* UnityEngine.RenderSettings.set_customReflection
		*parameters:
		*  value : UnityEngine.Cubemap
		*/
		[native,static_unityengine_RenderSettings_set_customReflection]
		public static function set customReflection(value:Cubemap):void;


	}
}
