package unityengine
{
	import system._Object_;
	import unityengine.rendering.TextureDimension;
	import unityengine.rendering.ShadowSamplingMode;


		/**
		* Struct
		*  UnityEngine.RenderTextureDescriptor
		*/
	[struct]
	[link_system]
	public final class RenderTextureDescriptor extends system._Object_
	{
		[creator];
		[native,unityengine_RenderTextureDescriptor_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_RenderTextureDescriptor_constructor_];
		public static function constructor_(width:int,height:int,colorFormat:RenderTextureFormat):RenderTextureDescriptor;

		[native,unityengine_RenderTextureDescriptor_constructor__];
		public static function constructor__(width:int,height:int,colorFormat:RenderTextureFormat,depthBufferBits:int):RenderTextureDescriptor;

		[native,unityengine_RenderTextureDescriptor_ctor];
		public function RenderTextureDescriptor(width:int,height:int);


		//*********公共方法*******
		/**
		* UnityEngine.RenderTextureDescriptor.get_width
		*return:
		*   System.Int32
		*/
		[native,unityengine_RenderTextureDescriptor_get_width]
		public final function get width():int;

		/**
		* UnityEngine.RenderTextureDescriptor.set_width
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_RenderTextureDescriptor_set_width]
		public final function set width(value:int):void;

		/**
		* UnityEngine.RenderTextureDescriptor.get_height
		*return:
		*   System.Int32
		*/
		[native,unityengine_RenderTextureDescriptor_get_height]
		public final function get height():int;

		/**
		* UnityEngine.RenderTextureDescriptor.set_height
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_RenderTextureDescriptor_set_height]
		public final function set height(value:int):void;

		/**
		* UnityEngine.RenderTextureDescriptor.get_msaaSamples
		*return:
		*   System.Int32
		*/
		[native,unityengine_RenderTextureDescriptor_get_msaaSamples]
		public final function get msaaSamples():int;

		/**
		* UnityEngine.RenderTextureDescriptor.set_msaaSamples
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_RenderTextureDescriptor_set_msaaSamples]
		public final function set msaaSamples(value:int):void;

		/**
		* UnityEngine.RenderTextureDescriptor.get_volumeDepth
		*return:
		*   System.Int32
		*/
		[native,unityengine_RenderTextureDescriptor_get_volumeDepth]
		public final function get volumeDepth():int;

		/**
		* UnityEngine.RenderTextureDescriptor.set_volumeDepth
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_RenderTextureDescriptor_set_volumeDepth]
		public final function set volumeDepth(value:int):void;

		/**
		* UnityEngine.RenderTextureDescriptor.get_colorFormat
		*return:
		*   UnityEngine.RenderTextureFormat
		*/
		[native,unityengine_RenderTextureDescriptor_get_colorFormat]
		public final function get colorFormat():RenderTextureFormat;

		/**
		* UnityEngine.RenderTextureDescriptor.set_colorFormat
		*parameters:
		*  value : UnityEngine.RenderTextureFormat
		*/
		[native,unityengine_RenderTextureDescriptor_set_colorFormat]
		public final function set colorFormat(value:RenderTextureFormat):void;

		/**
		* UnityEngine.RenderTextureDescriptor.get_depthBufferBits
		*return:
		*   System.Int32
		*/
		[native,unityengine_RenderTextureDescriptor_get_depthBufferBits]
		public final function get depthBufferBits():int;

		/**
		* UnityEngine.RenderTextureDescriptor.set_depthBufferBits
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_RenderTextureDescriptor_set_depthBufferBits]
		public final function set depthBufferBits(value:int):void;

		/**
		* UnityEngine.RenderTextureDescriptor.get_dimension
		*return:
		*   UnityEngine.Rendering.TextureDimension
		*/
		[native,unityengine_RenderTextureDescriptor_get_dimension]
		public final function get dimension():unityengine.rendering.TextureDimension;

		/**
		* UnityEngine.RenderTextureDescriptor.set_dimension
		*parameters:
		*  value : UnityEngine.Rendering.TextureDimension
		*/
		[native,unityengine_RenderTextureDescriptor_set_dimension]
		public final function set dimension(value:unityengine.rendering.TextureDimension):void;

		/**
		* UnityEngine.RenderTextureDescriptor.get_shadowSamplingMode
		*return:
		*   UnityEngine.Rendering.ShadowSamplingMode
		*/
		[native,unityengine_RenderTextureDescriptor_get_shadowSamplingMode]
		public final function get shadowSamplingMode():unityengine.rendering.ShadowSamplingMode;

		/**
		* UnityEngine.RenderTextureDescriptor.set_shadowSamplingMode
		*parameters:
		*  value : UnityEngine.Rendering.ShadowSamplingMode
		*/
		[native,unityengine_RenderTextureDescriptor_set_shadowSamplingMode]
		public final function set shadowSamplingMode(value:unityengine.rendering.ShadowSamplingMode):void;

		/**
		* UnityEngine.RenderTextureDescriptor.get_vrUsage
		*return:
		*   UnityEngine.VRTextureUsage
		*/
		[native,unityengine_RenderTextureDescriptor_get_vrUsage]
		public final function get vrUsage():VRTextureUsage;

		/**
		* UnityEngine.RenderTextureDescriptor.set_vrUsage
		*parameters:
		*  value : UnityEngine.VRTextureUsage
		*/
		[native,unityengine_RenderTextureDescriptor_set_vrUsage]
		public final function set vrUsage(value:VRTextureUsage):void;

		/**
		* UnityEngine.RenderTextureDescriptor.get_flags
		*return:
		*   UnityEngine.RenderTextureCreationFlags
		*/
		[native,unityengine_RenderTextureDescriptor_get_flags]
		public final function get flags():RenderTextureCreationFlags;

		/**
		* UnityEngine.RenderTextureDescriptor.get_memoryless
		*return:
		*   UnityEngine.RenderTextureMemoryless
		*/
		[native,unityengine_RenderTextureDescriptor_get_memoryless]
		public final function get memoryless():RenderTextureMemoryless;

		/**
		* UnityEngine.RenderTextureDescriptor.set_memoryless
		*parameters:
		*  value : UnityEngine.RenderTextureMemoryless
		*/
		[native,unityengine_RenderTextureDescriptor_set_memoryless]
		public final function set memoryless(value:RenderTextureMemoryless):void;

		/**
		* UnityEngine.RenderTextureDescriptor.get_sRGB
		*return:
		*   System.Boolean
		*/
		[native,unityengine_RenderTextureDescriptor_get_sRGB]
		public final function get sRGB():Boolean;

		/**
		* UnityEngine.RenderTextureDescriptor.set_sRGB
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_RenderTextureDescriptor_set_sRGB]
		public final function set sRGB(value:Boolean):void;

		/**
		* UnityEngine.RenderTextureDescriptor.get_useMipMap
		*return:
		*   System.Boolean
		*/
		[native,unityengine_RenderTextureDescriptor_get_useMipMap]
		public final function get useMipMap():Boolean;

		/**
		* UnityEngine.RenderTextureDescriptor.set_useMipMap
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_RenderTextureDescriptor_set_useMipMap]
		public final function set useMipMap(value:Boolean):void;

		/**
		* UnityEngine.RenderTextureDescriptor.get_autoGenerateMips
		*return:
		*   System.Boolean
		*/
		[native,unityengine_RenderTextureDescriptor_get_autoGenerateMips]
		public final function get autoGenerateMips():Boolean;

		/**
		* UnityEngine.RenderTextureDescriptor.set_autoGenerateMips
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_RenderTextureDescriptor_set_autoGenerateMips]
		public final function set autoGenerateMips(value:Boolean):void;

		/**
		* UnityEngine.RenderTextureDescriptor.get_enableRandomWrite
		*return:
		*   System.Boolean
		*/
		[native,unityengine_RenderTextureDescriptor_get_enableRandomWrite]
		public final function get enableRandomWrite():Boolean;

		/**
		* UnityEngine.RenderTextureDescriptor.set_enableRandomWrite
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_RenderTextureDescriptor_set_enableRandomWrite]
		public final function set enableRandomWrite(value:Boolean):void;


	}
}
