package unityengine
{
	import unityengine.rendering.ShadowCastingMode;
	import system._Array_;
	import unityengine.rendering.LightProbeUsage;
	import unityengine.rendering.ReflectionProbeUsage;
	import system.collections.generic.List_Of_ReflectionProbeBlendInfo;


		/**
		*  UnityEngine.Renderer
		*/
	[link_system]
	public class Renderer extends Component
	{
		[creator];
		[native,unityengine_Renderer_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Renderer_ctor];
		public function Renderer();

		//*********跨语言继承适配器*******
		[crossextendadapter];
		[native,_unityengine_RendererAdapter_ctor];
		private function _RendererAdapter();


		//*********公共方法*******
		/**
		* UnityEngine.Renderer.get_isPartOfStaticBatch
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Renderer_get_isPartOfStaticBatch]
		public final function get isPartOfStaticBatch():Boolean;

		/**
		* UnityEngine.Renderer.get_worldToLocalMatrix
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_Renderer_get_worldToLocalMatrix]
		public final function get worldToLocalMatrix():Matrix4x4;

		/**
		* UnityEngine.Renderer.get_localToWorldMatrix
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,unityengine_Renderer_get_localToWorldMatrix]
		public final function get localToWorldMatrix():Matrix4x4;

		/**
		* UnityEngine.Renderer.get_enabled
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Renderer_get_enabled]
		public final function get enabled():Boolean;

		/**
		* UnityEngine.Renderer.set_enabled
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_Renderer_set_enabled]
		public final function set enabled(value:Boolean):void;

		/**
		* UnityEngine.Renderer.get_shadowCastingMode
		*return:
		*   UnityEngine.Rendering.ShadowCastingMode
		*/
		[native,unityengine_Renderer_get_shadowCastingMode]
		public final function get shadowCastingMode():unityengine.rendering.ShadowCastingMode;

		/**
		* UnityEngine.Renderer.set_shadowCastingMode
		*parameters:
		*  value : UnityEngine.Rendering.ShadowCastingMode
		*/
		[native,unityengine_Renderer_set_shadowCastingMode]
		public final function set shadowCastingMode(value:unityengine.rendering.ShadowCastingMode):void;

		/**
		* UnityEngine.Renderer.get_receiveShadows
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Renderer_get_receiveShadows]
		public final function get receiveShadows():Boolean;

		/**
		* UnityEngine.Renderer.set_receiveShadows
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_Renderer_set_receiveShadows]
		public final function set receiveShadows(value:Boolean):void;

		/**
		* UnityEngine.Renderer.get_material
		*return:
		*   UnityEngine.Material
		*/
		[native,unityengine_Renderer_get_material]
		public final function get material():Material;

		/**
		* UnityEngine.Renderer.set_material
		*parameters:
		*  value : UnityEngine.Material
		*/
		[native,unityengine_Renderer_set_material]
		public final function set material(value:Material):void;

		/**
		* UnityEngine.Renderer.get_sharedMaterial
		*return:
		*   UnityEngine.Material
		*/
		[native,unityengine_Renderer_get_sharedMaterial]
		public final function get sharedMaterial():Material;

		/**
		* UnityEngine.Renderer.set_sharedMaterial
		*parameters:
		*  value : UnityEngine.Material
		*/
		[native,unityengine_Renderer_set_sharedMaterial]
		public final function set sharedMaterial(value:Material):void;

		/**
		* UnityEngine.Renderer.get_materials
		*return:
		*   UnityEngine.Material[]
		*/
		[native,unityengine_Renderer_get_materials]
		public final function get materials():_Array_;

		/**
		* UnityEngine.Renderer.set_materials
		*parameters:
		*  value : UnityEngine.Material[]
		*/
		[native,unityengine_Renderer_set_materials]
		public final function set materials(value:_Array_):void;

		/**
		* UnityEngine.Renderer.get_sharedMaterials
		*return:
		*   UnityEngine.Material[]
		*/
		[native,unityengine_Renderer_get_sharedMaterials]
		public final function get sharedMaterials():_Array_;

		/**
		* UnityEngine.Renderer.set_sharedMaterials
		*parameters:
		*  value : UnityEngine.Material[]
		*/
		[native,unityengine_Renderer_set_sharedMaterials]
		public final function set sharedMaterials(value:_Array_):void;

		/**
		* UnityEngine.Renderer.get_bounds
		*return:
		*   UnityEngine.Bounds
		*/
		[native,unityengine_Renderer_get_bounds]
		public final function get bounds():Bounds;

		/**
		* UnityEngine.Renderer.get_lightmapIndex
		*return:
		*   System.Int32
		*/
		[native,unityengine_Renderer_get_lightmapIndex]
		public final function get lightmapIndex():int;

		/**
		* UnityEngine.Renderer.set_lightmapIndex
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_Renderer_set_lightmapIndex]
		public final function set lightmapIndex(value:int):void;

		/**
		* UnityEngine.Renderer.get_realtimeLightmapIndex
		*return:
		*   System.Int32
		*/
		[native,unityengine_Renderer_get_realtimeLightmapIndex]
		public final function get realtimeLightmapIndex():int;

		/**
		* UnityEngine.Renderer.set_realtimeLightmapIndex
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_Renderer_set_realtimeLightmapIndex]
		public final function set realtimeLightmapIndex(value:int):void;

		/**
		* UnityEngine.Renderer.get_lightmapScaleOffset
		*return:
		*   UnityEngine.Vector4
		*/
		[native,unityengine_Renderer_get_lightmapScaleOffset]
		public final function get lightmapScaleOffset():Vector4;

		/**
		* UnityEngine.Renderer.set_lightmapScaleOffset
		*parameters:
		*  value : UnityEngine.Vector4
		*/
		[native,unityengine_Renderer_set_lightmapScaleOffset]
		public final function set lightmapScaleOffset(value:Vector4):void;

		/**
		* UnityEngine.Renderer.get_motionVectorGenerationMode
		*return:
		*   UnityEngine.MotionVectorGenerationMode
		*/
		[native,unityengine_Renderer_get_motionVectorGenerationMode]
		public final function get motionVectorGenerationMode():MotionVectorGenerationMode;

		/**
		* UnityEngine.Renderer.set_motionVectorGenerationMode
		*parameters:
		*  value : UnityEngine.MotionVectorGenerationMode
		*/
		[native,unityengine_Renderer_set_motionVectorGenerationMode]
		public final function set motionVectorGenerationMode(value:MotionVectorGenerationMode):void;

		/**
		* UnityEngine.Renderer.get_realtimeLightmapScaleOffset
		*return:
		*   UnityEngine.Vector4
		*/
		[native,unityengine_Renderer_get_realtimeLightmapScaleOffset]
		public final function get realtimeLightmapScaleOffset():Vector4;

		/**
		* UnityEngine.Renderer.set_realtimeLightmapScaleOffset
		*parameters:
		*  value : UnityEngine.Vector4
		*/
		[native,unityengine_Renderer_set_realtimeLightmapScaleOffset]
		public final function set realtimeLightmapScaleOffset(value:Vector4):void;

		/**
		* UnityEngine.Renderer.get_isVisible
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Renderer_get_isVisible]
		public final function get isVisible():Boolean;

		/**
		* UnityEngine.Renderer.get_lightProbeUsage
		*return:
		*   UnityEngine.Rendering.LightProbeUsage
		*/
		[native,unityengine_Renderer_get_lightProbeUsage]
		public final function get lightProbeUsage():unityengine.rendering.LightProbeUsage;

		/**
		* UnityEngine.Renderer.set_lightProbeUsage
		*parameters:
		*  value : UnityEngine.Rendering.LightProbeUsage
		*/
		[native,unityengine_Renderer_set_lightProbeUsage]
		public final function set lightProbeUsage(value:unityengine.rendering.LightProbeUsage):void;

		/**
		* UnityEngine.Renderer.get_lightProbeProxyVolumeOverride
		*return:
		*   UnityEngine.GameObject
		*/
		[native,unityengine_Renderer_get_lightProbeProxyVolumeOverride]
		public final function get lightProbeProxyVolumeOverride():GameObject;

		/**
		* UnityEngine.Renderer.set_lightProbeProxyVolumeOverride
		*parameters:
		*  value : UnityEngine.GameObject
		*/
		[native,unityengine_Renderer_set_lightProbeProxyVolumeOverride]
		public final function set lightProbeProxyVolumeOverride(value:GameObject):void;

		/**
		* UnityEngine.Renderer.get_probeAnchor
		*return:
		*   UnityEngine.Transform
		*/
		[native,unityengine_Renderer_get_probeAnchor]
		public final function get probeAnchor():Transform;

		/**
		* UnityEngine.Renderer.set_probeAnchor
		*parameters:
		*  value : UnityEngine.Transform
		*/
		[native,unityengine_Renderer_set_probeAnchor]
		public final function set probeAnchor(value:Transform):void;

		/**
		* UnityEngine.Renderer.get_reflectionProbeUsage
		*return:
		*   UnityEngine.Rendering.ReflectionProbeUsage
		*/
		[native,unityengine_Renderer_get_reflectionProbeUsage]
		public final function get reflectionProbeUsage():unityengine.rendering.ReflectionProbeUsage;

		/**
		* UnityEngine.Renderer.set_reflectionProbeUsage
		*parameters:
		*  value : UnityEngine.Rendering.ReflectionProbeUsage
		*/
		[native,unityengine_Renderer_set_reflectionProbeUsage]
		public final function set reflectionProbeUsage(value:unityengine.rendering.ReflectionProbeUsage):void;

		/**
		* UnityEngine.Renderer.SetPropertyBlock
		*parameters:
		*  properties : UnityEngine.MaterialPropertyBlock
		*/
		[native,unityengine_Renderer_setPropertyBlock];
		public final function setPropertyBlock(properties:MaterialPropertyBlock):void;

		/**
		* UnityEngine.Renderer.GetPropertyBlock
		*parameters:
		*  dest : UnityEngine.MaterialPropertyBlock
		*/
		[native,unityengine_Renderer_getPropertyBlock];
		public final function getPropertyBlock(dest:MaterialPropertyBlock):void;

		/**
		* UnityEngine.Renderer.get_sortingLayerName
		*return:
		*   System.String
		*/
		[native,unityengine_Renderer_get_sortingLayerName]
		public final function get sortingLayerName():String;

		/**
		* UnityEngine.Renderer.set_sortingLayerName
		*parameters:
		*  value : System.String
		*/
		[native,unityengine_Renderer_set_sortingLayerName]
		public final function set sortingLayerName(value:String):void;

		/**
		* UnityEngine.Renderer.get_allowOcclusionWhenDynamic
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Renderer_get_allowOcclusionWhenDynamic]
		public final function get allowOcclusionWhenDynamic():Boolean;

		/**
		* UnityEngine.Renderer.set_allowOcclusionWhenDynamic
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_Renderer_set_allowOcclusionWhenDynamic]
		public final function set allowOcclusionWhenDynamic(value:Boolean):void;

		/**
		* UnityEngine.Renderer.get_sortingLayerID
		*return:
		*   System.Int32
		*/
		[native,unityengine_Renderer_get_sortingLayerID]
		public final function get sortingLayerID():int;

		/**
		* UnityEngine.Renderer.set_sortingLayerID
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_Renderer_set_sortingLayerID]
		public final function set sortingLayerID(value:int):void;

		/**
		* UnityEngine.Renderer.get_sortingOrder
		*return:
		*   System.Int32
		*/
		[native,unityengine_Renderer_get_sortingOrder]
		public final function get sortingOrder():int;

		/**
		* UnityEngine.Renderer.set_sortingOrder
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_Renderer_set_sortingOrder]
		public final function set sortingOrder(value:int):void;

		/**
		* UnityEngine.Renderer.GetClosestReflectionProbes
		*parameters:
		*  result : System.Collections.Generic.List &lt; UnityEngine.Rendering.ReflectionProbeBlendInfo &gt; 
		*/
		[native,unityengine_Renderer_getClosestReflectionProbes];
		public final function getClosestReflectionProbes(result:system.collections.generic.List_Of_ReflectionProbeBlendInfo):void;


	}
}
