package unityengine
{
	import system._Object_;
	import system._Array_;


		/**
		* Sealed
		*  UnityEngine.Screen
		*/
	[link_system]
	public final class Screen extends system._Object_
	{
		[creator];
		[native,unityengine_Screen_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Screen_ctor];
		public function Screen();


		//*********公共方法*******
		/**
		* UnityEngine.Screen.get_resolutions
		*return:
		*   UnityEngine.Resolution[]
		*/
		[native,static_unityengine_Screen_get_resolutions]
		public static function get resolutions():_Array_;

		/**
		* UnityEngine.Screen.get_currentResolution
		*return:
		*   UnityEngine.Resolution
		*/
		[native,static_unityengine_Screen_get_currentResolution]
		public static function get currentResolution():Resolution;

		/**
		* UnityEngine.Screen.SetResolution
		*parameters:
		*  width : System.Int32
		*  height : System.Int32
		*  fullscreen : System.Boolean
		*  preferredRefreshRate : System.Int32
		*/
		[native,static_unityengine_Screen_setResolution];
		public static function setResolution(width:int,height:int,fullscreen:Boolean,preferredRefreshRate:int):void;

		/**
		* UnityEngine.Screen.SetResolution
		*parameters:
		*  width : System.Int32
		*  height : System.Int32
		*  fullscreen : System.Boolean
		*/
		[native,static_unityengine_Screen_setResolution_];
		public static function setResolution_(width:int,height:int,fullscreen:Boolean):void;

		/**
		* UnityEngine.Screen.get_width
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Screen_get_width]
		public static function get width():int;

		/**
		* UnityEngine.Screen.get_height
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Screen_get_height]
		public static function get height():int;

		/**
		* UnityEngine.Screen.get_safeArea
		*return:
		*   UnityEngine.Rect
		*/
		[native,static_unityengine_Screen_get_safeArea]
		public static function get safeArea():Rect;

		/**
		* UnityEngine.Screen.get_dpi
		*return:
		*   System.Single
		*/
		[native,static_unityengine_Screen_get_dpi]
		public static function get dpi():Number;

		/**
		* UnityEngine.Screen.get_fullScreen
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Screen_get_fullScreen]
		public static function get fullScreen():Boolean;

		/**
		* UnityEngine.Screen.set_fullScreen
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_Screen_set_fullScreen]
		public static function set fullScreen(value:Boolean):void;

		/**
		* UnityEngine.Screen.get_autorotateToPortrait
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Screen_get_autorotateToPortrait]
		public static function get autorotateToPortrait():Boolean;

		/**
		* UnityEngine.Screen.set_autorotateToPortrait
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_Screen_set_autorotateToPortrait]
		public static function set autorotateToPortrait(value:Boolean):void;

		/**
		* UnityEngine.Screen.get_autorotateToPortraitUpsideDown
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Screen_get_autorotateToPortraitUpsideDown]
		public static function get autorotateToPortraitUpsideDown():Boolean;

		/**
		* UnityEngine.Screen.set_autorotateToPortraitUpsideDown
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_Screen_set_autorotateToPortraitUpsideDown]
		public static function set autorotateToPortraitUpsideDown(value:Boolean):void;

		/**
		* UnityEngine.Screen.get_autorotateToLandscapeLeft
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Screen_get_autorotateToLandscapeLeft]
		public static function get autorotateToLandscapeLeft():Boolean;

		/**
		* UnityEngine.Screen.set_autorotateToLandscapeLeft
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_Screen_set_autorotateToLandscapeLeft]
		public static function set autorotateToLandscapeLeft(value:Boolean):void;

		/**
		* UnityEngine.Screen.get_autorotateToLandscapeRight
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Screen_get_autorotateToLandscapeRight]
		public static function get autorotateToLandscapeRight():Boolean;

		/**
		* UnityEngine.Screen.set_autorotateToLandscapeRight
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_Screen_set_autorotateToLandscapeRight]
		public static function set autorotateToLandscapeRight(value:Boolean):void;

		/**
		* UnityEngine.Screen.get_orientation
		*return:
		*   UnityEngine.ScreenOrientation
		*/
		[native,static_unityengine_Screen_get_orientation]
		public static function get orientation():ScreenOrientation;

		/**
		* UnityEngine.Screen.set_orientation
		*parameters:
		*  value : UnityEngine.ScreenOrientation
		*/
		[native,static_unityengine_Screen_set_orientation]
		public static function set orientation(value:ScreenOrientation):void;

		/**
		* UnityEngine.Screen.get_sleepTimeout
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Screen_get_sleepTimeout]
		public static function get sleepTimeout():int;

		/**
		* UnityEngine.Screen.set_sleepTimeout
		*parameters:
		*  value : System.Int32
		*/
		[native,static_unityengine_Screen_set_sleepTimeout]
		public static function set sleepTimeout(value:int):void;


	}
}
