package unityengine
{
	import system.collections.generic.List_Of_Single;
	import system._Array_;
	import system.collections.generic.List_Of_Vector4;
	import system.collections.generic.List_Of_Matrix4x4;


		/**
		* Sealed
		*  UnityEngine.Shader
		*/
	[link_system]
	public final class Shader extends UObject
	{
		[creator];
		[native,unityengine_Shader_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Shader_ctor];
		public function Shader();


		//*********公共方法*******
		/**
		* UnityEngine.Shader.Find
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Shader
		*/
		[native,static_unityengine_Shader_find];
		public static function find(name:String):Shader;

		/**
		* UnityEngine.Shader.get_isSupported
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Shader_get_isSupported]
		public final function get isSupported():Boolean;

		/**
		* UnityEngine.Shader.EnableKeyword
		*parameters:
		*  keyword : System.String
		*/
		[native,static_unityengine_Shader_enableKeyword];
		public static function enableKeyword(keyword:String):void;

		/**
		* UnityEngine.Shader.DisableKeyword
		*parameters:
		*  keyword : System.String
		*/
		[native,static_unityengine_Shader_disableKeyword];
		public static function disableKeyword(keyword:String):void;

		/**
		* UnityEngine.Shader.IsKeywordEnabled
		*parameters:
		*  keyword : System.String
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Shader_isKeywordEnabled];
		public static function isKeywordEnabled(keyword:String):Boolean;

		/**
		* UnityEngine.Shader.get_maximumLOD
		*return:
		*   System.Int32
		*/
		[native,unityengine_Shader_get_maximumLOD]
		public final function get maximumLOD():int;

		/**
		* UnityEngine.Shader.set_maximumLOD
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_Shader_set_maximumLOD]
		public final function set maximumLOD(value:int):void;

		/**
		* UnityEngine.Shader.get_globalMaximumLOD
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Shader_get_globalMaximumLOD]
		public static function get globalMaximumLOD():int;

		/**
		* UnityEngine.Shader.set_globalMaximumLOD
		*parameters:
		*  value : System.Int32
		*/
		[native,static_unityengine_Shader_set_globalMaximumLOD]
		public static function set globalMaximumLOD(value:int):void;

		/**
		* UnityEngine.Shader.get_globalRenderPipeline
		*return:
		*   System.String
		*/
		[native,static_unityengine_Shader_get_globalRenderPipeline]
		public static function get globalRenderPipeline():String;

		/**
		* UnityEngine.Shader.set_globalRenderPipeline
		*parameters:
		*  value : System.String
		*/
		[native,static_unityengine_Shader_set_globalRenderPipeline]
		public static function set globalRenderPipeline(value:String):void;

		/**
		* UnityEngine.Shader.get_renderQueue
		*return:
		*   System.Int32
		*/
		[native,unityengine_Shader_get_renderQueue]
		public final function get renderQueue():int;

		/**
		* UnityEngine.Shader.SetGlobalBuffer
		*parameters:
		*  nameID : System.Int32
		*  buffer : UnityEngine.ComputeBuffer
		*/
		[native,static_unityengine_Shader_setGlobalBuffer];
		public static function setGlobalBuffer(nameID:int,buffer:ComputeBuffer):void;

		/**
		* UnityEngine.Shader.PropertyToID
		*parameters:
		*  name : System.String
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Shader_propertyToID];
		public static function propertyToID(name:String):int;

		/**
		* UnityEngine.Shader.WarmupAllShaders
		*/
		[native,static_unityengine_Shader_warmupAllShaders];
		public static function warmupAllShaders():void;

		/**
		* UnityEngine.Shader.SetGlobalFloat
		*parameters:
		*  name : System.String
		*  value : System.Single
		*/
		[native,static_unityengine_Shader_setGlobalFloat];
		public static function setGlobalFloat(name:String,value:Number):void;

		/**
		* UnityEngine.Shader.SetGlobalFloat
		*parameters:
		*  nameID : System.Int32
		*  value : System.Single
		*/
		[native,static_unityengine_Shader_setGlobalFloat_];
		public static function setGlobalFloat_(nameID:int,value:Number):void;

		/**
		* UnityEngine.Shader.SetGlobalInt
		*parameters:
		*  name : System.String
		*  value : System.Int32
		*/
		[native,static_unityengine_Shader_setGlobalInt];
		public static function setGlobalInt(name:String,value:int):void;

		/**
		* UnityEngine.Shader.SetGlobalInt
		*parameters:
		*  nameID : System.Int32
		*  value : System.Int32
		*/
		[native,static_unityengine_Shader_setGlobalInt_];
		public static function setGlobalInt_(nameID:int,value:int):void;

		/**
		* UnityEngine.Shader.SetGlobalVector
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Vector4
		*/
		[native,static_unityengine_Shader_setGlobalVector];
		public static function setGlobalVector(name:String,value:Vector4):void;

		/**
		* UnityEngine.Shader.SetGlobalVector
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Vector4
		*/
		[native,static_unityengine_Shader_setGlobalVector_];
		public static function setGlobalVector_(nameID:int,value:Vector4):void;

		/**
		* UnityEngine.Shader.SetGlobalColor
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Color
		*/
		[native,static_unityengine_Shader_setGlobalColor];
		public static function setGlobalColor(name:String,value:Color):void;

		/**
		* UnityEngine.Shader.SetGlobalColor
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Color
		*/
		[native,static_unityengine_Shader_setGlobalColor_];
		public static function setGlobalColor_(nameID:int,value:Color):void;

		/**
		* UnityEngine.Shader.SetGlobalMatrix
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Matrix4x4
		*/
		[native,static_unityengine_Shader_setGlobalMatrix];
		public static function setGlobalMatrix(name:String,value:Matrix4x4):void;

		/**
		* UnityEngine.Shader.SetGlobalMatrix
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Matrix4x4
		*/
		[native,static_unityengine_Shader_setGlobalMatrix_];
		public static function setGlobalMatrix_(nameID:int,value:Matrix4x4):void;

		/**
		* UnityEngine.Shader.SetGlobalTexture
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Texture
		*/
		[native,static_unityengine_Shader_setGlobalTexture];
		public static function setGlobalTexture(name:String,value:Texture):void;

		/**
		* UnityEngine.Shader.SetGlobalTexture
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Texture
		*/
		[native,static_unityengine_Shader_setGlobalTexture_];
		public static function setGlobalTexture_(nameID:int,value:Texture):void;

		/**
		* UnityEngine.Shader.SetGlobalBuffer
		*parameters:
		*  name : System.String
		*  buffer : UnityEngine.ComputeBuffer
		*/
		[native,static_unityengine_Shader_setGlobalBuffer_];
		public static function setGlobalBuffer_(name:String,buffer:ComputeBuffer):void;

		/**
		* UnityEngine.Shader.SetGlobalFloatArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,static_unityengine_Shader_setGlobalFloatArray];
		public static function setGlobalFloatArray(name:String,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.Shader.SetGlobalFloatArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,static_unityengine_Shader_setGlobalFloatArray_];
		public static function setGlobalFloatArray_(nameID:int,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.Shader.SetGlobalFloatArray
		*parameters:
		*  name : System.String
		*  values : System.Single[]
		*/
		[native,static_unityengine_Shader_setGlobalFloatArray__];
		public static function setGlobalFloatArray__(name:String,values:_Array_):void;

		/**
		* UnityEngine.Shader.SetGlobalFloatArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Single[]
		*/
		[native,static_unityengine_Shader_setGlobalFloatArray___];
		public static function setGlobalFloatArray___(nameID:int,values:_Array_):void;

		/**
		* UnityEngine.Shader.SetGlobalVectorArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,static_unityengine_Shader_setGlobalVectorArray];
		public static function setGlobalVectorArray(name:String,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Shader.SetGlobalVectorArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,static_unityengine_Shader_setGlobalVectorArray_];
		public static function setGlobalVectorArray_(nameID:int,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Shader.SetGlobalVectorArray
		*parameters:
		*  name : System.String
		*  values : UnityEngine.Vector4[]
		*/
		[native,static_unityengine_Shader_setGlobalVectorArray__];
		public static function setGlobalVectorArray__(name:String,values:_Array_):void;

		/**
		* UnityEngine.Shader.SetGlobalVectorArray
		*parameters:
		*  nameID : System.Int32
		*  values : UnityEngine.Vector4[]
		*/
		[native,static_unityengine_Shader_setGlobalVectorArray___];
		public static function setGlobalVectorArray___(nameID:int,values:_Array_):void;

		/**
		* UnityEngine.Shader.SetGlobalMatrixArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,static_unityengine_Shader_setGlobalMatrixArray];
		public static function setGlobalMatrixArray(name:String,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.Shader.SetGlobalMatrixArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,static_unityengine_Shader_setGlobalMatrixArray_];
		public static function setGlobalMatrixArray_(nameID:int,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.Shader.SetGlobalMatrixArray
		*parameters:
		*  name : System.String
		*  values : UnityEngine.Matrix4x4[]
		*/
		[native,static_unityengine_Shader_setGlobalMatrixArray__];
		public static function setGlobalMatrixArray__(name:String,values:_Array_):void;

		/**
		* UnityEngine.Shader.SetGlobalMatrixArray
		*parameters:
		*  nameID : System.Int32
		*  values : UnityEngine.Matrix4x4[]
		*/
		[native,static_unityengine_Shader_setGlobalMatrixArray___];
		public static function setGlobalMatrixArray___(nameID:int,values:_Array_):void;

		/**
		* UnityEngine.Shader.GetGlobalFloat
		*parameters:
		*  name : System.String
		*return:
		*   System.Single
		*/
		[native,static_unityengine_Shader_getGlobalFloat];
		public static function getGlobalFloat(name:String):Number;

		/**
		* UnityEngine.Shader.GetGlobalFloat
		*parameters:
		*  nameID : System.Int32
		*return:
		*   System.Single
		*/
		[native,static_unityengine_Shader_getGlobalFloat_];
		public static function getGlobalFloat_(nameID:int):Number;

		/**
		* UnityEngine.Shader.GetGlobalInt
		*parameters:
		*  name : System.String
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Shader_getGlobalInt];
		public static function getGlobalInt(name:String):int;

		/**
		* UnityEngine.Shader.GetGlobalInt
		*parameters:
		*  nameID : System.Int32
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Shader_getGlobalInt_];
		public static function getGlobalInt_(nameID:int):int;

		/**
		* UnityEngine.Shader.GetGlobalVector
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Vector4
		*/
		[native,static_unityengine_Shader_getGlobalVector];
		public static function getGlobalVector(name:String):Vector4;

		/**
		* UnityEngine.Shader.GetGlobalVector
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Vector4
		*/
		[native,static_unityengine_Shader_getGlobalVector_];
		public static function getGlobalVector_(nameID:int):Vector4;

		/**
		* UnityEngine.Shader.GetGlobalColor
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Color
		*/
		[native,static_unityengine_Shader_getGlobalColor];
		public static function getGlobalColor(name:String):Color;

		/**
		* UnityEngine.Shader.GetGlobalColor
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Color
		*/
		[native,static_unityengine_Shader_getGlobalColor_];
		public static function getGlobalColor_(nameID:int):Color;

		/**
		* UnityEngine.Shader.GetGlobalMatrix
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,static_unityengine_Shader_getGlobalMatrix];
		public static function getGlobalMatrix(name:String):Matrix4x4;

		/**
		* UnityEngine.Shader.GetGlobalMatrix
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Matrix4x4
		*/
		[native,static_unityengine_Shader_getGlobalMatrix_];
		public static function getGlobalMatrix_(nameID:int):Matrix4x4;

		/**
		* UnityEngine.Shader.GetGlobalTexture
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Texture
		*/
		[native,static_unityengine_Shader_getGlobalTexture];
		public static function getGlobalTexture(name:String):Texture;

		/**
		* UnityEngine.Shader.GetGlobalTexture
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Texture
		*/
		[native,static_unityengine_Shader_getGlobalTexture_];
		public static function getGlobalTexture_(nameID:int):Texture;

		/**
		* UnityEngine.Shader.GetGlobalFloatArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,static_unityengine_Shader_getGlobalFloatArray];
		public static function getGlobalFloatArray(name:String,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.Shader.GetGlobalFloatArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,static_unityengine_Shader_getGlobalFloatArray_];
		public static function getGlobalFloatArray_(nameID:int,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.Shader.GetGlobalFloatArray
		*parameters:
		*  name : System.String
		*return:
		*   System.Single[]
		*/
		[native,static_unityengine_Shader_getGlobalFloatArray__];
		public static function getGlobalFloatArray__(name:String):_Array_;

		/**
		* UnityEngine.Shader.GetGlobalFloatArray
		*parameters:
		*  nameID : System.Int32
		*return:
		*   System.Single[]
		*/
		[native,static_unityengine_Shader_getGlobalFloatArray___];
		public static function getGlobalFloatArray___(nameID:int):_Array_;

		/**
		* UnityEngine.Shader.GetGlobalVectorArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,static_unityengine_Shader_getGlobalVectorArray];
		public static function getGlobalVectorArray(name:String,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Shader.GetGlobalVectorArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,static_unityengine_Shader_getGlobalVectorArray_];
		public static function getGlobalVectorArray_(nameID:int,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Shader.GetGlobalVectorArray
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Vector4[]
		*/
		[native,static_unityengine_Shader_getGlobalVectorArray__];
		public static function getGlobalVectorArray__(name:String):_Array_;

		/**
		* UnityEngine.Shader.GetGlobalVectorArray
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Vector4[]
		*/
		[native,static_unityengine_Shader_getGlobalVectorArray___];
		public static function getGlobalVectorArray___(nameID:int):_Array_;

		/**
		* UnityEngine.Shader.GetGlobalMatrixArray
		*parameters:
		*  name : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,static_unityengine_Shader_getGlobalMatrixArray];
		public static function getGlobalMatrixArray(name:String,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.Shader.GetGlobalMatrixArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,static_unityengine_Shader_getGlobalMatrixArray_];
		public static function getGlobalMatrixArray_(nameID:int,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.Shader.GetGlobalMatrixArray
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.Matrix4x4[]
		*/
		[native,static_unityengine_Shader_getGlobalMatrixArray__];
		public static function getGlobalMatrixArray__(name:String):_Array_;

		/**
		* UnityEngine.Shader.GetGlobalMatrixArray
		*parameters:
		*  nameID : System.Int32
		*return:
		*   UnityEngine.Matrix4x4[]
		*/
		[native,static_unityengine_Shader_getGlobalMatrixArray___];
		public static function getGlobalMatrixArray___(nameID:int):_Array_;


	}
}
