package unityengine
{
	import system._Array_;
	import system.collections.generic.List_Of_Vector2;


		/**
		* Sealed
		*  UnityEngine.Sprite
		*/
	[link_system]
	public final class Sprite extends UObject
	{
		[creator];
		[native,unityengine_Sprite_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Sprite_ctor];
		public function Sprite();


		//*********公共方法*******
		/**
		* UnityEngine.Sprite.Create
		*parameters:
		*  texture : UnityEngine.Texture2D
		*  rect : UnityEngine.Rect
		*  pivot : UnityEngine.Vector2
		*  pixelsPerUnit : System.Single
		*  extrude : System.UInt32
		*  meshType : UnityEngine.SpriteMeshType
		*  border : UnityEngine.Vector4
		*return:
		*   UnityEngine.Sprite
		*/
		[native,static_unityengine_Sprite_create];
		public static function create(texture:Texture2D,rect:Rect,pivot:Vector2,pixelsPerUnit:Number,extrude:uint,meshType:SpriteMeshType,border:Vector4):Sprite;

		/**
		* UnityEngine.Sprite.Create
		*parameters:
		*  texture : UnityEngine.Texture2D
		*  rect : UnityEngine.Rect
		*  pivot : UnityEngine.Vector2
		*  pixelsPerUnit : System.Single
		*  extrude : System.UInt32
		*  meshType : UnityEngine.SpriteMeshType
		*return:
		*   UnityEngine.Sprite
		*/
		[native,static_unityengine_Sprite_create_];
		public static function create_(texture:Texture2D,rect:Rect,pivot:Vector2,pixelsPerUnit:Number,extrude:uint,meshType:SpriteMeshType):Sprite;

		/**
		* UnityEngine.Sprite.Create
		*parameters:
		*  texture : UnityEngine.Texture2D
		*  rect : UnityEngine.Rect
		*  pivot : UnityEngine.Vector2
		*  pixelsPerUnit : System.Single
		*  extrude : System.UInt32
		*return:
		*   UnityEngine.Sprite
		*/
		[native,static_unityengine_Sprite_create__];
		public static function create__(texture:Texture2D,rect:Rect,pivot:Vector2,pixelsPerUnit:Number,extrude:uint):Sprite;

		/**
		* UnityEngine.Sprite.Create
		*parameters:
		*  texture : UnityEngine.Texture2D
		*  rect : UnityEngine.Rect
		*  pivot : UnityEngine.Vector2
		*  pixelsPerUnit : System.Single
		*return:
		*   UnityEngine.Sprite
		*/
		[native,static_unityengine_Sprite_create___];
		public static function create___(texture:Texture2D,rect:Rect,pivot:Vector2,pixelsPerUnit:Number):Sprite;

		/**
		* UnityEngine.Sprite.Create
		*parameters:
		*  texture : UnityEngine.Texture2D
		*  rect : UnityEngine.Rect
		*  pivot : UnityEngine.Vector2
		*return:
		*   UnityEngine.Sprite
		*/
		[native,static_unityengine_Sprite_create____];
		public static function create____(texture:Texture2D,rect:Rect,pivot:Vector2):Sprite;

		/**
		* UnityEngine.Sprite.get_bounds
		*return:
		*   UnityEngine.Bounds
		*/
		[native,unityengine_Sprite_get_bounds]
		public final function get bounds():Bounds;

		/**
		* UnityEngine.Sprite.get_rect
		*return:
		*   UnityEngine.Rect
		*/
		[native,unityengine_Sprite_get_rect]
		public final function get rect():Rect;

		/**
		* UnityEngine.Sprite.get_texture
		*return:
		*   UnityEngine.Texture2D
		*/
		[native,unityengine_Sprite_get_texture]
		public final function get texture():Texture2D;

		/**
		* UnityEngine.Sprite.get_associatedAlphaSplitTexture
		*return:
		*   UnityEngine.Texture2D
		*/
		[native,unityengine_Sprite_get_associatedAlphaSplitTexture]
		public final function get associatedAlphaSplitTexture():Texture2D;

		/**
		* UnityEngine.Sprite.get_textureRect
		*return:
		*   UnityEngine.Rect
		*/
		[native,unityengine_Sprite_get_textureRect]
		public final function get textureRect():Rect;

		/**
		* UnityEngine.Sprite.get_textureRectOffset
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_Sprite_get_textureRectOffset]
		public final function get textureRectOffset():Vector2;

		/**
		* UnityEngine.Sprite.get_packed
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Sprite_get_packed]
		public final function get packed():Boolean;

		/**
		* UnityEngine.Sprite.get_packingMode
		*return:
		*   UnityEngine.SpritePackingMode
		*/
		[native,unityengine_Sprite_get_packingMode]
		public final function get packingMode():SpritePackingMode;

		/**
		* UnityEngine.Sprite.get_packingRotation
		*return:
		*   UnityEngine.SpritePackingRotation
		*/
		[native,unityengine_Sprite_get_packingRotation]
		public final function get packingRotation():SpritePackingRotation;

		/**
		* UnityEngine.Sprite.get_pivot
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_Sprite_get_pivot]
		public final function get pivot():Vector2;

		/**
		* UnityEngine.Sprite.get_border
		*return:
		*   UnityEngine.Vector4
		*/
		[native,unityengine_Sprite_get_border]
		public final function get border():Vector4;

		/**
		* UnityEngine.Sprite.get_vertices
		*return:
		*   UnityEngine.Vector2[]
		*/
		[native,unityengine_Sprite_get_vertices]
		public final function get vertices():_Array_;

		/**
		* UnityEngine.Sprite.get_triangles
		*return:
		*   System.UInt16[]
		*/
		[native,unityengine_Sprite_get_triangles]
		public final function get triangles():_Array_;

		/**
		* UnityEngine.Sprite.get_uv
		*return:
		*   UnityEngine.Vector2[]
		*/
		[native,unityengine_Sprite_get_uv]
		public final function get uv():_Array_;

		/**
		* UnityEngine.Sprite.OverrideGeometry
		*parameters:
		*  vertices : UnityEngine.Vector2[]
		*  triangles : System.UInt16[]
		*/
		[native,unityengine_Sprite_overrideGeometry];
		public final function overrideGeometry(vertices:_Array_,triangles:_Array_):void;

		/**
		* UnityEngine.Sprite.get_pixelsPerUnit
		*return:
		*   System.Single
		*/
		[native,unityengine_Sprite_get_pixelsPerUnit]
		public final function get pixelsPerUnit():Number;

		/**
		* UnityEngine.Sprite.GetPhysicsShapeCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_Sprite_getPhysicsShapeCount];
		public final function getPhysicsShapeCount():int;

		/**
		* UnityEngine.Sprite.GetPhysicsShapePointCount
		*parameters:
		*  shapeIdx : System.Int32
		*return:
		*   System.Int32
		*/
		[native,unityengine_Sprite_getPhysicsShapePointCount];
		public final function getPhysicsShapePointCount(shapeIdx:int):int;

		/**
		* UnityEngine.Sprite.GetPhysicsShape
		*parameters:
		*  shapeIdx : System.Int32
		*  physicsShape : System.Collections.Generic.List &lt; UnityEngine.Vector2 &gt; 
		*return:
		*   System.Int32
		*/
		[native,unityengine_Sprite_getPhysicsShape];
		public final function getPhysicsShape(shapeIdx:int,physicsShape:system.collections.generic.List_Of_Vector2):int;


	}
}
