package unityengine
{
	import system._Object_;
	import unityengine.rendering.GraphicsDeviceType;
	import unityengine.rendering.CopyTextureSupport;


		/**
		* Sealed
		*  UnityEngine.SystemInfo
		*/
	[link_system]
	public final class SystemInfo extends system._Object_
	{
		[creator];
		[native,unityengine_SystemInfo_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_SystemInfo_ctor];
		public function SystemInfo();


		//*********字段*******
		/**
		* UnityEngine.SystemInfo.unsupportedIdentifier
		*fieldtype:
		*   System.String
		*/
		[native, unityengine_SystemInfo_unsupportedIdentifier_getter];
		public static const unsupportedIdentifier:String;

		//*********公共方法*******
		/**
		* UnityEngine.SystemInfo.get_batteryLevel
		*return:
		*   System.Single
		*/
		[native,static_unityengine_SystemInfo_get_batteryLevel]
		public static function get batteryLevel():Number;

		/**
		* UnityEngine.SystemInfo.get_batteryStatus
		*return:
		*   UnityEngine.BatteryStatus
		*/
		[native,static_unityengine_SystemInfo_get_batteryStatus]
		public static function get batteryStatus():BatteryStatus;

		/**
		* UnityEngine.SystemInfo.get_operatingSystem
		*return:
		*   System.String
		*/
		[native,static_unityengine_SystemInfo_get_operatingSystem]
		public static function get operatingSystem():String;

		/**
		* UnityEngine.SystemInfo.get_operatingSystemFamily
		*return:
		*   UnityEngine.OperatingSystemFamily
		*/
		[native,static_unityengine_SystemInfo_get_operatingSystemFamily]
		public static function get operatingSystemFamily():OperatingSystemFamily;

		/**
		* UnityEngine.SystemInfo.get_processorType
		*return:
		*   System.String
		*/
		[native,static_unityengine_SystemInfo_get_processorType]
		public static function get processorType():String;

		/**
		* UnityEngine.SystemInfo.get_processorFrequency
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_SystemInfo_get_processorFrequency]
		public static function get processorFrequency():int;

		/**
		* UnityEngine.SystemInfo.get_processorCount
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_SystemInfo_get_processorCount]
		public static function get processorCount():int;

		/**
		* UnityEngine.SystemInfo.get_systemMemorySize
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_SystemInfo_get_systemMemorySize]
		public static function get systemMemorySize():int;

		/**
		* UnityEngine.SystemInfo.get_graphicsMemorySize
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_SystemInfo_get_graphicsMemorySize]
		public static function get graphicsMemorySize():int;

		/**
		* UnityEngine.SystemInfo.get_graphicsDeviceName
		*return:
		*   System.String
		*/
		[native,static_unityengine_SystemInfo_get_graphicsDeviceName]
		public static function get graphicsDeviceName():String;

		/**
		* UnityEngine.SystemInfo.get_graphicsDeviceVendor
		*return:
		*   System.String
		*/
		[native,static_unityengine_SystemInfo_get_graphicsDeviceVendor]
		public static function get graphicsDeviceVendor():String;

		/**
		* UnityEngine.SystemInfo.get_graphicsDeviceID
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_SystemInfo_get_graphicsDeviceID]
		public static function get graphicsDeviceID():int;

		/**
		* UnityEngine.SystemInfo.get_graphicsDeviceVendorID
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_SystemInfo_get_graphicsDeviceVendorID]
		public static function get graphicsDeviceVendorID():int;

		/**
		* UnityEngine.SystemInfo.get_graphicsDeviceType
		*return:
		*   UnityEngine.Rendering.GraphicsDeviceType
		*/
		[native,static_unityengine_SystemInfo_get_graphicsDeviceType]
		public static function get graphicsDeviceType():unityengine.rendering.GraphicsDeviceType;

		/**
		* UnityEngine.SystemInfo.get_graphicsUVStartsAtTop
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_graphicsUVStartsAtTop]
		public static function get graphicsUVStartsAtTop():Boolean;

		/**
		* UnityEngine.SystemInfo.get_graphicsDeviceVersion
		*return:
		*   System.String
		*/
		[native,static_unityengine_SystemInfo_get_graphicsDeviceVersion]
		public static function get graphicsDeviceVersion():String;

		/**
		* UnityEngine.SystemInfo.get_graphicsShaderLevel
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_SystemInfo_get_graphicsShaderLevel]
		public static function get graphicsShaderLevel():int;

		/**
		* UnityEngine.SystemInfo.get_graphicsMultiThreaded
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_graphicsMultiThreaded]
		public static function get graphicsMultiThreaded():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supportsShadows
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsShadows]
		public static function get supportsShadows():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supportsRawShadowDepthSampling
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsRawShadowDepthSampling]
		public static function get supportsRawShadowDepthSampling():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supportsMotionVectors
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsMotionVectors]
		public static function get supportsMotionVectors():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supportsRenderToCubemap
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsRenderToCubemap]
		public static function get supportsRenderToCubemap():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supportsImageEffects
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsImageEffects]
		public static function get supportsImageEffects():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supports3DTextures
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supports3DTextures]
		public static function get supports3DTextures():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supports2DArrayTextures
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supports2DArrayTextures]
		public static function get supports2DArrayTextures():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supports3DRenderTextures
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supports3DRenderTextures]
		public static function get supports3DRenderTextures():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supportsCubemapArrayTextures
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsCubemapArrayTextures]
		public static function get supportsCubemapArrayTextures():Boolean;

		/**
		* UnityEngine.SystemInfo.get_copyTextureSupport
		*return:
		*   UnityEngine.Rendering.CopyTextureSupport
		*/
		[native,static_unityengine_SystemInfo_get_copyTextureSupport]
		public static function get copyTextureSupport():unityengine.rendering.CopyTextureSupport;

		/**
		* UnityEngine.SystemInfo.get_supportsComputeShaders
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsComputeShaders]
		public static function get supportsComputeShaders():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supportsInstancing
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsInstancing]
		public static function get supportsInstancing():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supportsSparseTextures
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsSparseTextures]
		public static function get supportsSparseTextures():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supportedRenderTargetCount
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_SystemInfo_get_supportedRenderTargetCount]
		public static function get supportedRenderTargetCount():int;

		/**
		* UnityEngine.SystemInfo.get_supportsTextureWrapMirrorOnce
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_SystemInfo_get_supportsTextureWrapMirrorOnce]
		public static function get supportsTextureWrapMirrorOnce():int;

		/**
		* UnityEngine.SystemInfo.get_usesReversedZBuffer
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_usesReversedZBuffer]
		public static function get usesReversedZBuffer():Boolean;

		/**
		* UnityEngine.SystemInfo.SupportsRenderTextureFormat
		*parameters:
		*  format : UnityEngine.RenderTextureFormat
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_supportsRenderTextureFormat];
		public static function supportsRenderTextureFormat(format:RenderTextureFormat):Boolean;

		/**
		* UnityEngine.SystemInfo.SupportsTextureFormat
		*parameters:
		*  format : UnityEngine.TextureFormat
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_supportsTextureFormat];
		public static function supportsTextureFormat(format:TextureFormat):Boolean;

		/**
		* UnityEngine.SystemInfo.get_npotSupport
		*return:
		*   UnityEngine.NPOTSupport
		*/
		[native,static_unityengine_SystemInfo_get_npotSupport]
		public static function get npotSupport():NPOTSupport;

		/**
		* UnityEngine.SystemInfo.get_deviceUniqueIdentifier
		*return:
		*   System.String
		*/
		[native,static_unityengine_SystemInfo_get_deviceUniqueIdentifier]
		public static function get deviceUniqueIdentifier():String;

		/**
		* UnityEngine.SystemInfo.get_deviceName
		*return:
		*   System.String
		*/
		[native,static_unityengine_SystemInfo_get_deviceName]
		public static function get deviceName():String;

		/**
		* UnityEngine.SystemInfo.get_deviceModel
		*return:
		*   System.String
		*/
		[native,static_unityengine_SystemInfo_get_deviceModel]
		public static function get deviceModel():String;

		/**
		* UnityEngine.SystemInfo.get_supportsAccelerometer
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsAccelerometer]
		public static function get supportsAccelerometer():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supportsGyroscope
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsGyroscope]
		public static function get supportsGyroscope():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supportsLocationService
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsLocationService]
		public static function get supportsLocationService():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supportsVibration
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsVibration]
		public static function get supportsVibration():Boolean;

		/**
		* UnityEngine.SystemInfo.get_supportsAudio
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_SystemInfo_get_supportsAudio]
		public static function get supportsAudio():Boolean;

		/**
		* UnityEngine.SystemInfo.get_deviceType
		*return:
		*   UnityEngine.DeviceType
		*/
		[native,static_unityengine_SystemInfo_get_deviceType]
		public static function get deviceType():DeviceType;

		/**
		* UnityEngine.SystemInfo.get_maxTextureSize
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_SystemInfo_get_maxTextureSize]
		public static function get maxTextureSize():int;

		/**
		* UnityEngine.SystemInfo.get_maxCubemapSize
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_SystemInfo_get_maxCubemapSize]
		public static function get maxCubemapSize():int;


	}
}
