package unityengine
{
	import system._Object_;
	import system.IDisposable;
	import system.collections.generic.List_Of_UICharInfo;
	import system.collections.generic.List_Of_UILineInfo;
	import system.collections.generic.List_Of_UIVertex;
	import system._Array_;


		/**
		* Sealed
		*  UnityEngine.TextGenerator
		*/
	[link_system]
	public final class TextGenerator extends system._Object_ implements system.IDisposable
	{
		[creator];
		[native,unityengine_TextGenerator_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_TextGenerator_constructor_];
		public static function constructor_(initialCapacity:int):TextGenerator;

		[native,unityengine_TextGenerator_ctor];
		public function TextGenerator();


		//*********公共方法*******
		/**
		* UnityEngine.TextGenerator.Invalidate
		*/
		[native,unityengine_TextGenerator_invalidate];
		public final function invalidate():void;

		/**
		* UnityEngine.TextGenerator.GetCharacters
		*parameters:
		*  characters : System.Collections.Generic.List &lt; UnityEngine.UICharInfo &gt; 
		*/
		[native,unityengine_TextGenerator_getCharacters];
		public final function getCharacters(characters:system.collections.generic.List_Of_UICharInfo):void;

		/**
		* UnityEngine.TextGenerator.GetLines
		*parameters:
		*  lines : System.Collections.Generic.List &lt; UnityEngine.UILineInfo &gt; 
		*/
		[native,unityengine_TextGenerator_getLines];
		public final function getLines(lines:system.collections.generic.List_Of_UILineInfo):void;

		/**
		* UnityEngine.TextGenerator.GetVertices
		*parameters:
		*  vertices : System.Collections.Generic.List &lt; UnityEngine.UIVertex &gt; 
		*/
		[native,unityengine_TextGenerator_getVertices];
		public final function getVertices(vertices:system.collections.generic.List_Of_UIVertex):void;

		/**
		* UnityEngine.TextGenerator.GetPreferredWidth
		*parameters:
		*  str : System.String
		*  settings : UnityEngine.TextGenerationSettings
		*return:
		*   System.Single
		*/
		[native,unityengine_TextGenerator_getPreferredWidth];
		public final function getPreferredWidth(str:String,settings:TextGenerationSettings):Number;

		/**
		* UnityEngine.TextGenerator.GetPreferredHeight
		*parameters:
		*  str : System.String
		*  settings : UnityEngine.TextGenerationSettings
		*return:
		*   System.Single
		*/
		[native,unityengine_TextGenerator_getPreferredHeight];
		public final function getPreferredHeight(str:String,settings:TextGenerationSettings):Number;

		/**
		* UnityEngine.TextGenerator.PopulateWithErrors
		*parameters:
		*  str : System.String
		*  settings : UnityEngine.TextGenerationSettings
		*  context : UnityEngine.GameObject
		*return:
		*   System.Boolean
		*/
		[native,unityengine_TextGenerator_populateWithErrors];
		public final function populateWithErrors(str:String,settings:TextGenerationSettings,context:GameObject):Boolean;

		/**
		* UnityEngine.TextGenerator.Populate
		*parameters:
		*  str : System.String
		*  settings : UnityEngine.TextGenerationSettings
		*return:
		*   System.Boolean
		*/
		[native,unityengine_TextGenerator_populate];
		public final function populate(str:String,settings:TextGenerationSettings):Boolean;

		/**
		* UnityEngine.TextGenerator.get_rectExtents
		*return:
		*   UnityEngine.Rect
		*/
		[native,unityengine_TextGenerator_get_rectExtents]
		public final function get rectExtents():Rect;

		/**
		* UnityEngine.TextGenerator.get_vertexCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_TextGenerator_get_vertexCount]
		public final function get vertexCount():int;

		/**
		* UnityEngine.TextGenerator.GetVerticesArray
		*return:
		*   UnityEngine.UIVertex[]
		*/
		[native,unityengine_TextGenerator_getVerticesArray];
		public final function getVerticesArray():_Array_;

		/**
		* UnityEngine.TextGenerator.get_characterCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_TextGenerator_get_characterCount]
		public final function get characterCount():int;

		/**
		* UnityEngine.TextGenerator.get_characterCountVisible
		*return:
		*   System.Int32
		*/
		[native,unityengine_TextGenerator_get_characterCountVisible]
		public final function get characterCountVisible():int;

		/**
		* UnityEngine.TextGenerator.GetCharactersArray
		*return:
		*   UnityEngine.UICharInfo[]
		*/
		[native,unityengine_TextGenerator_getCharactersArray];
		public final function getCharactersArray():_Array_;

		/**
		* UnityEngine.TextGenerator.get_lineCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_TextGenerator_get_lineCount]
		public final function get lineCount():int;

		/**
		* UnityEngine.TextGenerator.GetLinesArray
		*return:
		*   UnityEngine.UILineInfo[]
		*/
		[native,unityengine_TextGenerator_getLinesArray];
		public final function getLinesArray():_Array_;

		/**
		* UnityEngine.TextGenerator.get_fontSizeUsedForBestFit
		*return:
		*   System.Int32
		*/
		[native,unityengine_TextGenerator_get_fontSizeUsedForBestFit]
		public final function get fontSizeUsedForBestFit():int;


		//*****显式接口实现*****
		[native,system_IDisposable_dispose];
		private function system_IDisposable_Dispose():void;


	}
}
