package unityengine
{
	import unityengine.rendering.TextureDimension;
	import system.IntPtr;


		/**
		*  UnityEngine.Texture
		*/
	[link_system]
	public class Texture extends UObject
	{
		[creator];
		[native,unityengine_Texture_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Texture_ctor];
		public function Texture();

		//*********跨语言继承适配器*******
		[crossextendadapter];
		[native,_unityengine_TextureAdapter_ctor];
		private function _TextureAdapter();


		//*********公共方法*******
		/**
		* UnityEngine.Texture.get_masterTextureLimit
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_Texture_get_masterTextureLimit]
		public static function get masterTextureLimit():int;

		/**
		* UnityEngine.Texture.set_masterTextureLimit
		*parameters:
		*  value : System.Int32
		*/
		[native,static_unityengine_Texture_set_masterTextureLimit]
		public static function set masterTextureLimit(value:int):void;

		/**
		* UnityEngine.Texture.get_anisotropicFiltering
		*return:
		*   UnityEngine.AnisotropicFiltering
		*/
		[native,static_unityengine_Texture_get_anisotropicFiltering]
		public static function get anisotropicFiltering():AnisotropicFiltering;

		/**
		* UnityEngine.Texture.set_anisotropicFiltering
		*parameters:
		*  value : UnityEngine.AnisotropicFiltering
		*/
		[native,static_unityengine_Texture_set_anisotropicFiltering]
		public static function set anisotropicFiltering(value:AnisotropicFiltering):void;

		/**
		* UnityEngine.Texture.SetGlobalAnisotropicFilteringLimits
		*parameters:
		*  forcedMin : System.Int32
		*  globalMax : System.Int32
		*/
		[native,static_unityengine_Texture_setGlobalAnisotropicFilteringLimits];
		public static function setGlobalAnisotropicFilteringLimits(forcedMin:int,globalMax:int):void;

		/**
		* UnityEngine.Texture.get_width
		*return:
		*   System.Int32
		*/
		[native,unityengine_Texture_get_width]
		public function get width():int;

		/**
		* UnityEngine.Texture.set_width
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_Texture_set_width]
		public function set width(value:int):void;

		/**
		* UnityEngine.Texture.get_height
		*return:
		*   System.Int32
		*/
		[native,unityengine_Texture_get_height]
		public function get height():int;

		/**
		* UnityEngine.Texture.set_height
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_Texture_set_height]
		public function set height(value:int):void;

		/**
		* UnityEngine.Texture.get_dimension
		*return:
		*   UnityEngine.Rendering.TextureDimension
		*/
		[native,unityengine_Texture_get_dimension]
		public function get dimension():unityengine.rendering.TextureDimension;

		/**
		* UnityEngine.Texture.set_dimension
		*parameters:
		*  value : UnityEngine.Rendering.TextureDimension
		*/
		[native,unityengine_Texture_set_dimension]
		public function set dimension(value:unityengine.rendering.TextureDimension):void;

		/**
		* UnityEngine.Texture.get_filterMode
		*return:
		*   UnityEngine.FilterMode
		*/
		[native,unityengine_Texture_get_filterMode]
		public final function get filterMode():FilterMode;

		/**
		* UnityEngine.Texture.set_filterMode
		*parameters:
		*  value : UnityEngine.FilterMode
		*/
		[native,unityengine_Texture_set_filterMode]
		public final function set filterMode(value:FilterMode):void;

		/**
		* UnityEngine.Texture.get_anisoLevel
		*return:
		*   System.Int32
		*/
		[native,unityengine_Texture_get_anisoLevel]
		public final function get anisoLevel():int;

		/**
		* UnityEngine.Texture.set_anisoLevel
		*parameters:
		*  value : System.Int32
		*/
		[native,unityengine_Texture_set_anisoLevel]
		public final function set anisoLevel(value:int):void;

		/**
		* UnityEngine.Texture.get_wrapMode
		*return:
		*   UnityEngine.TextureWrapMode
		*/
		[native,unityengine_Texture_get_wrapMode]
		public final function get wrapMode():TextureWrapMode;

		/**
		* UnityEngine.Texture.set_wrapMode
		*parameters:
		*  value : UnityEngine.TextureWrapMode
		*/
		[native,unityengine_Texture_set_wrapMode]
		public final function set wrapMode(value:TextureWrapMode):void;

		/**
		* UnityEngine.Texture.get_wrapModeU
		*return:
		*   UnityEngine.TextureWrapMode
		*/
		[native,unityengine_Texture_get_wrapModeU]
		public final function get wrapModeU():TextureWrapMode;

		/**
		* UnityEngine.Texture.set_wrapModeU
		*parameters:
		*  value : UnityEngine.TextureWrapMode
		*/
		[native,unityengine_Texture_set_wrapModeU]
		public final function set wrapModeU(value:TextureWrapMode):void;

		/**
		* UnityEngine.Texture.get_wrapModeV
		*return:
		*   UnityEngine.TextureWrapMode
		*/
		[native,unityengine_Texture_get_wrapModeV]
		public final function get wrapModeV():TextureWrapMode;

		/**
		* UnityEngine.Texture.set_wrapModeV
		*parameters:
		*  value : UnityEngine.TextureWrapMode
		*/
		[native,unityengine_Texture_set_wrapModeV]
		public final function set wrapModeV(value:TextureWrapMode):void;

		/**
		* UnityEngine.Texture.get_wrapModeW
		*return:
		*   UnityEngine.TextureWrapMode
		*/
		[native,unityengine_Texture_get_wrapModeW]
		public final function get wrapModeW():TextureWrapMode;

		/**
		* UnityEngine.Texture.set_wrapModeW
		*parameters:
		*  value : UnityEngine.TextureWrapMode
		*/
		[native,unityengine_Texture_set_wrapModeW]
		public final function set wrapModeW(value:TextureWrapMode):void;

		/**
		* UnityEngine.Texture.get_mipMapBias
		*return:
		*   System.Single
		*/
		[native,unityengine_Texture_get_mipMapBias]
		public final function get mipMapBias():Number;

		/**
		* UnityEngine.Texture.set_mipMapBias
		*parameters:
		*  value : System.Single
		*/
		[native,unityengine_Texture_set_mipMapBias]
		public final function set mipMapBias(value:Number):void;

		/**
		* UnityEngine.Texture.get_texelSize
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_Texture_get_texelSize]
		public final function get texelSize():Vector2;

		/**
		* UnityEngine.Texture.GetNativeTexturePtr
		*return:
		*   System.IntPtr
		*/
		[native,unityengine_Texture_getNativeTexturePtr];
		public final function getNativeTexturePtr():system.IntPtr;


	}
}
