package unityengine
{
	import system.IntPtr;
	import system._Array_;
	import system.collections.generic.List_Of_Rect;


		/**
		* Sealed
		*  UnityEngine.Texture2D
		*/
	[link_system]
	public final class Texture2D extends Texture
	{
		[creator];
		[native,unityengine_Texture2D_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Texture2D_constructor_];
		public static function constructor_(width:int,height:int,format:TextureFormat,mipmap:Boolean):Texture2D;

		[native,unityengine_Texture2D_constructor__];
		public static function constructor__(width:int,height:int,format:TextureFormat,mipmap:Boolean,linear:Boolean):Texture2D;

		[native,unityengine_Texture2D_ctor];
		public function Texture2D(width:int,height:int);


		//*********公共方法*******
		/**
		* UnityEngine.Texture2D.get_mipmapCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_Texture2D_get_mipmapCount]
		public final function get mipmapCount():int;

		/**
		* UnityEngine.Texture2D.CreateExternalTexture
		*parameters:
		*  width : System.Int32
		*  height : System.Int32
		*  format : UnityEngine.TextureFormat
		*  mipmap : System.Boolean
		*  linear : System.Boolean
		*  nativeTex : System.IntPtr
		*return:
		*   UnityEngine.Texture2D
		*/
		[native,static_unityengine_Texture2D_createExternalTexture];
		public static function createExternalTexture(width:int,height:int,format:TextureFormat,mipmap:Boolean,linear:Boolean,nativeTex:system.IntPtr):Texture2D;

		/**
		* UnityEngine.Texture2D.UpdateExternalTexture
		*parameters:
		*  nativeTex : System.IntPtr
		*/
		[native,unityengine_Texture2D_updateExternalTexture];
		public final function updateExternalTexture(nativeTex:system.IntPtr):void;

		/**
		* UnityEngine.Texture2D.get_format
		*return:
		*   UnityEngine.TextureFormat
		*/
		[native,unityengine_Texture2D_get_format]
		public final function get format():TextureFormat;

		/**
		* UnityEngine.Texture2D.get_whiteTexture
		*return:
		*   UnityEngine.Texture2D
		*/
		[native,static_unityengine_Texture2D_get_whiteTexture]
		public static function get whiteTexture():Texture2D;

		/**
		* UnityEngine.Texture2D.get_blackTexture
		*return:
		*   UnityEngine.Texture2D
		*/
		[native,static_unityengine_Texture2D_get_blackTexture]
		public static function get blackTexture():Texture2D;

		/**
		* UnityEngine.Texture2D.SetPixel
		*parameters:
		*  x : System.Int32
		*  y : System.Int32
		*  color : UnityEngine.Color
		*/
		[native,unityengine_Texture2D_setPixel];
		public final function setPixel(x:int,y:int,color:Color):void;

		/**
		* UnityEngine.Texture2D.GetPixel
		*parameters:
		*  x : System.Int32
		*  y : System.Int32
		*return:
		*   UnityEngine.Color
		*/
		[native,unityengine_Texture2D_getPixel];
		public final function getPixel(x:int,y:int):Color;

		/**
		* UnityEngine.Texture2D.GetPixelBilinear
		*parameters:
		*  u : System.Single
		*  v : System.Single
		*return:
		*   UnityEngine.Color
		*/
		[native,unityengine_Texture2D_getPixelBilinear];
		public final function getPixelBilinear(u:Number,v:Number):Color;

		/**
		* UnityEngine.Texture2D.SetPixels
		*parameters:
		*  colors : UnityEngine.Color[]
		*/
		[native,unityengine_Texture2D_setPixels];
		public final function setPixels(colors:_Array_):void;

		/**
		* UnityEngine.Texture2D.SetPixels
		*parameters:
		*  colors : UnityEngine.Color[]
		*  miplevel : System.Int32
		*/
		[native,unityengine_Texture2D_setPixels_];
		public final function setPixels_(colors:_Array_,miplevel:int):void;

		/**
		* UnityEngine.Texture2D.SetPixels
		*parameters:
		*  x : System.Int32
		*  y : System.Int32
		*  blockWidth : System.Int32
		*  blockHeight : System.Int32
		*  colors : UnityEngine.Color[]
		*  miplevel : System.Int32
		*/
		[native,unityengine_Texture2D_setPixels__];
		public final function setPixels__(x:int,y:int,blockWidth:int,blockHeight:int,colors:_Array_,miplevel:int):void;

		/**
		* UnityEngine.Texture2D.SetPixels
		*parameters:
		*  x : System.Int32
		*  y : System.Int32
		*  blockWidth : System.Int32
		*  blockHeight : System.Int32
		*  colors : UnityEngine.Color[]
		*/
		[native,unityengine_Texture2D_setPixels___];
		public final function setPixels___(x:int,y:int,blockWidth:int,blockHeight:int,colors:_Array_):void;

		/**
		* UnityEngine.Texture2D.SetPixels32
		*parameters:
		*  colors : UnityEngine.Color32[]
		*/
		[native,unityengine_Texture2D_setPixels32];
		public final function setPixels32(colors:_Array_):void;

		/**
		* UnityEngine.Texture2D.SetPixels32
		*parameters:
		*  colors : UnityEngine.Color32[]
		*  miplevel : System.Int32
		*/
		[native,unityengine_Texture2D_setPixels32_];
		public final function setPixels32_(colors:_Array_,miplevel:int):void;

		/**
		* UnityEngine.Texture2D.SetPixels32
		*parameters:
		*  x : System.Int32
		*  y : System.Int32
		*  blockWidth : System.Int32
		*  blockHeight : System.Int32
		*  colors : UnityEngine.Color32[]
		*/
		[native,unityengine_Texture2D_setPixels32__];
		public final function setPixels32__(x:int,y:int,blockWidth:int,blockHeight:int,colors:_Array_):void;

		/**
		* UnityEngine.Texture2D.SetPixels32
		*parameters:
		*  x : System.Int32
		*  y : System.Int32
		*  blockWidth : System.Int32
		*  blockHeight : System.Int32
		*  colors : UnityEngine.Color32[]
		*  miplevel : System.Int32
		*/
		[native,unityengine_Texture2D_setPixels32___];
		public final function setPixels32___(x:int,y:int,blockWidth:int,blockHeight:int,colors:_Array_,miplevel:int):void;

		/**
		* UnityEngine.Texture2D.LoadRawTextureData
		*parameters:
		*  data : System.Byte[]
		*/
		[native,unityengine_Texture2D_loadRawTextureData];
		public final function loadRawTextureData(data:_Array_):void;

		/**
		* UnityEngine.Texture2D.LoadRawTextureData
		*parameters:
		*  data : System.IntPtr
		*  size : System.Int32
		*/
		[native,unityengine_Texture2D_loadRawTextureData_];
		public final function loadRawTextureData_(data:system.IntPtr,size:int):void;

		/**
		* UnityEngine.Texture2D.GetRawTextureData
		*return:
		*   System.Byte[]
		*/
		[native,unityengine_Texture2D_getRawTextureData];
		public final function getRawTextureData():_Array_;

		/**
		* UnityEngine.Texture2D.GetPixels
		*return:
		*   UnityEngine.Color[]
		*/
		[native,unityengine_Texture2D_getPixels];
		public final function getPixels():_Array_;

		/**
		* UnityEngine.Texture2D.GetPixels
		*parameters:
		*  miplevel : System.Int32
		*return:
		*   UnityEngine.Color[]
		*/
		[native,unityengine_Texture2D_getPixels_];
		public final function getPixels_(miplevel:int):_Array_;

		/**
		* UnityEngine.Texture2D.GetPixels
		*parameters:
		*  x : System.Int32
		*  y : System.Int32
		*  blockWidth : System.Int32
		*  blockHeight : System.Int32
		*  miplevel : System.Int32
		*return:
		*   UnityEngine.Color[]
		*/
		[native,unityengine_Texture2D_getPixels__];
		public final function getPixels__(x:int,y:int,blockWidth:int,blockHeight:int,miplevel:int):_Array_;

		/**
		* UnityEngine.Texture2D.GetPixels
		*parameters:
		*  x : System.Int32
		*  y : System.Int32
		*  blockWidth : System.Int32
		*  blockHeight : System.Int32
		*return:
		*   UnityEngine.Color[]
		*/
		[native,unityengine_Texture2D_getPixels___];
		public final function getPixels___(x:int,y:int,blockWidth:int,blockHeight:int):_Array_;

		/**
		* UnityEngine.Texture2D.GetPixels32
		*parameters:
		*  miplevel : System.Int32
		*return:
		*   UnityEngine.Color32[]
		*/
		[native,unityengine_Texture2D_getPixels32];
		public final function getPixels32(miplevel:int):_Array_;

		/**
		* UnityEngine.Texture2D.GetPixels32
		*return:
		*   UnityEngine.Color32[]
		*/
		[native,unityengine_Texture2D_getPixels32_];
		public final function getPixels32_():_Array_;

		/**
		* UnityEngine.Texture2D.Apply
		*parameters:
		*  updateMipmaps : System.Boolean
		*  makeNoLongerReadable : System.Boolean
		*/
		[native,unityengine_Texture2D_apply];
		public final function apply(updateMipmaps:Boolean,makeNoLongerReadable:Boolean):void;

		/**
		* UnityEngine.Texture2D.Apply
		*parameters:
		*  updateMipmaps : System.Boolean
		*/
		[native,unityengine_Texture2D_apply_];
		public final function apply_(updateMipmaps:Boolean):void;

		/**
		* UnityEngine.Texture2D.Apply
		*/
		[native,unityengine_Texture2D_apply__];
		public final function apply__():void;

		/**
		* UnityEngine.Texture2D.Resize
		*parameters:
		*  width : System.Int32
		*  height : System.Int32
		*  format : UnityEngine.TextureFormat
		*  hasMipMap : System.Boolean
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Texture2D_resize];
		public final function resize(width:int,height:int,format:TextureFormat,hasMipMap:Boolean):Boolean;

		/**
		* UnityEngine.Texture2D.Resize
		*parameters:
		*  width : System.Int32
		*  height : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,unityengine_Texture2D_resize_];
		public final function resize_(width:int,height:int):Boolean;

		/**
		* UnityEngine.Texture2D.Compress
		*parameters:
		*  highQuality : System.Boolean
		*/
		[native,unityengine_Texture2D_compress];
		public final function compress(highQuality:Boolean):void;

		/**
		* UnityEngine.Texture2D.PackTextures
		*parameters:
		*  textures : UnityEngine.Texture2D[]
		*  padding : System.Int32
		*  maximumAtlasSize : System.Int32
		*  makeNoLongerReadable : System.Boolean
		*return:
		*   UnityEngine.Rect[]
		*/
		[native,unityengine_Texture2D_packTextures];
		public final function packTextures(textures:_Array_,padding:int,maximumAtlasSize:int,makeNoLongerReadable:Boolean):_Array_;

		/**
		* UnityEngine.Texture2D.PackTextures
		*parameters:
		*  textures : UnityEngine.Texture2D[]
		*  padding : System.Int32
		*  maximumAtlasSize : System.Int32
		*return:
		*   UnityEngine.Rect[]
		*/
		[native,unityengine_Texture2D_packTextures_];
		public final function packTextures_(textures:_Array_,padding:int,maximumAtlasSize:int):_Array_;

		/**
		* UnityEngine.Texture2D.PackTextures
		*parameters:
		*  textures : UnityEngine.Texture2D[]
		*  padding : System.Int32
		*return:
		*   UnityEngine.Rect[]
		*/
		[native,unityengine_Texture2D_packTextures__];
		public final function packTextures__(textures:_Array_,padding:int):_Array_;

		/**
		* UnityEngine.Texture2D.GenerateAtlas
		*parameters:
		*  sizes : UnityEngine.Vector2[]
		*  padding : System.Int32
		*  atlasSize : System.Int32
		*  results : System.Collections.Generic.List &lt; UnityEngine.Rect &gt; 
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_Texture2D_generateAtlas];
		public static function generateAtlas(sizes:_Array_,padding:int,atlasSize:int,results:system.collections.generic.List_Of_Rect):Boolean;

		/**
		* UnityEngine.Texture2D.ReadPixels
		*parameters:
		*  source : UnityEngine.Rect
		*  destX : System.Int32
		*  destY : System.Int32
		*  recalculateMipMaps : System.Boolean
		*/
		[native,unityengine_Texture2D_readPixels];
		public final function readPixels(source:Rect,destX:int,destY:int,recalculateMipMaps:Boolean):void;

		/**
		* UnityEngine.Texture2D.ReadPixels
		*parameters:
		*  source : UnityEngine.Rect
		*  destX : System.Int32
		*  destY : System.Int32
		*/
		[native,unityengine_Texture2D_readPixels_];
		public final function readPixels_(source:Rect,destX:int,destY:int):void;


	}
}
