package unityengine
{
	import system._Object_;
	import system._Array_;


		/**
		*  UnityEngine.Object
		*/
	[link_system]
	public class UObject extends system._Object_
	{
		[creator];
		[native,unityengine_Object_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_Object_ctor];
		public function UObject();

		//*********跨语言继承适配器*******
		[crossextendadapter];
		[native,_unityengine_ObjectAdapter_ctor];
		private function _UObjectAdapter();


		//*********公共方法*******
		/**
		* UnityEngine.Object.Destroy
		*parameters:
		*  obj : UnityEngine.Object
		*  t : System.Single
		*/
		[native,static_unityengine_Object_destroy];
		public static function destroy(obj:UObject,t:Number):void;

		/**
		* UnityEngine.Object.Destroy
		*parameters:
		*  obj : UnityEngine.Object
		*/
		[native,static_unityengine_Object_destroy_];
		public static function destroy_(obj:UObject):void;

		/**
		* UnityEngine.Object.DestroyImmediate
		*parameters:
		*  obj : UnityEngine.Object
		*  allowDestroyingAssets : System.Boolean
		*/
		[native,static_unityengine_Object_destroyImmediate];
		public static function destroyImmediate(obj:UObject,allowDestroyingAssets:Boolean):void;

		/**
		* UnityEngine.Object.DestroyImmediate
		*parameters:
		*  obj : UnityEngine.Object
		*/
		[native,static_unityengine_Object_destroyImmediate_];
		public static function destroyImmediate_(obj:UObject):void;

		/**
		* UnityEngine.Object.FindObjectsOfType
		*parameters:
		*  type : System.Type
		*return:
		*   UnityEngine.Object[]
		*/
		[native,static_unityengine_Object_findObjectsOfType];
		public static function findObjectsOfType(type:Class):_Array_;

		/**
		* UnityEngine.Object.get_name
		*return:
		*   System.String
		*/
		[native,unityengine_Object_get_name]
		public final function get name():String;

		/**
		* UnityEngine.Object.set_name
		*parameters:
		*  value : System.String
		*/
		[native,unityengine_Object_set_name]
		public final function set name(value:String):void;

		/**
		* UnityEngine.Object.DontDestroyOnLoad
		*parameters:
		*  target : UnityEngine.Object
		*/
		[native,static_unityengine_Object_dontDestroyOnLoad];
		public static function dontDestroyOnLoad(target:UObject):void;

		/**
		* UnityEngine.Object.get_hideFlags
		*return:
		*   UnityEngine.HideFlags
		*/
		[native,unityengine_Object_get_hideFlags]
		public final function get hideFlags():HideFlags;

		/**
		* UnityEngine.Object.set_hideFlags
		*parameters:
		*  value : UnityEngine.HideFlags
		*/
		[native,unityengine_Object_set_hideFlags]
		public final function set hideFlags(value:HideFlags):void;

		/**
		* UnityEngine.Object.DestroyObject
		*parameters:
		*  obj : UnityEngine.Object
		*  t : System.Single
		*/
		[native,static_unityengine_Object_destroyObject];
		public static function destroyObject(obj:UObject,t:Number):void;

		/**
		* UnityEngine.Object.DestroyObject
		*parameters:
		*  obj : UnityEngine.Object
		*/
		[native,static_unityengine_Object_destroyObject_];
		public static function destroyObject_(obj:UObject):void;

		/**
		* UnityEngine.Object.GetInstanceID
		*return:
		*   System.Int32
		*/
		[native,unityengine_Object_getInstanceID];
		public final function getInstanceID():int;

		/**
		* UnityEngine.Object.Instantiate
		*parameters:
		*  original : UnityEngine.Object
		*  position : UnityEngine.Vector3
		*  rotation : UnityEngine.Quaternion
		*return:
		*   UnityEngine.Object
		*/
		[native,static_unityengine_Object_instantiate];
		public static function instantiate(original:UObject,position:Vector3,rotation:Quaternion):UObject;

		/**
		* UnityEngine.Object.Instantiate
		*parameters:
		*  original : UnityEngine.Object
		*  position : UnityEngine.Vector3
		*  rotation : UnityEngine.Quaternion
		*  parent : UnityEngine.Transform
		*return:
		*   UnityEngine.Object
		*/
		[native,static_unityengine_Object_instantiate_];
		public static function instantiate_(original:UObject,position:Vector3,rotation:Quaternion,parent:Transform):UObject;

		/**
		* UnityEngine.Object.Instantiate
		*parameters:
		*  original : UnityEngine.Object
		*return:
		*   UnityEngine.Object
		*/
		[native,static_unityengine_Object_instantiate__];
		public static function instantiate__(original:UObject):UObject;

		/**
		* UnityEngine.Object.Instantiate
		*parameters:
		*  original : UnityEngine.Object
		*  parent : UnityEngine.Transform
		*return:
		*   UnityEngine.Object
		*/
		[native,static_unityengine_Object_instantiate___];
		public static function instantiate___(original:UObject,parent:Transform):UObject;

		/**
		* UnityEngine.Object.Instantiate
		*parameters:
		*  original : UnityEngine.Object
		*  parent : UnityEngine.Transform
		*  instantiateInWorldSpace : System.Boolean
		*return:
		*   UnityEngine.Object
		*/
		[native,static_unityengine_Object_instantiate____];
		public static function instantiate____(original:UObject,parent:Transform,instantiateInWorldSpace:Boolean):UObject;

		/**
		* UnityEngine.Object.FindObjectOfType
		*parameters:
		*  type : System.Type
		*return:
		*   UnityEngine.Object
		*/
		[native,static_unityengine_Object_findObjectOfType_];
		public static function findObjectOfType_(type:Class):UObject;


		//*****操作重载*****
		/**
		 * Implicit To System.Boolean 
		 */
		[native,static_unityengine_Object_op_Implicit];
		public static function op_Implicit(exists:UObject):Boolean;

		/**
		 * 计算 x == y
		 */
		[native,static_unityengine_Object_op_Equality];
		public static function op_Equality(x:UObject,y:UObject):Boolean;

		[operator,"=="];
		[native,static_unityengine_Object_op_Equality];
		private static function _operator_op_Equality(x:UObject,y:UObject):Boolean;

		/**
		 * 计算 x != y
		 */
		[native,static_unityengine_Object_op_Inequality];
		public static function op_Inequality(x:UObject,y:UObject):Boolean;

		[operator,"!="];
		[native,static_unityengine_Object_op_Inequality];
		private static function _operator_op_Inequality(x:UObject,y:UObject):Boolean;

		[native,unityengine_Object_valueOf];
		public function valueOf():Boolean;


	}
}
