package unityengine.animations
{
	import system._Object_;
	import unityengine.playables.IPlayable;
	import unityengine.playables.PlayableGraph;
	import unityengine.RuntimeAnimatorController;
	import unityengine.playables.PlayableHandle;
	import unityengine.AnimatorStateInfo;
	import unityengine.AnimatorTransitionInfo;
	import system._Array_;
	import system.collections.generic.List_Of_AnimatorClipInfo;
	import unityengine.AnimatorControllerParameter;
	import unityengine.playables.Playable;


		/**
		* Struct
		*  UnityEngine.Animations.AnimatorControllerPlayable
		*/
	[struct]
	[link_system]
	public final class AnimatorControllerPlayable extends system._Object_ implements unityengine.playables.IPlayable
	{
		[creator];
		[native,unityengine_animations_AnimatorControllerPlayable_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_animations_AnimatorControllerPlayable_ctor];
		public function AnimatorControllerPlayable();
		//*********公共方法*******
		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.Play
		*parameters:
		*  stateNameHash : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_play];
		public final function play(stateNameHash:int):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.Play
		*parameters:
		*  stateNameHash : System.Int32
		*  layer : System.Int32
		*  normalizedTime : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_play_];
		public final function play_(stateNameHash:int,layer:int,normalizedTime:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.HasState
		*parameters:
		*  layerIndex : System.Int32
		*  stateID : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_hasState];
		public final function hasState(layerIndex:int,stateID:int):Boolean;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.get_Null
		*return:
		*   UnityEngine.Animations.AnimatorControllerPlayable
		*/
		[native,static_unityengine_animations_AnimatorControllerPlayable_get_Null]
		public static function get null():AnimatorControllerPlayable;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.Create
		*parameters:
		*  graph : UnityEngine.Playables.PlayableGraph
		*  controller : UnityEngine.RuntimeAnimatorController
		*return:
		*   UnityEngine.Animations.AnimatorControllerPlayable
		*/
		[native,static_unityengine_animations_AnimatorControllerPlayable_create];
		public static function create(graph:unityengine.playables.PlayableGraph,controller:unityengine.RuntimeAnimatorController):AnimatorControllerPlayable;

		[native,unityengine_playables_IPlayable_getHandle];
		public final function getHandle():unityengine.playables.PlayableHandle;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.SetHandle
		*parameters:
		*  handle : UnityEngine.Playables.PlayableHandle
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_setHandle];
		public final function setHandle(handle:unityengine.playables.PlayableHandle):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.Equals
		*parameters:
		*  other : UnityEngine.Animations.AnimatorControllerPlayable
		*return:
		*   System.Boolean
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_equals__];
		public final function equals__(other:AnimatorControllerPlayable):Boolean;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetFloat
		*parameters:
		*  name : System.String
		*return:
		*   System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getFloat];
		public final function getFloat(name:String):Number;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetFloat
		*parameters:
		*  id : System.Int32
		*return:
		*   System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getFloat_];
		public final function getFloat_(id:int):Number;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.SetFloat
		*parameters:
		*  name : System.String
		*  value : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_setFloat];
		public final function setFloat(name:String,value:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.SetFloat
		*parameters:
		*  id : System.Int32
		*  value : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_setFloat_];
		public final function setFloat_(id:int,value:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetBool
		*parameters:
		*  name : System.String
		*return:
		*   System.Boolean
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getBool];
		public final function getBool(name:String):Boolean;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetBool
		*parameters:
		*  id : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getBool_];
		public final function getBool_(id:int):Boolean;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.SetBool
		*parameters:
		*  name : System.String
		*  value : System.Boolean
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_setBool];
		public final function setBool(name:String,value:Boolean):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.SetBool
		*parameters:
		*  id : System.Int32
		*  value : System.Boolean
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_setBool_];
		public final function setBool_(id:int,value:Boolean):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetInteger
		*parameters:
		*  name : System.String
		*return:
		*   System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getInteger];
		public final function getInteger(name:String):int;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetInteger
		*parameters:
		*  id : System.Int32
		*return:
		*   System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getInteger_];
		public final function getInteger_(id:int):int;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.SetInteger
		*parameters:
		*  name : System.String
		*  value : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_setInteger];
		public final function setInteger(name:String,value:int):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.SetInteger
		*parameters:
		*  id : System.Int32
		*  value : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_setInteger_];
		public final function setInteger_(id:int,value:int):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.SetTrigger
		*parameters:
		*  name : System.String
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_setTrigger];
		public final function setTrigger(name:String):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.SetTrigger
		*parameters:
		*  id : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_setTrigger_];
		public final function setTrigger_(id:int):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.ResetTrigger
		*parameters:
		*  name : System.String
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_resetTrigger];
		public final function resetTrigger(name:String):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.ResetTrigger
		*parameters:
		*  id : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_resetTrigger_];
		public final function resetTrigger_(id:int):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.IsParameterControlledByCurve
		*parameters:
		*  name : System.String
		*return:
		*   System.Boolean
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_isParameterControlledByCurve];
		public final function isParameterControlledByCurve(name:String):Boolean;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.IsParameterControlledByCurve
		*parameters:
		*  id : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_isParameterControlledByCurve_];
		public final function isParameterControlledByCurve_(id:int):Boolean;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetLayerCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getLayerCount];
		public final function getLayerCount():int;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetLayerName
		*parameters:
		*  layerIndex : System.Int32
		*return:
		*   System.String
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getLayerName];
		public final function getLayerName(layerIndex:int):String;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetLayerIndex
		*parameters:
		*  layerName : System.String
		*return:
		*   System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getLayerIndex];
		public final function getLayerIndex(layerName:String):int;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetLayerWeight
		*parameters:
		*  layerIndex : System.Int32
		*return:
		*   System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getLayerWeight];
		public final function getLayerWeight(layerIndex:int):Number;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.SetLayerWeight
		*parameters:
		*  layerIndex : System.Int32
		*  weight : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_setLayerWeight];
		public final function setLayerWeight(layerIndex:int,weight:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetCurrentAnimatorStateInfo
		*parameters:
		*  layerIndex : System.Int32
		*return:
		*   UnityEngine.AnimatorStateInfo
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getCurrentAnimatorStateInfo];
		public final function getCurrentAnimatorStateInfo(layerIndex:int):unityengine.AnimatorStateInfo;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetNextAnimatorStateInfo
		*parameters:
		*  layerIndex : System.Int32
		*return:
		*   UnityEngine.AnimatorStateInfo
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getNextAnimatorStateInfo];
		public final function getNextAnimatorStateInfo(layerIndex:int):unityengine.AnimatorStateInfo;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetAnimatorTransitionInfo
		*parameters:
		*  layerIndex : System.Int32
		*return:
		*   UnityEngine.AnimatorTransitionInfo
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getAnimatorTransitionInfo];
		public final function getAnimatorTransitionInfo(layerIndex:int):unityengine.AnimatorTransitionInfo;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetCurrentAnimatorClipInfo
		*parameters:
		*  layerIndex : System.Int32
		*return:
		*   UnityEngine.AnimatorClipInfo[]
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getCurrentAnimatorClipInfo];
		public final function getCurrentAnimatorClipInfo(layerIndex:int):_Array_;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetCurrentAnimatorClipInfo
		*parameters:
		*  layerIndex : System.Int32
		*  clips : System.Collections.Generic.List &lt; UnityEngine.AnimatorClipInfo &gt; 
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getCurrentAnimatorClipInfo_];
		public final function getCurrentAnimatorClipInfo_(layerIndex:int,clips:system.collections.generic.List_Of_AnimatorClipInfo):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetNextAnimatorClipInfo
		*parameters:
		*  layerIndex : System.Int32
		*  clips : System.Collections.Generic.List &lt; UnityEngine.AnimatorClipInfo &gt; 
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getNextAnimatorClipInfo];
		public final function getNextAnimatorClipInfo(layerIndex:int,clips:system.collections.generic.List_Of_AnimatorClipInfo):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetCurrentAnimatorClipInfoCount
		*parameters:
		*  layerIndex : System.Int32
		*return:
		*   System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getCurrentAnimatorClipInfoCount];
		public final function getCurrentAnimatorClipInfoCount(layerIndex:int):int;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetNextAnimatorClipInfoCount
		*parameters:
		*  layerIndex : System.Int32
		*return:
		*   System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getNextAnimatorClipInfoCount];
		public final function getNextAnimatorClipInfoCount(layerIndex:int):int;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetNextAnimatorClipInfo
		*parameters:
		*  layerIndex : System.Int32
		*return:
		*   UnityEngine.AnimatorClipInfo[]
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getNextAnimatorClipInfo_];
		public final function getNextAnimatorClipInfo_(layerIndex:int):_Array_;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.IsInTransition
		*parameters:
		*  layerIndex : System.Int32
		*return:
		*   System.Boolean
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_isInTransition];
		public final function isInTransition(layerIndex:int):Boolean;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetParameterCount
		*return:
		*   System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getParameterCount];
		public final function getParameterCount():int;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.GetParameter
		*parameters:
		*  index : System.Int32
		*return:
		*   UnityEngine.AnimatorControllerParameter
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_getParameter];
		public final function getParameter(index:int):unityengine.AnimatorControllerParameter;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.CrossFadeInFixedTime
		*parameters:
		*  stateName : System.String
		*  transitionDuration : System.Single
		*  layer : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_crossFadeInFixedTime];
		public final function crossFadeInFixedTime(stateName:String,transitionDuration:Number,layer:int):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.CrossFadeInFixedTime
		*parameters:
		*  stateName : System.String
		*  transitionDuration : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_crossFadeInFixedTime_];
		public final function crossFadeInFixedTime_(stateName:String,transitionDuration:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.CrossFadeInFixedTime
		*parameters:
		*  stateName : System.String
		*  transitionDuration : System.Single
		*  layer : System.Int32
		*  fixedTime : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_crossFadeInFixedTime__];
		public final function crossFadeInFixedTime__(stateName:String,transitionDuration:Number,layer:int,fixedTime:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.CrossFadeInFixedTime
		*parameters:
		*  stateNameHash : System.Int32
		*  transitionDuration : System.Single
		*  layer : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_crossFadeInFixedTime___];
		public final function crossFadeInFixedTime___(stateNameHash:int,transitionDuration:Number,layer:int):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.CrossFadeInFixedTime
		*parameters:
		*  stateNameHash : System.Int32
		*  transitionDuration : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_crossFadeInFixedTime____];
		public final function crossFadeInFixedTime____(stateNameHash:int,transitionDuration:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.CrossFadeInFixedTime
		*parameters:
		*  stateNameHash : System.Int32
		*  transitionDuration : System.Single
		*  layer : System.Int32
		*  fixedTime : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_crossFadeInFixedTime_____];
		public final function crossFadeInFixedTime_____(stateNameHash:int,transitionDuration:Number,layer:int,fixedTime:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.CrossFade
		*parameters:
		*  stateName : System.String
		*  transitionDuration : System.Single
		*  layer : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_crossFade];
		public final function crossFade(stateName:String,transitionDuration:Number,layer:int):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.CrossFade
		*parameters:
		*  stateName : System.String
		*  transitionDuration : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_crossFade_];
		public final function crossFade_(stateName:String,transitionDuration:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.CrossFade
		*parameters:
		*  stateName : System.String
		*  transitionDuration : System.Single
		*  layer : System.Int32
		*  normalizedTime : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_crossFade__];
		public final function crossFade__(stateName:String,transitionDuration:Number,layer:int,normalizedTime:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.CrossFade
		*parameters:
		*  stateNameHash : System.Int32
		*  transitionDuration : System.Single
		*  layer : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_crossFade___];
		public final function crossFade___(stateNameHash:int,transitionDuration:Number,layer:int):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.CrossFade
		*parameters:
		*  stateNameHash : System.Int32
		*  transitionDuration : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_crossFade____];
		public final function crossFade____(stateNameHash:int,transitionDuration:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.CrossFade
		*parameters:
		*  stateNameHash : System.Int32
		*  transitionDuration : System.Single
		*  layer : System.Int32
		*  normalizedTime : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_crossFade_____];
		public final function crossFade_____(stateNameHash:int,transitionDuration:Number,layer:int,normalizedTime:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.PlayInFixedTime
		*parameters:
		*  stateName : System.String
		*  layer : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_playInFixedTime];
		public final function playInFixedTime(stateName:String,layer:int):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.PlayInFixedTime
		*parameters:
		*  stateName : System.String
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_playInFixedTime_];
		public final function playInFixedTime_(stateName:String):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.PlayInFixedTime
		*parameters:
		*  stateName : System.String
		*  layer : System.Int32
		*  fixedTime : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_playInFixedTime__];
		public final function playInFixedTime__(stateName:String,layer:int,fixedTime:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.PlayInFixedTime
		*parameters:
		*  stateNameHash : System.Int32
		*  layer : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_playInFixedTime___];
		public final function playInFixedTime___(stateNameHash:int,layer:int):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.PlayInFixedTime
		*parameters:
		*  stateNameHash : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_playInFixedTime____];
		public final function playInFixedTime____(stateNameHash:int):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.PlayInFixedTime
		*parameters:
		*  stateNameHash : System.Int32
		*  layer : System.Int32
		*  fixedTime : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_playInFixedTime_____];
		public final function playInFixedTime_____(stateNameHash:int,layer:int,fixedTime:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.Play
		*parameters:
		*  stateName : System.String
		*  layer : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_play__];
		public final function play__(stateName:String,layer:int):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.Play
		*parameters:
		*  stateName : System.String
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_play___];
		public final function play___(stateName:String):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.Play
		*parameters:
		*  stateName : System.String
		*  layer : System.Int32
		*  normalizedTime : System.Single
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_play____];
		public final function play____(stateName:String,layer:int,normalizedTime:Number):void;

		/**
		* UnityEngine.Animations.AnimatorControllerPlayable.Play
		*parameters:
		*  stateNameHash : System.Int32
		*  layer : System.Int32
		*/
		[native,unityengine_animations_AnimatorControllerPlayable_play_____];
		public final function play_____(stateNameHash:int,layer:int):void;


		//*****操作重载*****
		/**
		 * Implicit To UnityEngine.Playables.Playable 
		 */
		[native,static_unityengine_animations_AnimatorControllerPlayable_op_Implicit];
		public static function op_Implicit(playable:AnimatorControllerPlayable):unityengine.playables.Playable;

		/**
		 * Explicit From UnityEngine.Playables.Playable 
		 */
		[native,static_unityengine_animations_AnimatorControllerPlayable_op_Explicit];
		public static function op_Explicit(playable:unityengine.playables.Playable):AnimatorControllerPlayable;


	}
}
