package unityengine.rendering
{
	import system._Object_;
	import system.IDisposable;
	import unityengine.Color;
	import unityengine.Vector4;
	import unityengine.Matrix4x4;
	import system.collections.generic.List_Of_Single;
	import system._Array_;
	import system.collections.generic.List_Of_Vector4;
	import system.collections.generic.List_Of_Matrix4x4;
	import unityengine.ComputeBuffer;
	import system.IntPtr;
	import unityengine.Texture;
	import unityengine.ComputeShader;
	import unityengine.Mesh;
	import unityengine.Material;
	import unityengine.MaterialPropertyBlock;
	import unityengine.Renderer;
	import unityengine.MeshTopology;
	import unityengine.CubemapFace;
	import unityengine.Rect;
	import unityengine.Vector2;
	import unityengine.FilterMode;
	import unityengine.RenderTextureFormat;
	import unityengine.RenderTextureReadWrite;
	import unityengine.RenderTextureMemoryless;
	import unityengine.RenderTextureDescriptor;


		/**
		* Sealed
		*  UnityEngine.Rendering.CommandBuffer
		*/
	[link_system]
	public final class CommandBuffer extends system._Object_ implements system.IDisposable
	{
		[creator];
		[native,unityengine_rendering_CommandBuffer_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_rendering_CommandBuffer_ctor];
		public function CommandBuffer();


		//*********公共方法*******
		/**
		* UnityEngine.Rendering.CommandBuffer.ReleaseTemporaryRT
		*parameters:
		*  nameID : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_releaseTemporaryRT];
		public final function releaseTemporaryRT(nameID:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.ClearRenderTarget
		*parameters:
		*  clearDepth : System.Boolean
		*  clearColor : System.Boolean
		*  backgroundColor : UnityEngine.Color
		*  depth : System.Single
		*/
		[native,unityengine_rendering_CommandBuffer_clearRenderTarget];
		public final function clearRenderTarget(clearDepth:Boolean,clearColor:Boolean,backgroundColor:unityengine.Color,depth:Number):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.ClearRenderTarget
		*parameters:
		*  clearDepth : System.Boolean
		*  clearColor : System.Boolean
		*  backgroundColor : UnityEngine.Color
		*/
		[native,unityengine_rendering_CommandBuffer_clearRenderTarget_];
		public final function clearRenderTarget_(clearDepth:Boolean,clearColor:Boolean,backgroundColor:unityengine.Color):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalFloat
		*parameters:
		*  name : System.String
		*  value : System.Single
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalFloat];
		public final function setGlobalFloat(name:String,value:Number):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalFloat
		*parameters:
		*  nameID : System.Int32
		*  value : System.Single
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalFloat_];
		public final function setGlobalFloat_(nameID:int,value:Number):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalVector
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Vector4
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalVector];
		public final function setGlobalVector(name:String,value:unityengine.Vector4):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalVector
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Vector4
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalVector_];
		public final function setGlobalVector_(nameID:int,value:unityengine.Vector4):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalColor
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Color
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalColor];
		public final function setGlobalColor(name:String,value:unityengine.Color):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalColor
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Color
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalColor_];
		public final function setGlobalColor_(nameID:int,value:unityengine.Color):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalMatrix
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Matrix4x4
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalMatrix];
		public final function setGlobalMatrix(name:String,value:unityengine.Matrix4x4):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalMatrix
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Matrix4x4
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalMatrix_];
		public final function setGlobalMatrix_(nameID:int,value:unityengine.Matrix4x4):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.EnableShaderKeyword
		*parameters:
		*  keyword : System.String
		*/
		[native,unityengine_rendering_CommandBuffer_enableShaderKeyword];
		public final function enableShaderKeyword(keyword:String):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DisableShaderKeyword
		*parameters:
		*  keyword : System.String
		*/
		[native,unityengine_rendering_CommandBuffer_disableShaderKeyword];
		public final function disableShaderKeyword(keyword:String):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetViewMatrix
		*parameters:
		*  view : UnityEngine.Matrix4x4
		*/
		[native,unityengine_rendering_CommandBuffer_setViewMatrix];
		public final function setViewMatrix(view:unityengine.Matrix4x4):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetProjectionMatrix
		*parameters:
		*  proj : UnityEngine.Matrix4x4
		*/
		[native,unityengine_rendering_CommandBuffer_setProjectionMatrix];
		public final function setProjectionMatrix(proj:unityengine.Matrix4x4):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetViewProjectionMatrices
		*parameters:
		*  view : UnityEngine.Matrix4x4
		*  proj : UnityEngine.Matrix4x4
		*/
		[native,unityengine_rendering_CommandBuffer_setViewProjectionMatrices];
		public final function setViewProjectionMatrices(view:unityengine.Matrix4x4,proj:unityengine.Matrix4x4):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalDepthBias
		*parameters:
		*  bias : System.Single
		*  slopeBias : System.Single
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalDepthBias];
		public final function setGlobalDepthBias(bias:Number,slopeBias:Number):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalFloatArray
		*parameters:
		*  propertyName : System.String
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalFloatArray];
		public final function setGlobalFloatArray(propertyName:String,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalFloatArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; System.Single &gt; 
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalFloatArray_];
		public final function setGlobalFloatArray_(nameID:int,values:system.collections.generic.List_Of_Single):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalFloatArray
		*parameters:
		*  propertyName : System.String
		*  values : System.Single[]
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalFloatArray__];
		public final function setGlobalFloatArray__(propertyName:String,values:_Array_):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalFloatArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Single[]
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalFloatArray___];
		public final function setGlobalFloatArray___(nameID:int,values:_Array_):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalVectorArray
		*parameters:
		*  propertyName : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalVectorArray];
		public final function setGlobalVectorArray(propertyName:String,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalVectorArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Vector4 &gt; 
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalVectorArray_];
		public final function setGlobalVectorArray_(nameID:int,values:system.collections.generic.List_Of_Vector4):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalVectorArray
		*parameters:
		*  propertyName : System.String
		*  values : UnityEngine.Vector4[]
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalVectorArray__];
		public final function setGlobalVectorArray__(propertyName:String,values:_Array_):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalVectorArray
		*parameters:
		*  nameID : System.Int32
		*  values : UnityEngine.Vector4[]
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalVectorArray___];
		public final function setGlobalVectorArray___(nameID:int,values:_Array_):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalMatrixArray
		*parameters:
		*  propertyName : System.String
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalMatrixArray];
		public final function setGlobalMatrixArray(propertyName:String,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalMatrixArray
		*parameters:
		*  nameID : System.Int32
		*  values : System.Collections.Generic.List &lt; UnityEngine.Matrix4x4 &gt; 
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalMatrixArray_];
		public final function setGlobalMatrixArray_(nameID:int,values:system.collections.generic.List_Of_Matrix4x4):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalMatrixArray
		*parameters:
		*  propertyName : System.String
		*  values : UnityEngine.Matrix4x4[]
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalMatrixArray__];
		public final function setGlobalMatrixArray__(propertyName:String,values:_Array_):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalMatrixArray
		*parameters:
		*  nameID : System.Int32
		*  values : UnityEngine.Matrix4x4[]
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalMatrixArray___];
		public final function setGlobalMatrixArray___(nameID:int,values:_Array_):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalTexture
		*parameters:
		*  name : System.String
		*  value : UnityEngine.Rendering.RenderTargetIdentifier
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalTexture];
		public final function setGlobalTexture(name:String,value:RenderTargetIdentifier):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalTexture
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.Rendering.RenderTargetIdentifier
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalTexture_];
		public final function setGlobalTexture_(nameID:int,value:RenderTargetIdentifier):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalBuffer
		*parameters:
		*  name : System.String
		*  value : UnityEngine.ComputeBuffer
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalBuffer];
		public final function setGlobalBuffer(name:String,value:unityengine.ComputeBuffer):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetGlobalBuffer
		*parameters:
		*  nameID : System.Int32
		*  value : UnityEngine.ComputeBuffer
		*/
		[native,unityengine_rendering_CommandBuffer_setGlobalBuffer_];
		public final function setGlobalBuffer_(nameID:int,value:unityengine.ComputeBuffer):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetShadowSamplingMode
		*parameters:
		*  shadowmap : UnityEngine.Rendering.RenderTargetIdentifier
		*  mode : UnityEngine.Rendering.ShadowSamplingMode
		*/
		[native,unityengine_rendering_CommandBuffer_setShadowSamplingMode];
		public final function setShadowSamplingMode(shadowmap:RenderTargetIdentifier,mode:ShadowSamplingMode):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.IssuePluginEvent
		*parameters:
		*  callback : System.IntPtr
		*  eventID : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_issuePluginEvent];
		public final function issuePluginEvent(callback:system.IntPtr,eventID:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.BeginSample
		*parameters:
		*  name : System.String
		*/
		[native,unityengine_rendering_CommandBuffer_beginSample];
		public final function beginSample(name:String):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.EndSample
		*parameters:
		*  name : System.String
		*/
		[native,unityengine_rendering_CommandBuffer_endSample];
		public final function endSample(name:String):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.IssuePluginEventAndData
		*parameters:
		*  callback : System.IntPtr
		*  eventID : System.Int32
		*  data : System.IntPtr
		*/
		[native,unityengine_rendering_CommandBuffer_issuePluginEventAndData];
		public final function issuePluginEventAndData(callback:system.IntPtr,eventID:int,data:system.IntPtr):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.IssuePluginCustomBlit
		*parameters:
		*  callback : System.IntPtr
		*  command : System.UInt32
		*  source : UnityEngine.Rendering.RenderTargetIdentifier
		*  dest : UnityEngine.Rendering.RenderTargetIdentifier
		*  commandParam : System.UInt32
		*  commandFlags : System.UInt32
		*/
		[native,unityengine_rendering_CommandBuffer_issuePluginCustomBlit];
		public final function issuePluginCustomBlit(callback:system.IntPtr,command:uint,source:RenderTargetIdentifier,dest:RenderTargetIdentifier,commandParam:uint,commandFlags:uint):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.IssuePluginCustomTextureUpdate
		*parameters:
		*  callback : System.IntPtr
		*  targetTexture : UnityEngine.Texture
		*  userData : System.UInt32
		*/
		[native,unityengine_rendering_CommandBuffer_issuePluginCustomTextureUpdate];
		public final function issuePluginCustomTextureUpdate(callback:system.IntPtr,targetTexture:unityengine.Texture,userData:uint):void;

		[native,system_IDisposable_dispose];
		public final function dispose():void;

		/**
		* UnityEngine.Rendering.CommandBuffer.Release
		*/
		[native,unityengine_rendering_CommandBuffer_release];
		public final function release():void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetComputeFloatParam
		*parameters:
		*  computeShader : UnityEngine.ComputeShader
		*  name : System.String
		*  val : System.Single
		*/
		[native,unityengine_rendering_CommandBuffer_setComputeFloatParam];
		public final function setComputeFloatParam(computeShader:unityengine.ComputeShader,name:String,val:Number):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetComputeIntParam
		*parameters:
		*  computeShader : UnityEngine.ComputeShader
		*  name : System.String
		*  val : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_setComputeIntParam];
		public final function setComputeIntParam(computeShader:unityengine.ComputeShader,name:String,val:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetComputeVectorParam
		*parameters:
		*  computeShader : UnityEngine.ComputeShader
		*  name : System.String
		*  val : UnityEngine.Vector4
		*/
		[native,unityengine_rendering_CommandBuffer_setComputeVectorParam];
		public final function setComputeVectorParam(computeShader:unityengine.ComputeShader,name:String,val:unityengine.Vector4):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetComputeFloatParams
		*parameters:
		*  computeShader : UnityEngine.ComputeShader
		*  name : System.String
		*  values : System.Single[]
		*/
		[native,unityengine_rendering_CommandBuffer_setComputeFloatParams];
		public final function setComputeFloatParams(computeShader:unityengine.ComputeShader,name:String,values:_Array_):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetComputeIntParams
		*parameters:
		*  computeShader : UnityEngine.ComputeShader
		*  name : System.String
		*  values : System.Int32[]
		*/
		[native,unityengine_rendering_CommandBuffer_setComputeIntParams];
		public final function setComputeIntParams(computeShader:unityengine.ComputeShader,name:String,values:_Array_):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetComputeTextureParam
		*parameters:
		*  computeShader : UnityEngine.ComputeShader
		*  kernelIndex : System.Int32
		*  name : System.String
		*  rt : UnityEngine.Rendering.RenderTargetIdentifier
		*/
		[native,unityengine_rendering_CommandBuffer_setComputeTextureParam];
		public final function setComputeTextureParam(computeShader:unityengine.ComputeShader,kernelIndex:int,name:String,rt:RenderTargetIdentifier):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetComputeBufferParam
		*parameters:
		*  computeShader : UnityEngine.ComputeShader
		*  kernelIndex : System.Int32
		*  name : System.String
		*  buffer : UnityEngine.ComputeBuffer
		*/
		[native,unityengine_rendering_CommandBuffer_setComputeBufferParam];
		public final function setComputeBufferParam(computeShader:unityengine.ComputeShader,kernelIndex:int,name:String,buffer:unityengine.ComputeBuffer):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DispatchCompute
		*parameters:
		*  computeShader : UnityEngine.ComputeShader
		*  kernelIndex : System.Int32
		*  threadGroupsX : System.Int32
		*  threadGroupsY : System.Int32
		*  threadGroupsZ : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_dispatchCompute];
		public final function dispatchCompute(computeShader:unityengine.ComputeShader,kernelIndex:int,threadGroupsX:int,threadGroupsY:int,threadGroupsZ:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DispatchCompute
		*parameters:
		*  computeShader : UnityEngine.ComputeShader
		*  kernelIndex : System.Int32
		*  indirectBuffer : UnityEngine.ComputeBuffer
		*  argsOffset : System.UInt32
		*/
		[native,unityengine_rendering_CommandBuffer_dispatchCompute_];
		public final function dispatchCompute_(computeShader:unityengine.ComputeShader,kernelIndex:int,indirectBuffer:unityengine.ComputeBuffer,argsOffset:uint):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.CopyCounterValue
		*parameters:
		*  src : UnityEngine.ComputeBuffer
		*  dst : UnityEngine.ComputeBuffer
		*  dstOffsetBytes : System.UInt32
		*/
		[native,unityengine_rendering_CommandBuffer_copyCounterValue];
		public final function copyCounterValue(src:unityengine.ComputeBuffer,dst:unityengine.ComputeBuffer,dstOffsetBytes:uint):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.get_name
		*return:
		*   System.String
		*/
		[native,unityengine_rendering_CommandBuffer_get_name]
		public final function get name():String;

		/**
		* UnityEngine.Rendering.CommandBuffer.set_name
		*parameters:
		*  value : System.String
		*/
		[native,unityengine_rendering_CommandBuffer_set_name]
		public final function set name(value:String):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.get_sizeInBytes
		*return:
		*   System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_get_sizeInBytes]
		public final function get sizeInBytes():int;

		/**
		* UnityEngine.Rendering.CommandBuffer.Clear
		*/
		[native,unityengine_rendering_CommandBuffer_clear];
		public final function clear():void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawMesh
		*parameters:
		*  mesh : UnityEngine.Mesh
		*  matrix : UnityEngine.Matrix4x4
		*  material : UnityEngine.Material
		*  submeshIndex : System.Int32
		*  shaderPass : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_drawMesh];
		public final function drawMesh(mesh:unityengine.Mesh,matrix:unityengine.Matrix4x4,material:unityengine.Material,submeshIndex:int,shaderPass:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawMesh
		*parameters:
		*  mesh : UnityEngine.Mesh
		*  matrix : UnityEngine.Matrix4x4
		*  material : UnityEngine.Material
		*  submeshIndex : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_drawMesh_];
		public final function drawMesh_(mesh:unityengine.Mesh,matrix:unityengine.Matrix4x4,material:unityengine.Material,submeshIndex:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawMesh
		*parameters:
		*  mesh : UnityEngine.Mesh
		*  matrix : UnityEngine.Matrix4x4
		*  material : UnityEngine.Material
		*/
		[native,unityengine_rendering_CommandBuffer_drawMesh__];
		public final function drawMesh__(mesh:unityengine.Mesh,matrix:unityengine.Matrix4x4,material:unityengine.Material):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawMesh
		*parameters:
		*  mesh : UnityEngine.Mesh
		*  matrix : UnityEngine.Matrix4x4
		*  material : UnityEngine.Material
		*  submeshIndex : System.Int32
		*  shaderPass : System.Int32
		*  properties : UnityEngine.MaterialPropertyBlock
		*/
		[native,unityengine_rendering_CommandBuffer_drawMesh___];
		public final function drawMesh___(mesh:unityengine.Mesh,matrix:unityengine.Matrix4x4,material:unityengine.Material,submeshIndex:int,shaderPass:int,properties:unityengine.MaterialPropertyBlock):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawRenderer
		*parameters:
		*  renderer : UnityEngine.Renderer
		*  material : UnityEngine.Material
		*  submeshIndex : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_drawRenderer];
		public final function drawRenderer(renderer:unityengine.Renderer,material:unityengine.Material,submeshIndex:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawRenderer
		*parameters:
		*  renderer : UnityEngine.Renderer
		*  material : UnityEngine.Material
		*/
		[native,unityengine_rendering_CommandBuffer_drawRenderer_];
		public final function drawRenderer_(renderer:unityengine.Renderer,material:unityengine.Material):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawRenderer
		*parameters:
		*  renderer : UnityEngine.Renderer
		*  material : UnityEngine.Material
		*  submeshIndex : System.Int32
		*  shaderPass : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_drawRenderer__];
		public final function drawRenderer__(renderer:unityengine.Renderer,material:unityengine.Material,submeshIndex:int,shaderPass:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawProcedural
		*parameters:
		*  matrix : UnityEngine.Matrix4x4
		*  material : UnityEngine.Material
		*  shaderPass : System.Int32
		*  topology : UnityEngine.MeshTopology
		*  vertexCount : System.Int32
		*  instanceCount : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_drawProcedural];
		public final function drawProcedural(matrix:unityengine.Matrix4x4,material:unityengine.Material,shaderPass:int,topology:unityengine.MeshTopology,vertexCount:int,instanceCount:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawProcedural
		*parameters:
		*  matrix : UnityEngine.Matrix4x4
		*  material : UnityEngine.Material
		*  shaderPass : System.Int32
		*  topology : UnityEngine.MeshTopology
		*  vertexCount : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_drawProcedural_];
		public final function drawProcedural_(matrix:unityengine.Matrix4x4,material:unityengine.Material,shaderPass:int,topology:unityengine.MeshTopology,vertexCount:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawProcedural
		*parameters:
		*  matrix : UnityEngine.Matrix4x4
		*  material : UnityEngine.Material
		*  shaderPass : System.Int32
		*  topology : UnityEngine.MeshTopology
		*  vertexCount : System.Int32
		*  instanceCount : System.Int32
		*  properties : UnityEngine.MaterialPropertyBlock
		*/
		[native,unityengine_rendering_CommandBuffer_drawProcedural__];
		public final function drawProcedural__(matrix:unityengine.Matrix4x4,material:unityengine.Material,shaderPass:int,topology:unityengine.MeshTopology,vertexCount:int,instanceCount:int,properties:unityengine.MaterialPropertyBlock):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawProceduralIndirect
		*parameters:
		*  matrix : UnityEngine.Matrix4x4
		*  material : UnityEngine.Material
		*  shaderPass : System.Int32
		*  topology : UnityEngine.MeshTopology
		*  bufferWithArgs : UnityEngine.ComputeBuffer
		*  argsOffset : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_drawProceduralIndirect];
		public final function drawProceduralIndirect(matrix:unityengine.Matrix4x4,material:unityengine.Material,shaderPass:int,topology:unityengine.MeshTopology,bufferWithArgs:unityengine.ComputeBuffer,argsOffset:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawProceduralIndirect
		*parameters:
		*  matrix : UnityEngine.Matrix4x4
		*  material : UnityEngine.Material
		*  shaderPass : System.Int32
		*  topology : UnityEngine.MeshTopology
		*  bufferWithArgs : UnityEngine.ComputeBuffer
		*/
		[native,unityengine_rendering_CommandBuffer_drawProceduralIndirect_];
		public final function drawProceduralIndirect_(matrix:unityengine.Matrix4x4,material:unityengine.Material,shaderPass:int,topology:unityengine.MeshTopology,bufferWithArgs:unityengine.ComputeBuffer):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawProceduralIndirect
		*parameters:
		*  matrix : UnityEngine.Matrix4x4
		*  material : UnityEngine.Material
		*  shaderPass : System.Int32
		*  topology : UnityEngine.MeshTopology
		*  bufferWithArgs : UnityEngine.ComputeBuffer
		*  argsOffset : System.Int32
		*  properties : UnityEngine.MaterialPropertyBlock
		*/
		[native,unityengine_rendering_CommandBuffer_drawProceduralIndirect__];
		public final function drawProceduralIndirect__(matrix:unityengine.Matrix4x4,material:unityengine.Material,shaderPass:int,topology:unityengine.MeshTopology,bufferWithArgs:unityengine.ComputeBuffer,argsOffset:int,properties:unityengine.MaterialPropertyBlock):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawMeshInstanced
		*parameters:
		*  mesh : UnityEngine.Mesh
		*  submeshIndex : System.Int32
		*  material : UnityEngine.Material
		*  shaderPass : System.Int32
		*  matrices : UnityEngine.Matrix4x4[]
		*  count : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_drawMeshInstanced];
		public final function drawMeshInstanced(mesh:unityengine.Mesh,submeshIndex:int,material:unityengine.Material,shaderPass:int,matrices:_Array_,count:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawMeshInstanced
		*parameters:
		*  mesh : UnityEngine.Mesh
		*  submeshIndex : System.Int32
		*  material : UnityEngine.Material
		*  shaderPass : System.Int32
		*  matrices : UnityEngine.Matrix4x4[]
		*/
		[native,unityengine_rendering_CommandBuffer_drawMeshInstanced_];
		public final function drawMeshInstanced_(mesh:unityengine.Mesh,submeshIndex:int,material:unityengine.Material,shaderPass:int,matrices:_Array_):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawMeshInstanced
		*parameters:
		*  mesh : UnityEngine.Mesh
		*  submeshIndex : System.Int32
		*  material : UnityEngine.Material
		*  shaderPass : System.Int32
		*  matrices : UnityEngine.Matrix4x4[]
		*  count : System.Int32
		*  properties : UnityEngine.MaterialPropertyBlock
		*/
		[native,unityengine_rendering_CommandBuffer_drawMeshInstanced__];
		public final function drawMeshInstanced__(mesh:unityengine.Mesh,submeshIndex:int,material:unityengine.Material,shaderPass:int,matrices:_Array_,count:int,properties:unityengine.MaterialPropertyBlock):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawMeshInstancedIndirect
		*parameters:
		*  mesh : UnityEngine.Mesh
		*  submeshIndex : System.Int32
		*  material : UnityEngine.Material
		*  shaderPass : System.Int32
		*  bufferWithArgs : UnityEngine.ComputeBuffer
		*  argsOffset : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_drawMeshInstancedIndirect];
		public final function drawMeshInstancedIndirect(mesh:unityengine.Mesh,submeshIndex:int,material:unityengine.Material,shaderPass:int,bufferWithArgs:unityengine.ComputeBuffer,argsOffset:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawMeshInstancedIndirect
		*parameters:
		*  mesh : UnityEngine.Mesh
		*  submeshIndex : System.Int32
		*  material : UnityEngine.Material
		*  shaderPass : System.Int32
		*  bufferWithArgs : UnityEngine.ComputeBuffer
		*/
		[native,unityengine_rendering_CommandBuffer_drawMeshInstancedIndirect_];
		public final function drawMeshInstancedIndirect_(mesh:unityengine.Mesh,submeshIndex:int,material:unityengine.Material,shaderPass:int,bufferWithArgs:unityengine.ComputeBuffer):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.DrawMeshInstancedIndirect
		*parameters:
		*  mesh : UnityEngine.Mesh
		*  submeshIndex : System.Int32
		*  material : UnityEngine.Material
		*  shaderPass : System.Int32
		*  bufferWithArgs : UnityEngine.ComputeBuffer
		*  argsOffset : System.Int32
		*  properties : UnityEngine.MaterialPropertyBlock
		*/
		[native,unityengine_rendering_CommandBuffer_drawMeshInstancedIndirect__];
		public final function drawMeshInstancedIndirect__(mesh:unityengine.Mesh,submeshIndex:int,material:unityengine.Material,shaderPass:int,bufferWithArgs:unityengine.ComputeBuffer,argsOffset:int,properties:unityengine.MaterialPropertyBlock):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetRenderTarget
		*parameters:
		*  rt : UnityEngine.Rendering.RenderTargetIdentifier
		*/
		[native,unityengine_rendering_CommandBuffer_setRenderTarget];
		public final function setRenderTarget(rt:RenderTargetIdentifier):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetRenderTarget
		*parameters:
		*  rt : UnityEngine.Rendering.RenderTargetIdentifier
		*  mipLevel : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_setRenderTarget_];
		public final function setRenderTarget_(rt:RenderTargetIdentifier,mipLevel:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetRenderTarget
		*parameters:
		*  rt : UnityEngine.Rendering.RenderTargetIdentifier
		*  mipLevel : System.Int32
		*  cubemapFace : UnityEngine.CubemapFace
		*/
		[native,unityengine_rendering_CommandBuffer_setRenderTarget__];
		public final function setRenderTarget__(rt:RenderTargetIdentifier,mipLevel:int,cubemapFace:unityengine.CubemapFace):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetRenderTarget
		*parameters:
		*  rt : UnityEngine.Rendering.RenderTargetIdentifier
		*  mipLevel : System.Int32
		*  cubemapFace : UnityEngine.CubemapFace
		*  depthSlice : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_setRenderTarget___];
		public final function setRenderTarget___(rt:RenderTargetIdentifier,mipLevel:int,cubemapFace:unityengine.CubemapFace,depthSlice:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetRenderTarget
		*parameters:
		*  color : UnityEngine.Rendering.RenderTargetIdentifier
		*  depth : UnityEngine.Rendering.RenderTargetIdentifier
		*/
		[native,unityengine_rendering_CommandBuffer_setRenderTarget____];
		public final function setRenderTarget____(color:RenderTargetIdentifier,depth:RenderTargetIdentifier):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetRenderTarget
		*parameters:
		*  color : UnityEngine.Rendering.RenderTargetIdentifier
		*  depth : UnityEngine.Rendering.RenderTargetIdentifier
		*  mipLevel : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_setRenderTarget_____];
		public final function setRenderTarget_____(color:RenderTargetIdentifier,depth:RenderTargetIdentifier,mipLevel:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetRenderTarget
		*parameters:
		*  color : UnityEngine.Rendering.RenderTargetIdentifier
		*  depth : UnityEngine.Rendering.RenderTargetIdentifier
		*  mipLevel : System.Int32
		*  cubemapFace : UnityEngine.CubemapFace
		*/
		[native,unityengine_rendering_CommandBuffer_setRenderTarget______];
		public final function setRenderTarget______(color:RenderTargetIdentifier,depth:RenderTargetIdentifier,mipLevel:int,cubemapFace:unityengine.CubemapFace):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetRenderTarget
		*parameters:
		*  color : UnityEngine.Rendering.RenderTargetIdentifier
		*  depth : UnityEngine.Rendering.RenderTargetIdentifier
		*  mipLevel : System.Int32
		*  cubemapFace : UnityEngine.CubemapFace
		*  depthSlice : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_setRenderTarget_______];
		public final function setRenderTarget_______(color:RenderTargetIdentifier,depth:RenderTargetIdentifier,mipLevel:int,cubemapFace:unityengine.CubemapFace,depthSlice:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetRenderTarget
		*parameters:
		*  colors : UnityEngine.Rendering.RenderTargetIdentifier[]
		*  depth : UnityEngine.Rendering.RenderTargetIdentifier
		*/
		[native,unityengine_rendering_CommandBuffer_setRenderTarget________];
		public final function setRenderTarget________(colors:_Array_,depth:RenderTargetIdentifier):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetRandomWriteTarget
		*parameters:
		*  index : System.Int32
		*  rt : UnityEngine.Rendering.RenderTargetIdentifier
		*/
		[native,unityengine_rendering_CommandBuffer_setRandomWriteTarget];
		public final function setRandomWriteTarget(index:int,rt:RenderTargetIdentifier):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetRandomWriteTarget
		*parameters:
		*  index : System.Int32
		*  buffer : UnityEngine.ComputeBuffer
		*/
		[native,unityengine_rendering_CommandBuffer_setRandomWriteTarget_];
		public final function setRandomWriteTarget_(index:int,buffer:unityengine.ComputeBuffer):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetRandomWriteTarget
		*parameters:
		*  index : System.Int32
		*  buffer : UnityEngine.ComputeBuffer
		*  preserveCounterValue : System.Boolean
		*/
		[native,unityengine_rendering_CommandBuffer_setRandomWriteTarget__];
		public final function setRandomWriteTarget__(index:int,buffer:unityengine.ComputeBuffer,preserveCounterValue:Boolean):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.ClearRandomWriteTargets
		*/
		[native,unityengine_rendering_CommandBuffer_clearRandomWriteTargets];
		public final function clearRandomWriteTargets():void;

		/**
		* UnityEngine.Rendering.CommandBuffer.CopyTexture
		*parameters:
		*  src : UnityEngine.Rendering.RenderTargetIdentifier
		*  dst : UnityEngine.Rendering.RenderTargetIdentifier
		*/
		[native,unityengine_rendering_CommandBuffer_copyTexture];
		public final function copyTexture(src:RenderTargetIdentifier,dst:RenderTargetIdentifier):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.CopyTexture
		*parameters:
		*  src : UnityEngine.Rendering.RenderTargetIdentifier
		*  srcElement : System.Int32
		*  dst : UnityEngine.Rendering.RenderTargetIdentifier
		*  dstElement : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_copyTexture_];
		public final function copyTexture_(src:RenderTargetIdentifier,srcElement:int,dst:RenderTargetIdentifier,dstElement:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.CopyTexture
		*parameters:
		*  src : UnityEngine.Rendering.RenderTargetIdentifier
		*  srcElement : System.Int32
		*  srcMip : System.Int32
		*  dst : UnityEngine.Rendering.RenderTargetIdentifier
		*  dstElement : System.Int32
		*  dstMip : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_copyTexture__];
		public final function copyTexture__(src:RenderTargetIdentifier,srcElement:int,srcMip:int,dst:RenderTargetIdentifier,dstElement:int,dstMip:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.CopyTexture
		*parameters:
		*  src : UnityEngine.Rendering.RenderTargetIdentifier
		*  srcElement : System.Int32
		*  srcMip : System.Int32
		*  srcX : System.Int32
		*  srcY : System.Int32
		*  srcWidth : System.Int32
		*  srcHeight : System.Int32
		*  dst : UnityEngine.Rendering.RenderTargetIdentifier
		*  dstElement : System.Int32
		*  dstMip : System.Int32
		*  dstX : System.Int32
		*  dstY : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_copyTexture___];
		public final function copyTexture___(src:RenderTargetIdentifier,srcElement:int,srcMip:int,srcX:int,srcY:int,srcWidth:int,srcHeight:int,dst:RenderTargetIdentifier,dstElement:int,dstMip:int,dstX:int,dstY:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.SetViewport
		*parameters:
		*  pixelRect : UnityEngine.Rect
		*/
		[native,unityengine_rendering_CommandBuffer_setViewport];
		public final function setViewport(pixelRect:unityengine.Rect):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.Blit
		*parameters:
		*  source : UnityEngine.Texture
		*  dest : UnityEngine.Rendering.RenderTargetIdentifier
		*/
		[native,unityengine_rendering_CommandBuffer_blit];
		public final function blit(source:unityengine.Texture,dest:RenderTargetIdentifier):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.Blit
		*parameters:
		*  source : UnityEngine.Texture
		*  dest : UnityEngine.Rendering.RenderTargetIdentifier
		*  scale : UnityEngine.Vector2
		*  offset : UnityEngine.Vector2
		*/
		[native,unityengine_rendering_CommandBuffer_blit_];
		public final function blit_(source:unityengine.Texture,dest:RenderTargetIdentifier,scale:unityengine.Vector2,offset:unityengine.Vector2):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.Blit
		*parameters:
		*  source : UnityEngine.Texture
		*  dest : UnityEngine.Rendering.RenderTargetIdentifier
		*  mat : UnityEngine.Material
		*/
		[native,unityengine_rendering_CommandBuffer_blit__];
		public final function blit__(source:unityengine.Texture,dest:RenderTargetIdentifier,mat:unityengine.Material):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.Blit
		*parameters:
		*  source : UnityEngine.Texture
		*  dest : UnityEngine.Rendering.RenderTargetIdentifier
		*  mat : UnityEngine.Material
		*  pass : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_blit___];
		public final function blit___(source:unityengine.Texture,dest:RenderTargetIdentifier,mat:unityengine.Material,pass:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.Blit
		*parameters:
		*  source : UnityEngine.Rendering.RenderTargetIdentifier
		*  dest : UnityEngine.Rendering.RenderTargetIdentifier
		*/
		[native,unityengine_rendering_CommandBuffer_blit____];
		public final function blit____(source:RenderTargetIdentifier,dest:RenderTargetIdentifier):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.Blit
		*parameters:
		*  source : UnityEngine.Rendering.RenderTargetIdentifier
		*  dest : UnityEngine.Rendering.RenderTargetIdentifier
		*  scale : UnityEngine.Vector2
		*  offset : UnityEngine.Vector2
		*/
		[native,unityengine_rendering_CommandBuffer_blit_____];
		public final function blit_____(source:RenderTargetIdentifier,dest:RenderTargetIdentifier,scale:unityengine.Vector2,offset:unityengine.Vector2):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.Blit
		*parameters:
		*  source : UnityEngine.Rendering.RenderTargetIdentifier
		*  dest : UnityEngine.Rendering.RenderTargetIdentifier
		*  mat : UnityEngine.Material
		*/
		[native,unityengine_rendering_CommandBuffer_blit______];
		public final function blit______(source:RenderTargetIdentifier,dest:RenderTargetIdentifier,mat:unityengine.Material):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.Blit
		*parameters:
		*  source : UnityEngine.Rendering.RenderTargetIdentifier
		*  dest : UnityEngine.Rendering.RenderTargetIdentifier
		*  mat : UnityEngine.Material
		*  pass : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_blit_______];
		public final function blit_______(source:RenderTargetIdentifier,dest:RenderTargetIdentifier,mat:unityengine.Material,pass:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRT
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  depthBuffer : System.Int32
		*  filter : UnityEngine.FilterMode
		*  format : UnityEngine.RenderTextureFormat
		*  readWrite : UnityEngine.RenderTextureReadWrite
		*  antiAliasing : System.Int32
		*  enableRandomWrite : System.Boolean
		*  memorylessMode : UnityEngine.RenderTextureMemoryless
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRT];
		public final function getTemporaryRT(nameID:int,width:int,height:int,depthBuffer:int,filter:unityengine.FilterMode,format:unityengine.RenderTextureFormat,readWrite:unityengine.RenderTextureReadWrite,antiAliasing:int,enableRandomWrite:Boolean,memorylessMode:unityengine.RenderTextureMemoryless):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRT
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  depthBuffer : System.Int32
		*  filter : UnityEngine.FilterMode
		*  format : UnityEngine.RenderTextureFormat
		*  readWrite : UnityEngine.RenderTextureReadWrite
		*  antiAliasing : System.Int32
		*  enableRandomWrite : System.Boolean
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRT_];
		public final function getTemporaryRT_(nameID:int,width:int,height:int,depthBuffer:int,filter:unityengine.FilterMode,format:unityengine.RenderTextureFormat,readWrite:unityengine.RenderTextureReadWrite,antiAliasing:int,enableRandomWrite:Boolean):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRT
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  depthBuffer : System.Int32
		*  filter : UnityEngine.FilterMode
		*  format : UnityEngine.RenderTextureFormat
		*  readWrite : UnityEngine.RenderTextureReadWrite
		*  antiAliasing : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRT__];
		public final function getTemporaryRT__(nameID:int,width:int,height:int,depthBuffer:int,filter:unityengine.FilterMode,format:unityengine.RenderTextureFormat,readWrite:unityengine.RenderTextureReadWrite,antiAliasing:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRT
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  depthBuffer : System.Int32
		*  filter : UnityEngine.FilterMode
		*  format : UnityEngine.RenderTextureFormat
		*  readWrite : UnityEngine.RenderTextureReadWrite
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRT___];
		public final function getTemporaryRT___(nameID:int,width:int,height:int,depthBuffer:int,filter:unityengine.FilterMode,format:unityengine.RenderTextureFormat,readWrite:unityengine.RenderTextureReadWrite):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRT
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  depthBuffer : System.Int32
		*  filter : UnityEngine.FilterMode
		*  format : UnityEngine.RenderTextureFormat
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRT____];
		public final function getTemporaryRT____(nameID:int,width:int,height:int,depthBuffer:int,filter:unityengine.FilterMode,format:unityengine.RenderTextureFormat):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRT
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  depthBuffer : System.Int32
		*  filter : UnityEngine.FilterMode
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRT_____];
		public final function getTemporaryRT_____(nameID:int,width:int,height:int,depthBuffer:int,filter:unityengine.FilterMode):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRT
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  depthBuffer : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRT______];
		public final function getTemporaryRT______(nameID:int,width:int,height:int,depthBuffer:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRT
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRT_______];
		public final function getTemporaryRT_______(nameID:int,width:int,height:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRT
		*parameters:
		*  nameID : System.Int32
		*  desc : UnityEngine.RenderTextureDescriptor
		*  filter : UnityEngine.FilterMode
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRT________];
		public final function getTemporaryRT________(nameID:int,desc:unityengine.RenderTextureDescriptor,filter:unityengine.FilterMode):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRT
		*parameters:
		*  nameID : System.Int32
		*  desc : UnityEngine.RenderTextureDescriptor
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRT_________];
		public final function getTemporaryRT_________(nameID:int,desc:unityengine.RenderTextureDescriptor):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRTArray
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  slices : System.Int32
		*  depthBuffer : System.Int32
		*  filter : UnityEngine.FilterMode
		*  format : UnityEngine.RenderTextureFormat
		*  readWrite : UnityEngine.RenderTextureReadWrite
		*  antiAliasing : System.Int32
		*  enableRandomWrite : System.Boolean
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRTArray];
		public final function getTemporaryRTArray(nameID:int,width:int,height:int,slices:int,depthBuffer:int,filter:unityengine.FilterMode,format:unityengine.RenderTextureFormat,readWrite:unityengine.RenderTextureReadWrite,antiAliasing:int,enableRandomWrite:Boolean):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRTArray
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  slices : System.Int32
		*  depthBuffer : System.Int32
		*  filter : UnityEngine.FilterMode
		*  format : UnityEngine.RenderTextureFormat
		*  readWrite : UnityEngine.RenderTextureReadWrite
		*  antiAliasing : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRTArray_];
		public final function getTemporaryRTArray_(nameID:int,width:int,height:int,slices:int,depthBuffer:int,filter:unityengine.FilterMode,format:unityengine.RenderTextureFormat,readWrite:unityengine.RenderTextureReadWrite,antiAliasing:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRTArray
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  slices : System.Int32
		*  depthBuffer : System.Int32
		*  filter : UnityEngine.FilterMode
		*  format : UnityEngine.RenderTextureFormat
		*  readWrite : UnityEngine.RenderTextureReadWrite
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRTArray__];
		public final function getTemporaryRTArray__(nameID:int,width:int,height:int,slices:int,depthBuffer:int,filter:unityengine.FilterMode,format:unityengine.RenderTextureFormat,readWrite:unityengine.RenderTextureReadWrite):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRTArray
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  slices : System.Int32
		*  depthBuffer : System.Int32
		*  filter : UnityEngine.FilterMode
		*  format : UnityEngine.RenderTextureFormat
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRTArray___];
		public final function getTemporaryRTArray___(nameID:int,width:int,height:int,slices:int,depthBuffer:int,filter:unityengine.FilterMode,format:unityengine.RenderTextureFormat):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRTArray
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  slices : System.Int32
		*  depthBuffer : System.Int32
		*  filter : UnityEngine.FilterMode
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRTArray____];
		public final function getTemporaryRTArray____(nameID:int,width:int,height:int,slices:int,depthBuffer:int,filter:unityengine.FilterMode):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRTArray
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  slices : System.Int32
		*  depthBuffer : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRTArray_____];
		public final function getTemporaryRTArray_____(nameID:int,width:int,height:int,slices:int,depthBuffer:int):void;

		/**
		* UnityEngine.Rendering.CommandBuffer.GetTemporaryRTArray
		*parameters:
		*  nameID : System.Int32
		*  width : System.Int32
		*  height : System.Int32
		*  slices : System.Int32
		*/
		[native,unityengine_rendering_CommandBuffer_getTemporaryRTArray______];
		public final function getTemporaryRTArray______(nameID:int,width:int,height:int,slices:int):void;


	}
}
