package unityengine.rendering
{
	import unityengine.UObject;
	import unityengine.Shader;
	import unityengine.TransparencySortMode;
	import unityengine.Vector3;


		/**
		* Sealed
		*  UnityEngine.Rendering.GraphicsSettings
		*/
	[link_system]
	public final class GraphicsSettings extends unityengine.UObject
	{
		[creator];
		[native,unityengine_rendering_GraphicsSettings_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_rendering_GraphicsSettings_ctor];
		public function GraphicsSettings();


		//*********公共方法*******
		/**
		* UnityEngine.Rendering.GraphicsSettings.SetShaderMode
		*parameters:
		*  type : UnityEngine.Rendering.BuiltinShaderType
		*  mode : UnityEngine.Rendering.BuiltinShaderMode
		*/
		[native,static_unityengine_rendering_GraphicsSettings_setShaderMode];
		public static function setShaderMode(type:BuiltinShaderType,mode:BuiltinShaderMode):void;

		/**
		* UnityEngine.Rendering.GraphicsSettings.GetShaderMode
		*parameters:
		*  type : UnityEngine.Rendering.BuiltinShaderType
		*return:
		*   UnityEngine.Rendering.BuiltinShaderMode
		*/
		[native,static_unityengine_rendering_GraphicsSettings_getShaderMode];
		public static function getShaderMode(type:BuiltinShaderType):BuiltinShaderMode;

		/**
		* UnityEngine.Rendering.GraphicsSettings.SetCustomShader
		*parameters:
		*  type : UnityEngine.Rendering.BuiltinShaderType
		*  shader : UnityEngine.Shader
		*/
		[native,static_unityengine_rendering_GraphicsSettings_setCustomShader];
		public static function setCustomShader(type:BuiltinShaderType,shader:unityengine.Shader):void;

		/**
		* UnityEngine.Rendering.GraphicsSettings.GetCustomShader
		*parameters:
		*  type : UnityEngine.Rendering.BuiltinShaderType
		*return:
		*   UnityEngine.Shader
		*/
		[native,static_unityengine_rendering_GraphicsSettings_getCustomShader];
		public static function getCustomShader(type:BuiltinShaderType):unityengine.Shader;

		/**
		* UnityEngine.Rendering.GraphicsSettings.get_transparencySortMode
		*return:
		*   UnityEngine.TransparencySortMode
		*/
		[native,static_unityengine_rendering_GraphicsSettings_get_transparencySortMode]
		public static function get transparencySortMode():unityengine.TransparencySortMode;

		/**
		* UnityEngine.Rendering.GraphicsSettings.set_transparencySortMode
		*parameters:
		*  value : UnityEngine.TransparencySortMode
		*/
		[native,static_unityengine_rendering_GraphicsSettings_set_transparencySortMode]
		public static function set transparencySortMode(value:unityengine.TransparencySortMode):void;

		/**
		* UnityEngine.Rendering.GraphicsSettings.get_transparencySortAxis
		*return:
		*   UnityEngine.Vector3
		*/
		[native,static_unityengine_rendering_GraphicsSettings_get_transparencySortAxis]
		public static function get transparencySortAxis():unityengine.Vector3;

		/**
		* UnityEngine.Rendering.GraphicsSettings.set_transparencySortAxis
		*parameters:
		*  value : UnityEngine.Vector3
		*/
		[native,static_unityengine_rendering_GraphicsSettings_set_transparencySortAxis]
		public static function set transparencySortAxis(value:unityengine.Vector3):void;

		/**
		* UnityEngine.Rendering.GraphicsSettings.get_lightsUseLinearIntensity
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_rendering_GraphicsSettings_get_lightsUseLinearIntensity]
		public static function get lightsUseLinearIntensity():Boolean;

		/**
		* UnityEngine.Rendering.GraphicsSettings.set_lightsUseLinearIntensity
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_rendering_GraphicsSettings_set_lightsUseLinearIntensity]
		public static function set lightsUseLinearIntensity(value:Boolean):void;

		/**
		* UnityEngine.Rendering.GraphicsSettings.get_lightsUseColorTemperature
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_rendering_GraphicsSettings_get_lightsUseColorTemperature]
		public static function get lightsUseColorTemperature():Boolean;

		/**
		* UnityEngine.Rendering.GraphicsSettings.set_lightsUseColorTemperature
		*parameters:
		*  value : System.Boolean
		*/
		[native,static_unityengine_rendering_GraphicsSettings_set_lightsUseColorTemperature]
		public static function set lightsUseColorTemperature(value:Boolean):void;

		/**
		* UnityEngine.Rendering.GraphicsSettings.HasShaderDefine
		*parameters:
		*  tier : UnityEngine.Rendering.GraphicsTier
		*  defineHash : UnityEngine.Rendering.BuiltinShaderDefine
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_rendering_GraphicsSettings_hasShaderDefine];
		public static function hasShaderDefine(tier:GraphicsTier,defineHash:BuiltinShaderDefine):Boolean;

		/**
		* UnityEngine.Rendering.GraphicsSettings.HasShaderDefine
		*parameters:
		*  defineHash : UnityEngine.Rendering.BuiltinShaderDefine
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_rendering_GraphicsSettings_hasShaderDefine_];
		public static function hasShaderDefine_(defineHash:BuiltinShaderDefine):Boolean;


	}
}
