package unityengine.scenemanagement
{
	import system._Object_;
	import unityengine.AsyncOperation;
	import unityengine.GameObject;
	import unityengine.events.UnityAction_Of_Scene_LoadSceneMode;
	import unityengine.events.UnityAction_Of_Scene;
	import unityengine.events.UnityAction_Of_Scene_Scene;


		/**
		*  UnityEngine.SceneManagement.SceneManager
		*/
	[link_system]
	public class SceneManager extends system._Object_
	{
		[creator];
		[native,unityengine_scenemanagement_SceneManager_creator];
		private static function _creator(type:Class):*;

		//*********构造函数*******
		[native,unityengine_scenemanagement_SceneManager_ctor];
		public function SceneManager();

		//*********跨语言继承适配器*******
		[crossextendadapter];
		[native,_unityengine_scenemanagement_SceneManagerAdapter_ctor];
		private function _SceneManagerAdapter();


		//*********公共方法*******
		/**
		* UnityEngine.SceneManagement.SceneManager.get_sceneCount
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_scenemanagement_SceneManager_get_sceneCount]
		public static function get sceneCount():int;

		/**
		* UnityEngine.SceneManagement.SceneManager.get_sceneCountInBuildSettings
		*return:
		*   System.Int32
		*/
		[native,static_unityengine_scenemanagement_SceneManager_get_sceneCountInBuildSettings]
		public static function get sceneCountInBuildSettings():int;

		/**
		* UnityEngine.SceneManagement.SceneManager.GetActiveScene
		*return:
		*   UnityEngine.SceneManagement.Scene
		*/
		[native,static_unityengine_scenemanagement_SceneManager_getActiveScene];
		public static function getActiveScene():Scene;

		/**
		* UnityEngine.SceneManagement.SceneManager.SetActiveScene
		*parameters:
		*  scene : UnityEngine.SceneManagement.Scene
		*return:
		*   System.Boolean
		*/
		[native,static_unityengine_scenemanagement_SceneManager_setActiveScene];
		public static function setActiveScene(scene:Scene):Boolean;

		/**
		* UnityEngine.SceneManagement.SceneManager.GetSceneByPath
		*parameters:
		*  scenePath : System.String
		*return:
		*   UnityEngine.SceneManagement.Scene
		*/
		[native,static_unityengine_scenemanagement_SceneManager_getSceneByPath];
		public static function getSceneByPath(scenePath:String):Scene;

		/**
		* UnityEngine.SceneManagement.SceneManager.GetSceneByName
		*parameters:
		*  name : System.String
		*return:
		*   UnityEngine.SceneManagement.Scene
		*/
		[native,static_unityengine_scenemanagement_SceneManager_getSceneByName];
		public static function getSceneByName(name:String):Scene;

		/**
		* UnityEngine.SceneManagement.SceneManager.GetSceneByBuildIndex
		*parameters:
		*  buildIndex : System.Int32
		*return:
		*   UnityEngine.SceneManagement.Scene
		*/
		[native,static_unityengine_scenemanagement_SceneManager_getSceneByBuildIndex];
		public static function getSceneByBuildIndex(buildIndex:int):Scene;

		/**
		* UnityEngine.SceneManagement.SceneManager.GetSceneAt
		*parameters:
		*  index : System.Int32
		*return:
		*   UnityEngine.SceneManagement.Scene
		*/
		[native,static_unityengine_scenemanagement_SceneManager_getSceneAt];
		public static function getSceneAt(index:int):Scene;

		/**
		* UnityEngine.SceneManagement.SceneManager.LoadScene
		*parameters:
		*  sceneName : System.String
		*/
		[native,static_unityengine_scenemanagement_SceneManager_loadScene];
		public static function loadScene(sceneName:String):void;

		/**
		* UnityEngine.SceneManagement.SceneManager.LoadScene
		*parameters:
		*  sceneName : System.String
		*  mode : UnityEngine.SceneManagement.LoadSceneMode
		*/
		[native,static_unityengine_scenemanagement_SceneManager_loadScene_];
		public static function loadScene_(sceneName:String,mode:LoadSceneMode):void;

		/**
		* UnityEngine.SceneManagement.SceneManager.LoadScene
		*parameters:
		*  sceneBuildIndex : System.Int32
		*/
		[native,static_unityengine_scenemanagement_SceneManager_loadScene__];
		public static function loadScene__(sceneBuildIndex:int):void;

		/**
		* UnityEngine.SceneManagement.SceneManager.LoadScene
		*parameters:
		*  sceneBuildIndex : System.Int32
		*  mode : UnityEngine.SceneManagement.LoadSceneMode
		*/
		[native,static_unityengine_scenemanagement_SceneManager_loadScene___];
		public static function loadScene___(sceneBuildIndex:int,mode:LoadSceneMode):void;

		/**
		* UnityEngine.SceneManagement.SceneManager.LoadSceneAsync
		*parameters:
		*  sceneName : System.String
		*return:
		*   UnityEngine.AsyncOperation
		*/
		[native,static_unityengine_scenemanagement_SceneManager_loadSceneAsync];
		public static function loadSceneAsync(sceneName:String):unityengine.AsyncOperation;

		/**
		* UnityEngine.SceneManagement.SceneManager.LoadSceneAsync
		*parameters:
		*  sceneName : System.String
		*  mode : UnityEngine.SceneManagement.LoadSceneMode
		*return:
		*   UnityEngine.AsyncOperation
		*/
		[native,static_unityengine_scenemanagement_SceneManager_loadSceneAsync_];
		public static function loadSceneAsync_(sceneName:String,mode:LoadSceneMode):unityengine.AsyncOperation;

		/**
		* UnityEngine.SceneManagement.SceneManager.LoadSceneAsync
		*parameters:
		*  sceneBuildIndex : System.Int32
		*return:
		*   UnityEngine.AsyncOperation
		*/
		[native,static_unityengine_scenemanagement_SceneManager_loadSceneAsync__];
		public static function loadSceneAsync__(sceneBuildIndex:int):unityengine.AsyncOperation;

		/**
		* UnityEngine.SceneManagement.SceneManager.LoadSceneAsync
		*parameters:
		*  sceneBuildIndex : System.Int32
		*  mode : UnityEngine.SceneManagement.LoadSceneMode
		*return:
		*   UnityEngine.AsyncOperation
		*/
		[native,static_unityengine_scenemanagement_SceneManager_loadSceneAsync___];
		public static function loadSceneAsync___(sceneBuildIndex:int,mode:LoadSceneMode):unityengine.AsyncOperation;

		/**
		* UnityEngine.SceneManagement.SceneManager.CreateScene
		*parameters:
		*  sceneName : System.String
		*return:
		*   UnityEngine.SceneManagement.Scene
		*/
		[native,static_unityengine_scenemanagement_SceneManager_createScene];
		public static function createScene(sceneName:String):Scene;

		/**
		* UnityEngine.SceneManagement.SceneManager.UnloadSceneAsync
		*parameters:
		*  sceneBuildIndex : System.Int32
		*return:
		*   UnityEngine.AsyncOperation
		*/
		[native,static_unityengine_scenemanagement_SceneManager_unloadSceneAsync];
		public static function unloadSceneAsync(sceneBuildIndex:int):unityengine.AsyncOperation;

		/**
		* UnityEngine.SceneManagement.SceneManager.UnloadSceneAsync
		*parameters:
		*  sceneName : System.String
		*return:
		*   UnityEngine.AsyncOperation
		*/
		[native,static_unityengine_scenemanagement_SceneManager_unloadSceneAsync_];
		public static function unloadSceneAsync_(sceneName:String):unityengine.AsyncOperation;

		/**
		* UnityEngine.SceneManagement.SceneManager.UnloadSceneAsync
		*parameters:
		*  scene : UnityEngine.SceneManagement.Scene
		*return:
		*   UnityEngine.AsyncOperation
		*/
		[native,static_unityengine_scenemanagement_SceneManager_unloadSceneAsync__];
		public static function unloadSceneAsync__(scene:Scene):unityengine.AsyncOperation;

		/**
		* UnityEngine.SceneManagement.SceneManager.MergeScenes
		*parameters:
		*  sourceScene : UnityEngine.SceneManagement.Scene
		*  destinationScene : UnityEngine.SceneManagement.Scene
		*/
		[native,static_unityengine_scenemanagement_SceneManager_mergeScenes];
		public static function mergeScenes(sourceScene:Scene,destinationScene:Scene):void;

		/**
		* UnityEngine.SceneManagement.SceneManager.MoveGameObjectToScene
		*parameters:
		*  go : UnityEngine.GameObject
		*  scene : UnityEngine.SceneManagement.Scene
		*/
		[native,static_unityengine_scenemanagement_SceneManager_moveGameObjectToScene];
		public static function moveGameObjectToScene(go:unityengine.GameObject,scene:Scene):void;

		/**
		* UnityEngine.SceneManagement.SceneManager.add_sceneLoaded
		*parameters:
		*  value : UnityEngine.Events.UnityAction &lt; UnityEngine.SceneManagement.Scene,UnityEngine.SceneManagement.LoadSceneMode &gt;  [System.Void(UnityEngine.SceneManagement.Scene,UnityEngine.SceneManagement.LoadSceneMode)]
		*/
		[native,static_unityengine_scenemanagement_SceneManager_sceneLoaded_addEventListener];
		public static function sceneLoaded_addEventListener(value:unityengine.events.UnityAction_Of_Scene_LoadSceneMode):void;

		/**
		* UnityEngine.SceneManagement.SceneManager.remove_sceneLoaded
		*parameters:
		*  value : UnityEngine.Events.UnityAction &lt; UnityEngine.SceneManagement.Scene,UnityEngine.SceneManagement.LoadSceneMode &gt;  [System.Void(UnityEngine.SceneManagement.Scene,UnityEngine.SceneManagement.LoadSceneMode)]
		*/
		[native,static_unityengine_scenemanagement_SceneManager_sceneLoaded_removeEventListener];
		public static function sceneLoaded_removeEventListener(value:unityengine.events.UnityAction_Of_Scene_LoadSceneMode):void;

		/**
		* UnityEngine.SceneManagement.SceneManager.add_sceneUnloaded
		*parameters:
		*  value : UnityEngine.Events.UnityAction &lt; UnityEngine.SceneManagement.Scene &gt;  [System.Void(UnityEngine.SceneManagement.Scene)]
		*/
		[native,static_unityengine_scenemanagement_SceneManager_sceneUnloaded_addEventListener];
		public static function sceneUnloaded_addEventListener(value:unityengine.events.UnityAction_Of_Scene):void;

		/**
		* UnityEngine.SceneManagement.SceneManager.remove_sceneUnloaded
		*parameters:
		*  value : UnityEngine.Events.UnityAction &lt; UnityEngine.SceneManagement.Scene &gt;  [System.Void(UnityEngine.SceneManagement.Scene)]
		*/
		[native,static_unityengine_scenemanagement_SceneManager_sceneUnloaded_removeEventListener];
		public static function sceneUnloaded_removeEventListener(value:unityengine.events.UnityAction_Of_Scene):void;

		/**
		* UnityEngine.SceneManagement.SceneManager.add_activeSceneChanged
		*parameters:
		*  value : UnityEngine.Events.UnityAction &lt; UnityEngine.SceneManagement.Scene,UnityEngine.SceneManagement.Scene &gt;  [System.Void(UnityEngine.SceneManagement.Scene,UnityEngine.SceneManagement.Scene)]
		*/
		[native,static_unityengine_scenemanagement_SceneManager_activeSceneChanged_addEventListener];
		public static function activeSceneChanged_addEventListener(value:unityengine.events.UnityAction_Of_Scene_Scene):void;

		/**
		* UnityEngine.SceneManagement.SceneManager.remove_activeSceneChanged
		*parameters:
		*  value : UnityEngine.Events.UnityAction &lt; UnityEngine.SceneManagement.Scene,UnityEngine.SceneManagement.Scene &gt;  [System.Void(UnityEngine.SceneManagement.Scene,UnityEngine.SceneManagement.Scene)]
		*/
		[native,static_unityengine_scenemanagement_SceneManager_activeSceneChanged_removeEventListener];
		public static function activeSceneChanged_removeEventListener(value:unityengine.events.UnityAction_Of_Scene_Scene):void;


	}
}
