package unityengine.ui
{
	import unityengine.eventsystems.UIBehaviour;
	import unityengine.Material;
	import unityengine.Color;
	import unityengine.RectTransform;
	import unityengine.Canvas;
	import unityengine.Texture;
	import unityengine.Vector2;
	import unityengine.Camera;
	import unityengine.Rect;
	import unityengine.events.UnityAction;
	import unityengine.Transform;


		/**
		* Abstract
		*  UnityEngine.UI.Graphic
		*/
	[no_constructor]
	[link_system]
	public class Graphic extends unityengine.eventsystems.UIBehaviour implements ICanvasElement
	{
		[creator];
		[native,unityengine_ui_Graphic_creator];
		private static function _creator(type:Class):*;
		[native,$$_noctorclass];
		public function Graphic();
		//*********公共方法*******
		/**
		* UnityEngine.UI.Graphic.get_defaultGraphicMaterial
		*return:
		*   UnityEngine.Material
		*/
		[native,static_unityengine_ui_Graphic_get_defaultGraphicMaterial]
		public static function get defaultGraphicMaterial():unityengine.Material;

		/**
		* UnityEngine.UI.Graphic.get_color
		*return:
		*   UnityEngine.Color
		*/
		[native,unityengine_ui_Graphic_get_color]
		public function get color():unityengine.Color;

		/**
		* UnityEngine.UI.Graphic.set_color
		*parameters:
		*  value : UnityEngine.Color
		*/
		[native,unityengine_ui_Graphic_set_color]
		public function set color(value:unityengine.Color):void;

		/**
		* UnityEngine.UI.Graphic.get_raycastTarget
		*return:
		*   System.Boolean
		*/
		[native,unityengine_ui_Graphic_get_raycastTarget]
		public function get raycastTarget():Boolean;

		/**
		* UnityEngine.UI.Graphic.set_raycastTarget
		*parameters:
		*  value : System.Boolean
		*/
		[native,unityengine_ui_Graphic_set_raycastTarget]
		public function set raycastTarget(value:Boolean):void;

		/**
		* UnityEngine.UI.Graphic.SetAllDirty
		*/
		[native,unityengine_ui_Graphic_setAllDirty];
		public function setAllDirty():void;

		/**
		* UnityEngine.UI.Graphic.SetLayoutDirty
		*/
		[native,unityengine_ui_Graphic_setLayoutDirty];
		public function setLayoutDirty():void;

		/**
		* UnityEngine.UI.Graphic.SetVerticesDirty
		*/
		[native,unityengine_ui_Graphic_setVerticesDirty];
		public function setVerticesDirty():void;

		/**
		* UnityEngine.UI.Graphic.SetMaterialDirty
		*/
		[native,unityengine_ui_Graphic_setMaterialDirty];
		public function setMaterialDirty():void;

		/**
		* UnityEngine.UI.Graphic.get_depth
		*return:
		*   System.Int32
		*/
		[native,unityengine_ui_Graphic_get_depth]
		public final function get depth():int;

		/**
		* UnityEngine.UI.Graphic.get_rectTransform
		*return:
		*   UnityEngine.RectTransform
		*/
		[native,unityengine_ui_Graphic_get_rectTransform]
		public final function get rectTransform():unityengine.RectTransform;

		/**
		* UnityEngine.UI.Graphic.get_canvas
		*return:
		*   UnityEngine.Canvas
		*/
		[native,unityengine_ui_Graphic_get_canvas]
		public final function get canvas():unityengine.Canvas;

		/**
		* UnityEngine.UI.Graphic.get_defaultMaterial
		*return:
		*   UnityEngine.Material
		*/
		[native,unityengine_ui_Graphic_get_defaultMaterial]
		public function get defaultMaterial():unityengine.Material;

		/**
		* UnityEngine.UI.Graphic.get_material
		*return:
		*   UnityEngine.Material
		*/
		[native,unityengine_ui_Graphic_get_material]
		public function get material():unityengine.Material;

		/**
		* UnityEngine.UI.Graphic.set_material
		*parameters:
		*  value : UnityEngine.Material
		*/
		[native,unityengine_ui_Graphic_set_material]
		public function set material(value:unityengine.Material):void;

		/**
		* UnityEngine.UI.Graphic.get_materialForRendering
		*return:
		*   UnityEngine.Material
		*/
		[native,unityengine_ui_Graphic_get_materialForRendering]
		public function get materialForRendering():unityengine.Material;

		/**
		* UnityEngine.UI.Graphic.get_mainTexture
		*return:
		*   UnityEngine.Texture
		*/
		[native,unityengine_ui_Graphic_get_mainTexture]
		public function get mainTexture():unityengine.Texture;

		[native,unityengine_ui_ICanvasElement_rebuild];
		public function rebuild(update:CanvasUpdate):void;

		[native,unityengine_ui_ICanvasElement_layoutComplete];
		public function layoutComplete():void;

		[native,unityengine_ui_ICanvasElement_graphicUpdateComplete];
		public function graphicUpdateComplete():void;

		/**
		* UnityEngine.UI.Graphic.SetNativeSize
		*/
		[native,unityengine_ui_Graphic_setNativeSize];
		public function setNativeSize():void;

		/**
		* UnityEngine.UI.Graphic.Raycast
		*parameters:
		*  sp : UnityEngine.Vector2
		*  eventCamera : UnityEngine.Camera
		*return:
		*   System.Boolean
		*/
		[native,unityengine_ui_Graphic_raycast];
		public function raycast(sp:unityengine.Vector2,eventCamera:unityengine.Camera):Boolean;

		/**
		* UnityEngine.UI.Graphic.PixelAdjustPoint
		*parameters:
		*  point : UnityEngine.Vector2
		*return:
		*   UnityEngine.Vector2
		*/
		[native,unityengine_ui_Graphic_pixelAdjustPoint];
		public final function pixelAdjustPoint(point:unityengine.Vector2):unityengine.Vector2;

		/**
		* UnityEngine.UI.Graphic.GetPixelAdjustedRect
		*return:
		*   UnityEngine.Rect
		*/
		[native,unityengine_ui_Graphic_getPixelAdjustedRect];
		public final function getPixelAdjustedRect():unityengine.Rect;

		/**
		* UnityEngine.UI.Graphic.CrossFadeColor
		*parameters:
		*  targetColor : UnityEngine.Color
		*  duration : System.Single
		*  ignoreTimeScale : System.Boolean
		*  useAlpha : System.Boolean
		*/
		[native,unityengine_ui_Graphic_crossFadeColor];
		public function crossFadeColor(targetColor:unityengine.Color,duration:Number,ignoreTimeScale:Boolean,useAlpha:Boolean):void;

		/**
		* UnityEngine.UI.Graphic.CrossFadeColor
		*parameters:
		*  targetColor : UnityEngine.Color
		*  duration : System.Single
		*  ignoreTimeScale : System.Boolean
		*  useAlpha : System.Boolean
		*  useRGB : System.Boolean
		*/
		[native,unityengine_ui_Graphic_crossFadeColor_];
		public function crossFadeColor_(targetColor:unityengine.Color,duration:Number,ignoreTimeScale:Boolean,useAlpha:Boolean,useRGB:Boolean):void;

		/**
		* UnityEngine.UI.Graphic.CrossFadeAlpha
		*parameters:
		*  alpha : System.Single
		*  duration : System.Single
		*  ignoreTimeScale : System.Boolean
		*/
		[native,unityengine_ui_Graphic_crossFadeAlpha];
		public function crossFadeAlpha(alpha:Number,duration:Number,ignoreTimeScale:Boolean):void;

		/**
		* UnityEngine.UI.Graphic.RegisterDirtyLayoutCallback
		*parameters:
		*  action : UnityEngine.Events.UnityAction [System.Void()]
		*/
		[native,unityengine_ui_Graphic_registerDirtyLayoutCallback];
		public final function registerDirtyLayoutCallback(action:unityengine.events.UnityAction):void;

		/**
		* UnityEngine.UI.Graphic.UnregisterDirtyLayoutCallback
		*parameters:
		*  action : UnityEngine.Events.UnityAction [System.Void()]
		*/
		[native,unityengine_ui_Graphic_unregisterDirtyLayoutCallback];
		public final function unregisterDirtyLayoutCallback(action:unityengine.events.UnityAction):void;

		/**
		* UnityEngine.UI.Graphic.RegisterDirtyVerticesCallback
		*parameters:
		*  action : UnityEngine.Events.UnityAction [System.Void()]
		*/
		[native,unityengine_ui_Graphic_registerDirtyVerticesCallback];
		public final function registerDirtyVerticesCallback(action:unityengine.events.UnityAction):void;

		/**
		* UnityEngine.UI.Graphic.UnregisterDirtyVerticesCallback
		*parameters:
		*  action : UnityEngine.Events.UnityAction [System.Void()]
		*/
		[native,unityengine_ui_Graphic_unregisterDirtyVerticesCallback];
		public final function unregisterDirtyVerticesCallback(action:unityengine.events.UnityAction):void;

		/**
		* UnityEngine.UI.Graphic.RegisterDirtyMaterialCallback
		*parameters:
		*  action : UnityEngine.Events.UnityAction [System.Void()]
		*/
		[native,unityengine_ui_Graphic_registerDirtyMaterialCallback];
		public final function registerDirtyMaterialCallback(action:unityengine.events.UnityAction):void;

		/**
		* UnityEngine.UI.Graphic.UnregisterDirtyMaterialCallback
		*parameters:
		*  action : UnityEngine.Events.UnityAction [System.Void()]
		*/
		[native,unityengine_ui_Graphic_unregisterDirtyMaterialCallback];
		public final function unregisterDirtyMaterialCallback(action:unityengine.events.UnityAction):void;


		//*****显式接口实现*****
		[native,unityengine_ui_ICanvasElement_get_transform];
		private function unityengine_ui_ICanvasElement_get_transform():unityengine.Transform;

		[native,unityengine_ui_ICanvasElement_isDestroyed];
		private function unityengine_ui_ICanvasElement_IsDestroyed():Boolean;


	}
}
