package 
{
	import unityengine.GameObject;
	import unityengine.MonoBehaviour;
	import unityengine.Vector3;
	
	/**
	 * ...
	 * @author 
	 */
	public final class CameraController extends MonoBehaviour 
	{
		// store a public reference to the Player game object, so we can refer to it's Transform
		public var player:GameObject;

		// Store a Vector3 offset from the player (a distance to place the camera from the player at all times)
		private var offset:Vector3;
		// At the start of the game..
		private function Start ():void
		{
			
			player = GameObject.find("Player");
			
			// Create an offset by subtracting the Camera's position from the player's position
			offset = transform.position - player.transform.position;
		}

		// After the standard 'Update()' loop runs, and just before each frame is rendered..
		private function LateUpdate ():void
		{
			// Set the position of the Camera (the game object this script is attached to)
			// to the player's position, plus the offset amount
			transform.position = player.transform.position + offset;
		}
	}

}