package 
{
	import unityengine.Collider;
	import unityengine.GameObject;
	import unityengine.Input;
	import unityengine.MonoBehaviour;
	import unityengine.Rigidbody;
	import unityengine.Vector3;
	import unityengine.ui.Text;
	
	/**
	 * ...
	 * @author 
	 */
	public final class PlayerController extends MonoBehaviour 
	{
		// Create public variables for player speed, and for the Text UI game objects
		private var speed:Number;
	    private var countText:Text;
		private var winText:Text;

		// Create private references to the rigidbody component on the player, and the count of pick up objects picked up so far
		private var rb:Rigidbody;
		private var count:int;
		
		private function Start():void
		{
			speed = 10;
			countText = GameObject.find("Count Text").getComponent(Text) as Text;
			winText = GameObject.find("Win Text").getComponent(Text) as Text;
			
			
			rb = getComponent(Rigidbody) as Rigidbody;
			
			SetCountText();
			
			count = 0;
			winText.text = "";
			
		}
		
		private function FixedUpdate():void
		{
			// Set some local float variables equal to the value of our Horizontal and Vertical Inputs
			var moveHorizontal:Number = Input.getAxis("Horizontal");
			var moveVertical:Number = Input.getAxis("Vertical");

			moveHorizontal += Input.acceleration.x ;
			moveVertical += Input.acceleration.y;
			
			// Create a Vector3 variable, and assign X and Z to feature our horizontal and vertical float variables above
			var movement:Vector3 = new Vector3 (moveHorizontal, 0.0, moveVertical);
			// Add a physical force to our Player rigidbody using our 'movement' Vector3 above, 
			// multiplying it by 'speed' - our public player speed that appears in the inspector
			rb.addForce_(movement * speed);
			
		}
		
		private function OnTriggerEnter(other:Collider):void
		{
			// ..and if the game object we intersect has the tag 'Pick Up' assigned to it..
			if (other.gameObject.compareTag("Pick Up"))
			{
				// Make the other game object (the pick up) inactive, to make it disappear
				other.gameObject.setActive (false);
				// Add one to the score variable 'count'
				count = count + 1;
				// Run the 'SetCountText()' function (see below)
				SetCountText();
				
			}
		}
		
		
		
		private function SetCountText()
		{
			// Update the text field of our 'countText' variable
			countText.text = "Count: " + count;

			// Check if our 'count' is equal to or exceeded 12
			if (count >= 12) 
			{
				// Set the text value of our 'winText'
				winText.text = "You Win!";
			}
		}
		
	}

}